//
// Copyright 2020 FoxyUtils ehf. All rights reserved.
//
// This is a commercial product and requires a license to operate.
// A trial license can be obtained at https://unidoc.io
//
// DO NOT EDIT: generated by unitwist Go source code obfuscator.
//
// Use of this source code is governed by the UniDoc End User License Agreement
// terms that can be accessed at https://unidoc.io/eula/

// Package pdfa provides abstraction to optimize and verify documents with respect to the PDF/A standards.
// NOTE: This implementation is in experimental development state.
// 	Keep in mind that it might change in the subsequent minor versions.
package pdfa ;import (_fc "errors";_a "fmt";_fg "github.com/adrg/sysfont";_ba "github.com/trimmer-io/go-xmp/models/dc";_cg "github.com/trimmer-io/go-xmp/models/pdf";_c "github.com/trimmer-io/go-xmp/models/xmp_base";_bg "github.com/trimmer-io/go-xmp/models/xmp_mm";
_eg "github.com/trimmer-io/go-xmp/models/xmp_rights";_afd "github.com/trimmer-io/go-xmp/xmp";_ee "github.com/unidoc/unipdf/v3/common";_bd "github.com/unidoc/unipdf/v3/contentstream";_dd "github.com/unidoc/unipdf/v3/core";_cc "github.com/unidoc/unipdf/v3/internal/cmap";
_d "github.com/unidoc/unipdf/v3/internal/imageutil";_de "github.com/unidoc/unipdf/v3/internal/timeutils";_bf "github.com/unidoc/unipdf/v3/model";_egg "github.com/unidoc/unipdf/v3/model/internal/colorprofile";_dc "github.com/unidoc/unipdf/v3/model/internal/docutil";
_dcb "github.com/unidoc/unipdf/v3/model/internal/fonts";_fce "github.com/unidoc/unipdf/v3/model/xmputil";_ab "github.com/unidoc/unipdf/v3/model/xmputil/pdfaextension";_ec "github.com/unidoc/unipdf/v3/model/xmputil/pdfaid";_b "image/color";_f "math";_ae "sort";
_af "strings";_aa "time";);

// VerificationError is the PDF/A verification error structure, that contains all violated rules.
type VerificationError struct{

// ViolatedRules are the rules that were violated during error verification.
ViolatedRules []ViolatedRule ;

// ConformanceLevel defines the standard on verification failed.
ConformanceLevel int ;

// ConformanceVariant is the standard variant used on verification.
ConformanceVariant string ;};func _fgg (_gae *_bf .PdfPageResources ,_bbb *_bd .ContentStreamOperations ,_baeg bool )([]byte ,error ){var _adca bool ;for _ ,_fggg :=range *_bbb {_dae :switch _fggg .Operand {case "\u0042\u0049":_fgfe ,_faf :=_fggg .Params [0].(*_bd .ContentStreamInlineImage );
if !_faf {break ;};_aea ,_ggb :=_fgfe .GetColorSpace (_gae );if _ggb !=nil {return nil ,_ggb ;};switch _aea .(type ){case *_bf .PdfColorspaceDeviceCMYK :if _baeg {break _dae ;};case *_bf .PdfColorspaceDeviceGray :case *_bf .PdfColorspaceDeviceRGB :if !_baeg {break _dae ;
};default:break _dae ;};_adca =true ;_gaef ,_ggb :=_fgfe .ToImage (_gae );if _ggb !=nil {return nil ,_ggb ;};_dag ,_ggb :=_gaef .ToGoImage ();if _ggb !=nil {return nil ,_ggb ;};if _baeg {_dag ,_ggb =_d .CMYKConverter .Convert (_dag );}else {_dag ,_ggb =_d .NRGBAConverter .Convert (_dag );
};if _ggb !=nil {return nil ,_ggb ;};_ecgfa ,_faf :=_dag .(_d .Image );if !_faf {return nil ,_fc .New ("\u0069\u006d\u0061\u0067\u0065\u0020\u0064\u006f\u0065\u0073\u006e\u0027\u0074 \u0069\u006d\u0070\u006c\u0065\u006de\u006e\u0074\u0020\u0069\u006d\u0061\u0067\u0065\u0075\u0074\u0069\u006c\u002eI\u006d\u0061\u0067\u0065");
};_bfg :=_ecgfa .Base ();_dcbb :=_bf .Image {Width :int64 (_bfg .Width ),Height :int64 (_bfg .Height ),BitsPerComponent :int64 (_bfg .BitsPerComponent ),ColorComponents :_bfg .ColorComponents ,Data :_bfg .Data };_dcbb .SetDecode (_bfg .Decode );_dcbb .SetAlpha (_bfg .Alpha );
_cab ,_ggb :=_fgfe .GetEncoder ();if _ggb !=nil {_cab =_dd .NewFlateEncoder ();};_dggd ,_ggb :=_bd .NewInlineImageFromImage (_dcbb ,_cab );if _ggb !=nil {return nil ,_ggb ;};_fggg .Params [0]=_dggd ;case "\u0047","\u0067":if len (_fggg .Params )!=1{break ;
};_eaef ,_aceg :=_dd .GetNumberAsFloat (_fggg .Params [0]);if _aceg !=nil {break ;};if _baeg {_fggg .Params =[]_dd .PdfObject {_dd .MakeFloat (0),_dd .MakeFloat (0),_dd .MakeFloat (0),_dd .MakeFloat (1-_eaef )};_daeg :="\u004b";if _fggg .Operand =="\u0067"{_daeg ="\u006b";
};_fggg .Operand =_daeg ;}else {_fggg .Params =[]_dd .PdfObject {_dd .MakeFloat (_eaef ),_dd .MakeFloat (_eaef ),_dd .MakeFloat (_eaef )};_eaa :="\u0052\u0047";if _fggg .Operand =="\u0067"{_eaa ="\u0072\u0067";};_fggg .Operand =_eaa ;};_adca =true ;case "\u0052\u0047","\u0072\u0067":if !_baeg {break ;
};if len (_fggg .Params )!=3{break ;};_baga ,_dcdf :=_dd .GetNumbersAsFloat (_fggg .Params );if _dcdf !=nil {break ;};_adca =true ;_dffc ,_bde ,_daff :=_baga [0],_baga [1],_baga [2];_abf ,_ecc ,_aada ,_cgce :=_b .RGBToCMYK (uint8 (_dffc *255),uint8 (_bde *255),uint8 (255*_daff ));
_fggg .Params =[]_dd .PdfObject {_dd .MakeFloat (float64 (_abf )/255),_dd .MakeFloat (float64 (_ecc )/255),_dd .MakeFloat (float64 (_aada )/255),_dd .MakeFloat (float64 (_cgce )/255)};_cdeb :="\u004b";if _fggg .Operand =="\u0072\u0067"{_cdeb ="\u006b";
};_fggg .Operand =_cdeb ;case "\u004b","\u006b":if _baeg {break ;};if len (_fggg .Params )!=4{break ;};_dbac ,_gab :=_dd .GetNumbersAsFloat (_fggg .Params );if _gab !=nil {break ;};_cfeb ,_abaf ,_afgc ,_bee :=_dbac [0],_dbac [1],_dbac [2],_dbac [3];_gba ,_gaff ,_fabf :=_b .CMYKToRGB (uint8 (255*_cfeb ),uint8 (255*_abaf ),uint8 (255*_afgc ),uint8 (255*_bee ));
_fggg .Params =[]_dd .PdfObject {_dd .MakeFloat (float64 (_gba )/255),_dd .MakeFloat (float64 (_gaff )/255),_dd .MakeFloat (float64 (_fabf )/255)};_adag :="\u0052\u0047";if _fggg .Operand =="\u006b"{_adag ="\u0072\u0067";};_fggg .Operand =_adag ;_adca =true ;
};};if !_adca {return nil ,nil ;};_beg :=_bd .NewContentCreator ();for _ ,_fda :=range *_bbb {_beg .AddOperand (*_fda );};_cfge :=_beg .Bytes ();return _cfge ,nil ;};func _fd (_afde *_bf .XObjectImage ,_fbg imageModifications )error {_ecd ,_eff :=_afde .ToImage ();
if _eff !=nil {return _eff ;};if _fbg ._gda !=nil {_afde .Filter =_fbg ._gda ;};_fbb :=_dd .MakeDict ();_fbb .Set ("\u0051u\u0061\u006c\u0069\u0074\u0079",_dd .MakeInteger (100));_fbb .Set ("\u0050r\u0065\u0064\u0069\u0063\u0074\u006fr",_dd .MakeInteger (1));
_afde .Decode =nil ;if _eff =_afde .SetImage (_ecd ,nil );_eff !=nil {return _eff ;};_afde .ToPdfObject ();return nil ;};func (_bcd *documentImages )hasOnlyDeviceGray ()bool {return _bcd ._gf &&!_bcd ._bae &&!_bcd ._cgg };func _ffeb (_ccbcc *_bf .CompliancePdfReader )(_efba []ViolatedRule ){if _ccbcc .ParserMetadata ().HasOddLengthHexStrings (){_efba =append (_efba ,_cgc ("\u0036.\u0031\u002e\u0036\u002d\u0031","\u0068\u0065\u0078a\u0064\u0065\u0063\u0069\u006d\u0061\u006c\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0073\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u0062\u0065\u0020\u006f\u0066\u0020e\u0076\u0065\u006e\u0020\u0073\u0069\u007a\u0065"));
};if _ccbcc .ParserMetadata ().HasOddLengthHexStrings (){_efba =append (_efba ,_cgc ("\u0036.\u0031\u002e\u0036\u002d\u0032","\u0068\u0065\u0078\u0061\u0064\u0065\u0063\u0069\u006da\u006c\u0020s\u0074\u0072\u0069\u006e\u0067\u0073\u0020\u0073\u0068o\u0075\u006c\u0064\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u006f\u006e\u006c\u0079\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0073\u0020\u0066\u0072\u006f\u006d\u0020\u0072\u0061n\u0067\u0065\u0020[\u0030\u002d\u0039\u003b\u0041\u002d\u0046\u003b\u0061\u002d\u0066\u005d"));
};return _efba ;};func _afdg (_aacdc *_bf .CompliancePdfReader )(_ecba ViolatedRule ){for _ ,_egdf :=range _aacdc .GetObjectNums (){_bfcg ,_cgdeb :=_aacdc .GetIndirectObjectByNumber (_egdf );if _cgdeb !=nil {continue ;};_cdbe ,_ffc :=_dd .GetStream (_bfcg );
if !_ffc {continue ;};_dec ,_ffc :=_dd .GetName (_cdbe .Get ("\u0054\u0079\u0070\u0065"));if !_ffc {continue ;};if *_dec !="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;};_deae ,_ffc :=_dd .GetName (_cdbe .Get ("\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032"));
if !_ffc {continue ;};if *_deae =="\u0050\u0053"{return _cgc ("\u0036.\u0032\u002e\u0035\u002d\u0031","A\u0020\u0066\u006fr\u006d\u0020\u0058\u004f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006ft\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e \u0074\u0068\u0065\u0020\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032\u0020\u006b\u0065\u0079 \u0077\u0069\u0074\u0068\u0020a\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0050\u0053\u0020o\u0072\u0020\u0074\u0068e\u0020\u0050\u0053\u0020\u006b\u0065\u0079\u002e");
};if _cdbe .Get ("\u0050\u0053")!=nil {return _cgc ("\u0036.\u0032\u002e\u0035\u002d\u0031","A\u0020\u0066\u006fr\u006d\u0020\u0058\u004f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006ft\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e \u0074\u0068\u0065\u0020\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032\u0020\u006b\u0065\u0079 \u0077\u0069\u0074\u0068\u0020a\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0050\u0053\u0020o\u0072\u0020\u0074\u0068e\u0020\u0050\u0053\u0020\u006b\u0065\u0079\u002e");
};};return _ecba ;};type profile1 struct{_gbff standardType ;_dgba Profile1Options ;};func (_db standardType )String ()string {return _a .Sprintf ("\u0050\u0044\u0046\u002f\u0041\u002d\u0025\u0064\u0025\u0073",_db ._ecg ,_db ._bc );};func _edd (_cgcd standardType ,_acaf *_dc .OutputIntents )error {_fada ,_ffab :=_egg .NewCmykIsoCoatedV2OutputIntent (_cgcd .outputIntentSubtype ());
if _ffab !=nil {return _ffab ;};if _ffab =_acaf .Add (_fada .ToPdfObject ());_ffab !=nil {return _ffab ;};return nil ;};

// NewProfile1B creates a new Profile1B with the given options.
func NewProfile1B (options *Profile1Options )*Profile1B {if options ==nil {options =DefaultProfile1Options ();};_edffc (options );return &Profile1B {profile1 {_dgba :*options ,_gbff :_cd ()}};};func _dcg ()standardType {return standardType {_ecg :2,_bc :"\u0041"}};
func _dde ()standardType {return standardType {_ecg :1,_bc :"\u0041"}};func _gggfd (_bdgf *_bf .CompliancePdfReader )[]ViolatedRule {return nil };func _adefd (_cbg *_dd .PdfObjectDictionary ,_bfda map[*_dd .PdfObjectStream ][]byte ,_eacb map[*_dd .PdfObjectStream ]*_cc .CMap )ViolatedRule {const (_aaeaa ="\u0036.\u0033\u002e\u0033\u002d\u0033";
_ggbc ="\u0041\u006cl \u0043\u004d\u0061\u0070\u0073\u0020\u0075\u0073e\u0064 \u0077i\u0074\u0068\u0069\u006e\u0020\u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072m\u0069n\u0067\u0020\u0066\u0069\u006c\u0065\u002c\u0020\u0065\u0078\u0063\u0065\u0070\u0074\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048\u0020a\u006e\u0064\u0020\u0049\u0064\u0065\u006et\u0069\u0074\u0079-\u0056\u002c\u0020\u0073\u0068a\u006c\u006c \u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0020\u0069\u006e\u0020\u0074h\u0061\u0074\u0020\u0066\u0069\u006c\u0065\u0020\u0061\u0073\u0020\u0064es\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044F\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u00205\u002e\u0036\u002e\u0034\u002e";
);var _dbc string ;if _aebc ,_baad :=_dd .GetName (_cbg .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_baad {_dbc =_aebc .String ();};if _dbc !="\u0054\u0079\u0070e\u0030"{return _cf ;};_bfcd :=_cbg .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067");
if _dfdc ,_ffcg :=_dd .GetName (_bfcd );_ffcg {switch _dfdc .String (){case "\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048","\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0056":return _cf ;default:return _cgc (_aaeaa ,_ggbc );};
};_gdgc ,_dcca :=_dd .GetStream (_bfcd );if !_dcca {return _cgc (_aaeaa ,_ggbc );};_ ,_fba :=_daadb (_gdgc ,_bfda ,_eacb );if _fba !=nil {return _cgc (_aaeaa ,_ggbc );};return _cf ;};func _dfaf (_eeea *_bf .CompliancePdfReader ,_eaeef bool )(_bbfc []ViolatedRule ){var _ebfa ,_gagc ,_cddb ,_cfea ,_fge ,_dfbd ,_gafgf bool ;
_eaefc :=func ()bool {return _ebfa &&_gagc &&_cddb &&_cfea &&_fge &&_dfbd &&_gafgf };_dab ,_bdfb :=_edda (_eeea );var _dda _egg .ProfileHeader ;if _bdfb {_dda ,_ =_egg .ParseHeader (_dab .DestOutputProfile );};var _cfgcb bool ;_cfgf :=map[_dd .PdfObject ]struct{}{};
var _gcfc func (_fdg _bf .PdfColorspace )bool ;_gcfc =func (_dbb _bf .PdfColorspace )bool {switch _gdab :=_dbb .(type ){case *_bf .PdfColorspaceDeviceGray :if !_dfbd {if !_bdfb {_cfgcb =true ;_bbfc =append (_bbfc ,_cgc ("\u0036.\u0032\u002e\u0033\u002d\u0034","\u0044\u0065\u0076\u0069\u0063e\u0043\u004d\u0059\u004b \u006d\u0061\u0079\u0020\u0062\u0065\u0020\u0075\u0073\u0065\u0064\u0020\u006f\u006e\u006c\u0079\u0020\u0069\u0066\u0020\u0074h\u0065\u0020\u0066\u0069\u006ce \u0068\u0061\u0073\u0020\u0061 \u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074p\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0020\u0074\u0068a\u0074\u0020\u0075\u0073\u0065\u0073\u0020\u0061\u006e \u0043\u004d\u0059\u004b\u0020\u0063\u006f\u006c\u006f\u0072\u0020s\u0070\u0061\u0063e\u002e"));
_dfbd =true ;if _eaefc (){return true ;};};};case *_bf .PdfColorspaceDeviceRGB :if !_cfea {if !_bdfb ||_dda .ColorSpace !=_egg .ColorSpaceRGB {_cfgcb =true ;_bbfc =append (_bbfc ,_cgc ("\u0036.\u0032\u002e\u0033\u002d\u0032","\u0044\u0065\u0076\u0069\u0063\u0065\u0052\u0047\u0042\u0020\u006d\u0061\u0079\u0020\u0062\u0065\u0020\u0075\u0073\u0065\u0064\u0020\u006f\u006e\u006c\u0079\u0020\u0069\u0066\u0020\u0074\u0068\u0065 \u0066\u0069\u006c\u0065\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074\u0070\u0075\u0074In\u0074\u0065\u006e\u0074\u0020\u0074\u0068\u0061\u0074\u0020u\u0073es\u0020a\u006e\u0020\u0052\u0047\u0042\u0020\u0063o\u006c\u006f\u0072\u0020\u0073\u0070\u0061\u0063\u0065\u002e"));
_cfea =true ;if _eaefc (){return true ;};};};case *_bf .PdfColorspaceDeviceCMYK :if !_fge {if !_bdfb ||_dda .ColorSpace !=_egg .ColorSpaceCMYK {_cfgcb =true ;_bbfc =append (_bbfc ,_cgc ("\u0036.\u0032\u002e\u0033\u002d\u0033","\u0044\u0065\u0076\u0069\u0063e\u0043\u004d\u0059\u004b \u006d\u0061\u0079\u0020\u0062\u0065\u0020\u0075\u0073\u0065\u0064\u0020\u006f\u006e\u006c\u0079\u0020\u0069\u0066\u0020\u0074h\u0065\u0020\u0066\u0069\u006ce \u0068\u0061\u0073\u0020\u0061 \u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074p\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0020\u0074\u0068a\u0074\u0020\u0075\u0073\u0065\u0073\u0020\u0061\u006e \u0043\u004d\u0059\u004b\u0020\u0063\u006f\u006c\u006f\u0072\u0020s\u0070\u0061\u0063e\u002e"));
_fge =true ;if _eaefc (){return true ;};};};case *_bf .PdfColorspaceICCBased :if !_cddb ||!_gafgf {_bbcb ,_baabb :=_egg .ParseHeader (_gdab .Data );if _baabb !=nil {_ee .Log .Debug ("\u0070\u0061\u0072si\u006e\u0067\u0020\u0049\u0043\u0043\u0042\u0061\u0073e\u0064 \u0068e\u0061d\u0065\u0072\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_baabb );
_bbfc =append (_bbfc ,func ()ViolatedRule {return _cgc ("\u0036.\u0032\u002e\u0033\u002d\u0031","\u0041\u006cl \u0049\u0043\u0043\u0042\u0061\u0073\u0065\u0064\u0020\u0063\u006f\u006co\u0072\u0020\u0073\u0070a\u0063e\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0061\u0073\u0020\u0049\u0043\u0043 \u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0073\u0074\u0072\u0065a\u006d\u0073 \u0061\u0073\u0020d\u0065\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020R\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0034\u002e\u0035");
}());_cddb =true ;if _eaefc (){return true ;};};if !_cddb {var _febe ,_baeb bool ;switch _bbcb .DeviceClass {case _egg .DeviceClassPRTR ,_egg .DeviceClassMNTR ,_egg .DeviceClassSCNR ,_egg .DeviceClassSPAC :default:_febe =true ;};switch _bbcb .ColorSpace {case _egg .ColorSpaceRGB ,_egg .ColorSpaceCMYK ,_egg .ColorSpaceGRAY ,_egg .ColorSpaceLAB :default:_baeb =true ;
};if _febe ||_baeb {_bbfc =append (_bbfc ,_cgc ("\u0036.\u0032\u002e\u0033\u002d\u0031","\u0041\u006cl \u0049\u0043\u0043\u0042\u0061\u0073\u0065\u0064\u0020\u0063\u006f\u006co\u0072\u0020\u0073\u0070a\u0063e\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0061\u0073\u0020\u0049\u0043\u0043 \u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0073\u0074\u0072\u0065a\u006d\u0073 \u0061\u0073\u0020d\u0065\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020R\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0034\u002e\u0035"));
_cddb =true ;if _eaefc (){return true ;};};};if !_gafgf {_daad ,_ :=_dd .GetStream (_gdab .GetContainingPdfObject ());if _daad .Get ("\u004e")==nil ||(_gdab .N ==1&&_bbcb .ColorSpace !=_egg .ColorSpaceGRAY )||(_gdab .N ==3&&!(_bbcb .ColorSpace ==_egg .ColorSpaceRGB ||_bbcb .ColorSpace ==_egg .ColorSpaceLAB ))||(_gdab .N ==4&&_bbcb .ColorSpace !=_egg .ColorSpaceCMYK ){_bbfc =append (_bbfc ,_cgc ("\u0036.\u0032\u002e\u0033\u002d\u0035","\u0049\u0066\u0020a\u006e\u0020u\u006e\u0063\u0061\u006c\u0069\u0062\u0072a\u0074\u0065\u0064\u0020\u0063\u006fl\u006f\u0072 \u0073\u0070\u0061c\u0065\u0020\u0069\u0073\u0020\u0075\u0073\u0065\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0066\u0069\u006c\u0065 \u0074\u0068\u0065\u006e \u0074\u0068\u0061\u0074 \u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063o\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u0020\u0050\u0044\u0046\u002f\u0041-\u0031\u0020\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006e\u0065d\u0020\u0069\u006e\u0020\u0036\u002e\u0032\u002e\u0032\u002e"));
_gafgf =true ;if _eaefc (){return true ;};};};};if _gdab .Alternate !=nil {return _gcfc (_gdab .Alternate );};};return false ;};for _ ,_afbbd :=range _eeea .GetObjectNums (){_gaba ,_ffecb :=_eeea .GetIndirectObjectByNumber (_afbbd );if _ffecb !=nil {continue ;
};_bgb ,_ddf :=_dd .GetStream (_gaba );if !_ddf {continue ;};_dded ,_ddf :=_dd .GetName (_bgb .Get ("\u0054\u0079\u0070\u0065"));if !_ddf ||_dded .String ()!="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;};_ebc ,_ddf :=_dd .GetName (_bgb .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));
if !_ddf {continue ;};_cfgf [_bgb ]=struct{}{};switch _ebc .String (){case "\u0049\u006d\u0061g\u0065":_fbeef ,_bagf :=_bf .NewXObjectImageFromStream (_bgb );if _bagf !=nil {continue ;};_cfgf [_bgb ]=struct{}{};if _gcfc (_fbeef .ColorSpace ){return _bbfc ;
};case "\u0046\u006f\u0072\u006d":_gafb ,_becc :=_dd .GetDict (_bgb .Get ("\u0047\u0072\u006fu\u0070"));if !_becc {continue ;};_bgge :=_gafb .Get ("\u0043\u0053");if _bgge ==nil {continue ;};_ebeff ,_edc :=_bf .NewPdfColorspaceFromPdfObject (_bgge );if _edc !=nil {continue ;
};if _gcfc (_ebeff ){return _bbfc ;};};};for _ ,_egge :=range _eeea .PageList {_egac ,_eedf :=_egge .GetContentStreams ();if _eedf !=nil {continue ;};for _ ,_bebe :=range _egac {_def ,_bbac :=_bd .NewContentStreamParser (_bebe ).Parse ();if _bbac !=nil {continue ;
};for _ ,_afbe :=range *_def {if len (_afbe .Params )> 1{continue ;};switch _afbe .Operand {case "\u0042\u0049":_dfab ,_ccbcd :=_afbe .Params [0].(*_bd .ContentStreamInlineImage );if !_ccbcd {continue ;};_ecbf ,_acae :=_dfab .GetColorSpace (_egge .Resources );
if _acae !=nil {continue ;};if _gcfc (_ecbf ){return _bbfc ;};case "\u0044\u006f":_fed ,_dbf :=_dd .GetName (_afbe .Params [0]);if !_dbf {continue ;};_fcgg ,_gggb :=_egge .Resources .GetXObjectByName (*_fed );if _ ,_eegd :=_cfgf [_fcgg ];_eegd {continue ;
};switch _gggb {case _bf .XObjectTypeImage :_gege ,_cfff :=_bf .NewXObjectImageFromStream (_fcgg );if _cfff !=nil {continue ;};_cfgf [_fcgg ]=struct{}{};if _gcfc (_gege .ColorSpace ){return _bbfc ;};case _bf .XObjectTypeForm :_aggb ,_deec :=_dd .GetDict (_fcgg .Get ("\u0047\u0072\u006fu\u0070"));
if !_deec {continue ;};_agb ,_deec :=_dd .GetName (_aggb .Get ("\u0043\u0053"));if !_deec {continue ;};_bgdg ,_edag :=_bf .NewPdfColorspaceFromPdfObject (_agb );if _edag !=nil {continue ;};_cfgf [_fcgg ]=struct{}{};if _gcfc (_bgdg ){return _bbfc ;};};};
};};};if !_cfgcb {return _bbfc ;};if (_dda .DeviceClass ==_egg .DeviceClassPRTR ||_dda .DeviceClass ==_egg .DeviceClassMNTR )&&(_dda .ColorSpace ==_egg .ColorSpaceRGB ||_dda .ColorSpace ==_egg .ColorSpaceCMYK ||_dda .ColorSpace ==_egg .ColorSpaceGRAY ){return _bbfc ;
};if !_eaeef {return _bbfc ;};_deaa ,_gdaa :=_eecg (_eeea );if !_gdaa {return _bbfc ;};_febec ,_gdaa :=_dd .GetArray (_deaa .Get ("\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073"));if !_gdaa {_bbfc =append (_bbfc ,_cgc ("\u0036.\u0032\u002e\u0032\u002d\u0031","\u0041\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074p\u0075\u0074\u0049\u006e\u0074e\u006e\u0074\u0020\u0069\u0073\u0020a\u006e \u004f\u0075\u0074\u0070\u0075\u0074\u0049n\u0074\u0065\u006e\u0074\u0020\u0064i\u0063\u0074\u0069\u006fn\u0061\u0072\u0079\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0062y\u0020\u0050\u0044F\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065 \u0039\u002e\u0031\u0030.4\u002c\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0073 \u0069\u006e\u0063\u006c\u0075\u0064e\u0064\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0027\u0073\u0020O\u0075\u0074p\u0075\u0074I\u006e\u0074\u0065\u006e\u0074\u0073\u0020\u0061\u0072\u0072\u0061\u0079\u0020a\u006e\u0064\u0020h\u0061\u0073\u0020\u0047\u0054\u0053\u005f\u0050\u0044\u0046\u0041\u0031\u0020\u0061\u0073 \u0074\u0068\u0065\u0020\u0076a\u006c\u0075e\u0020\u006f\u0066\u0020i\u0074\u0073 \u0053\u0020\u006b\u0065\u0079\u0020\u0061\u006e\u0064\u0020\u0061\u0020\u0076\u0061\u006c\u0069\u0064\u0020I\u0043\u0043\u0020\u0070\u0072\u006f\u0066\u0069\u006ce\u0020s\u0074\u0072\u0065\u0061\u006d \u0061\u0073\u0020\u0074h\u0065\u0020\u0076a\u006c\u0075\u0065\u0020\u0069\u0074\u0073\u0020\u0044\u0065\u0073t\u004f\u0075t\u0070\u0075\u0074P\u0072\u006f\u0066\u0069\u006c\u0065 \u006b\u0065\u0079\u002e"),_cgc ("\u0036.\u0032\u002e\u0032\u002d\u0032","\u0049\u0066\u0020\u0061\u0020\u0066\u0069\u006c\u0065's\u0020O\u0075\u0074\u0070u\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073 \u0061\u0072\u0072a\u0079\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0073\u0020\u006d\u006f\u0072\u0065\u0020\u0074\u0068a\u006e\u0020\u006f\u006ee\u0020\u0065\u006e\u0074\u0072\u0079\u002c\u0020\u0074\u0068\u0065\u006e\u0020\u0061\u006c\u006c\u0020\u0065n\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e a \u0044\u0065\u0073\u0074\u004f\u0075\u0074\u0070\u0075\u0074\u0050\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006cl\u0020\u0068\u0061\u0076\u0065 \u0061\u0073\u0020\u0074\u0068\u0065 \u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068a\u0074\u0020\u006b\u0065\u0079 \u0074\u0068\u0065\u0020\u0073\u0061\u006d\u0065\u0020\u0069\u006e\u0064\u0069\u0072\u0065c\u0074\u0020\u006fb\u006ae\u0063t\u002c\u0020\u0077h\u0069\u0063\u0068\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u0061\u0020\u0076\u0061\u006c\u0069d\u0020\u0049\u0043\u0043\u0020\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0073\u0074r\u0065\u0061m\u002e"));
return _bbfc ;};if _febec .Len ()> 1{_aage :=map[*_dd .PdfObjectDictionary ]struct{}{};for _dfda :=0;_dfda < _febec .Len ();_dfda ++{_cgee ,_bfcc :=_dd .GetDict (_febec .Get (_dfda ));if !_bfcc {continue ;};if _dfda ==0{_aage [_cgee ]=struct{}{};continue ;
};if _ ,_cbaa :=_aage [_cgee ];!_cbaa {_bbfc =append (_bbfc ,_cgc ("\u0036.\u0032\u002e\u0032\u002d\u0032","\u0049\u0066\u0020\u0061\u0020\u0066\u0069\u006c\u0065's\u0020O\u0075\u0074\u0070u\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073 \u0061\u0072\u0072a\u0079\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0073\u0020\u006d\u006f\u0072\u0065\u0020\u0074\u0068a\u006e\u0020\u006f\u006ee\u0020\u0065\u006e\u0074\u0072\u0079\u002c\u0020\u0074\u0068\u0065\u006e\u0020\u0061\u006c\u006c\u0020\u0065n\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e a \u0044\u0065\u0073\u0074\u004f\u0075\u0074\u0070\u0075\u0074\u0050\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006cl\u0020\u0068\u0061\u0076\u0065 \u0061\u0073\u0020\u0074\u0068\u0065 \u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068a\u0074\u0020\u006b\u0065\u0079 \u0074\u0068\u0065\u0020\u0073\u0061\u006d\u0065\u0020\u0069\u006e\u0064\u0069\u0072\u0065c\u0074\u0020\u006fb\u006ae\u0063t\u002c\u0020\u0077h\u0069\u0063\u0068\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u0061\u0020\u0076\u0061\u006c\u0069d\u0020\u0049\u0043\u0043\u0020\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0073\u0074r\u0065\u0061m\u002e"));
break ;};};};return _bbfc ;};func _gbbc (_cgcg *_dc .Document ,_bfd []pageColorspaceOptimizeFunc ,_aeec []documentColorspaceOptimizeFunc )error {_beb ,_ccg :=_cgcg .GetPages ();if !_ccg {return nil ;};var _cad []*_dc .Image ;for _abd ,_cgb :=range _beb {_abc ,_gga :=_cgb .FindXObjectImages ();
if _gga !=nil {return _gga ;};for _ ,_fga :=range _bfd {if _gga =_fga (_cgcg ,&_beb [_abd ],_abc );_gga !=nil {return _gga ;};};_cad =append (_cad ,_abc ...);};for _ ,_ddc :=range _aeec {if _bea :=_ddc (_cgcg ,_cad );_bea !=nil {return _bea ;};};return nil ;
};func (_ce *documentImages )hasOnlyDeviceCMYK ()bool {return _ce ._cgg &&!_ce ._bae &&!_ce ._gf };

// ValidateStandard checks if provided input CompliancePdfReader matches rules that conforms PDF/A-1 standard.
func (_eaf *profile1 )ValidateStandard (r *_bf .CompliancePdfReader )error {_gafg :=VerificationError {ConformanceLevel :_eaf ._gbff ._ecg ,ConformanceVariant :_eaf ._gbff ._bc };if _gdfg :=_dbacf (r );_gdfg !=_cf {_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_gdfg );
};if _gbgg :=_gcc (r );_gbgg !=_cf {_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_gbgg );};if _cgeb :=_cfgee (r );_cgeb !=_cf {_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_cgeb );};if _gcdg :=_bbg (r );_gcdg !=_cf {_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_gcdg );
};if _acf :=_fcae (r );_acf !=_cf {_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_acf );};if _beeb :=_bdef (r );len (_beeb )!=0{_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_beeb ...);};if _ede :=_ggeg (r );_ede !=_cf {_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_ede );
};if _daea :=_ffeb (r );len (_daea )!=0{_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_daea ...);};if _ffaa :=_bacc (r );len (_ffaa )!=0{_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_ffaa ...);};if _eeeg :=_gggfd (r );len (_eeeg )!=0{_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_eeeg ...);
};if _gaa :=_fegd (r );_gaa !=_cf {_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_gaa );};if _cbfgf :=_edef (r );len (_cbfgf )!=0{_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_cbfgf ...);};if _efcb :=_fbd (r );len (_efcb )!=0{_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_efcb ...);
};if _fgc :=_dfd (r );_fgc !=_cf {_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_fgc );};if _afca :=_dfaf (r ,false );len (_afca )!=0{_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_afca ...);};if _dgd :=_fgea (r );len (_dgd )!=0{_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_dgd ...);
};if _fbc :=_afdg (r );_fbc !=_cf {_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_fbc );};if _faa :=_babab (r );_faa !=_cf {_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_faa );};if _bgc :=_gadc (r );_bgc !=_cf {_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_bgc );
};if _ebd :=_eac (r );_ebd !=_cf {_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_ebd );};if _ebg :=_caad (r );_ebg !=_cf {_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_ebg );};if _eccb :=_ecbg (r );len (_eccb )!=0{_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_eccb ...);
};if _baab :=_afbbf (r ,_eaf ._gbff );len (_baab )!=0{_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_baab ...);};if _effc :=_abfb (r );len (_effc )!=0{_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_effc ...);};if _feff :=_ffcf (r );_feff !=_cf {_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_feff );
};if _gffg :=_eacbc (r );_gffg !=_cf {_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_gffg );};if _agfb :=_aceb (r );len (_agfb )!=0{_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_agfb ...);};if _dad :=_bfe (r );len (_dad )!=0{_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_dad ...);
};if _aafg :=_adfc (r );_aafg !=_cf {_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_aafg );};if _fdb :=_daag (r );_fdb !=_cf {_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_fdb );};if _eecc :=_abea (r ,_eaf ._gbff ,false );len (_eecc )!=0{_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_eecc ...);
};if _eaf ._gbff ==_dde (){if _aegee :=_ffbdde (r );len (_aegee )!=0{_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_aegee ...);};};if _dddg :=_fbea (r );len (_dddg )!=0{_gafg .ViolatedRules =append (_gafg .ViolatedRules ,_dddg ...);};if len (_gafg .ViolatedRules )> 0{_ae .Slice (_gafg .ViolatedRules ,func (_eab ,_cba int )bool {return _gafg .ViolatedRules [_eab ].RuleNo < _gafg .ViolatedRules [_cba ].RuleNo });
return _gafg ;};return nil ;};func _ffcf (_fdae *_bf .CompliancePdfReader )ViolatedRule {for _ ,_gebaf :=range _fdae .GetObjectNums (){_ebcd ,_cdef :=_fdae .GetIndirectObjectByNumber (_gebaf );if _cdef !=nil {continue ;};_ggdd ,_dgac :=_dd .GetStream (_ebcd );
if !_dgac {continue ;};_gdc ,_dgac :=_dd .GetName (_ggdd .Get ("\u0054\u0079\u0070\u0065"));if !_dgac {continue ;};if *_gdc !="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;};if _ggdd .Get ("\u0053\u004d\u0061s\u006b")!=nil {return _cgc ("\u0036\u002e\u0034-\u0032","\u0041\u006e\u0020\u0058\u004f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074i\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068e \u0053\u004d\u0061\u0073\u006b\u0020\u006b\u0065\u0079\u002e");
};};return _cf ;};func _fgf ()standardType {return standardType {_ecg :2,_bc :"\u0042"}};func _aceb (_ggdfe *_bf .CompliancePdfReader )(_gabf []ViolatedRule ){var _cgggf ,_gafcc ,_babf ,_dbdfb ,_gegg ,_cdfc ,_afee bool ;_efga :=func ()bool {return _cgggf &&_gafcc &&_babf &&_dbdfb &&_gegg &&_cdfc &&_afee };
for _ ,_fefab :=range _ggdfe .PageList {_aafb ,_bfag :=_fefab .GetAnnotations ();if _bfag !=nil {_ee .Log .Trace ("\u006c\u006f\u0061\u0064\u0069\u006e\u0067\u0020\u0061\u006en\u006f\u0074\u0061\u0074\u0069\u006f\u006es\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_bfag );
continue ;};for _ ,_gcaf :=range _aafb {if !_cgggf {switch _gcaf .GetContext ().(type ){case *_bf .PdfAnnotationFileAttachment ,*_bf .PdfAnnotationSound ,*_bf .PdfAnnotationMovie ,nil :_gabf =append (_gabf ,_cgc ("\u0036.\u0035\u002e\u0032\u002d\u0031","\u0041\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0074\u0079\u0070\u0065\u0073\u0020\u006e\u006f\u0074 \u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020i\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006ec\u0065\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074 \u0062\u0065\u0020p\u0065\u0072m\u0069\u0074\u0074\u0065\u0064\u002e\u0020\u0041d\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u002c\u0020\u0074\u0068\u0065\u0020F\u0069\u006c\u0065\u0041\u0074\u0074\u0061\u0063\u0068\u006de\u006e\u0074\u002c\u0020\u0053\u006f\u0075\u006e\u0064\u0020\u0061\u006e\u0064\u0020\u004d\u006f\u0076\u0069e\u0020\u0074\u0079\u0070\u0065s \u0073ha\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_cgggf =true ;if _efga (){return _gabf ;};};};_eeefa ,_geeg :=_dd .GetDict (_gcaf .GetContainingPdfObject ());if !_geeg {continue ;};if !_gafcc {_cecdc ,_bcdb :=_dd .GetFloatVal (_eeefa .Get ("\u0043\u0041"));if _bcdb &&_cecdc !=1.0{_gabf =append (_gabf ,_cgc ("\u0036.\u0035\u002e\u0033\u002d\u0031","\u0041\u006e\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073h\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e \u0074\u0068\u0065\u0020\u0043\u0041\u0020\u006b\u0065\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0074\u0068\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0031\u002e\u0030\u002e"));
_gafcc =true ;if _efga (){return _gabf ;};};};if !_babf {_dbec ,_ccbac :=_dd .GetIntVal (_eeefa .Get ("\u0046"));if !(_ccbac &&_dbec &4==4&&_dbec &1==0&&_dbec &2==0&&_dbec &32==0){_gabf =append (_gabf ,_cgc ("\u0036.\u0035\u002e\u0033\u002d\u0032","\u0041\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074i\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0020\u0074\u0068\u0065\u0020\u0046\u0020\u006b\u0065\u0079\u002e\u0020\u0054\u0068\u0065\u0020\u0046\u0020\u006b\u0065\u0079\u0027\u0073\u0020\u0050\u0072\u0069\u006e\u0074\u0020\u0066\u006c\u0061\u0067\u0020\u0062\u0069\u0074\u0020\u0073h\u0061\u006c\u006c\u0020\u0062\u0065 s\u0065\u0074\u0020\u0074\u006f\u0020\u0031\u0020\u0061\u006e\u0064\u0020\u0069\u0074\u0073\u0020\u0048\u0069\u0064\u0064\u0065\u006e\u002c\u0020I\u006e\u0076\u0069\u0073\u0069\u0062\u006c\u0065\u0020\u0061\u006e\u0064\u0020\u004e\u006f\u0056\u0069\u0065\u0077\u0020\u0066\u006c\u0061\u0067\u0020b\u0069\u0074\u0073 \u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0073e\u0074\u0020t\u006f\u0020\u0030\u002e"));
_babf =true ;if _efga (){return _gabf ;};};};if !_dbdfb {_dbcc ,_fcbc :=_dd .GetDict (_eeefa .Get ("\u0041\u0050"));if _fcbc {_cabf :=_dbcc .Get ("\u004e");if _cabf ==nil ||len (_dbcc .Keys ())> 1{_gabf =append (_gabf ,_cgc ("\u0036.\u0035\u002e\u0033\u002d\u0034","\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020d\u0069\u0063t\u0069\u006f\u006ea\u0072\u0069\u0065\u0073 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0069\u006e\u0067\u0020\u0061\u006e\u0020\u0041\u0050 \u006b\u0065\u0079\u002c\u0020\u0074\u0068\u0065\u0020\u0061p\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0073\u0020\u0061\u0073\u0020it\u0073\u0020\u0076\u0061\u006cu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061i\u006e\u0020o\u006e\u006c\u0079\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u002e\u0020\u0049\u0066\u0020\u0061\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064i\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0027\u0073\u0020\u0053\u0075\u0062ty\u0070\u0065\u0020\u006b\u0065\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0057\u0069\u0064g\u0065\u0074\u0020\u0061\u006e\u0064\u0020\u0069\u0074s\u0020\u0046\u0054 \u006be\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020B\u0074\u006e,\u0020\u0074he \u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0064\u0069\u0063\u0074\u0069\u006fn\u0061r\u0079; \u006f\u0074\u0068\u0065\u0072\u0077\u0069s\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020th\u0065\u0020N\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062e\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061n\u0063\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"));
_dbdfb =true ;if _efga (){return _gabf ;};continue ;};_ ,_ddgbd :=_gcaf .GetContext ().(*_bf .PdfAnnotationWidget );if _ddgbd {_fdgg ,_bedf :=_dd .GetName (_eeefa .Get ("\u0046\u0054"));if _bedf &&*_fdgg =="\u0042\u0074\u006e"{if _ ,_dadg :=_dd .GetDict (_cabf );
!_dadg {_gabf =append (_gabf ,_cgc ("\u0036.\u0035\u002e\u0033\u002d\u0034","\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020d\u0069\u0063t\u0069\u006f\u006ea\u0072\u0069\u0065\u0073 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0069\u006e\u0067\u0020\u0061\u006e\u0020\u0041\u0050 \u006b\u0065\u0079\u002c\u0020\u0074\u0068\u0065\u0020\u0061p\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0073\u0020\u0061\u0073\u0020it\u0073\u0020\u0076\u0061\u006cu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061i\u006e\u0020o\u006e\u006c\u0079\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u002e\u0020\u0049\u0066\u0020\u0061\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064i\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0027\u0073\u0020\u0053\u0075\u0062ty\u0070\u0065\u0020\u006b\u0065\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0057\u0069\u0064g\u0065\u0074\u0020\u0061\u006e\u0064\u0020\u0069\u0074s\u0020\u0046\u0054 \u006be\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020B\u0074\u006e,\u0020\u0074he \u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0064\u0069\u0063\u0074\u0069\u006fn\u0061r\u0079; \u006f\u0074\u0068\u0065\u0072\u0077\u0069s\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020th\u0065\u0020N\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062e\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061n\u0063\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"));
_dbdfb =true ;if _efga (){return _gabf ;};continue ;};};};_ ,_ebea :=_dd .GetStream (_cabf );if !_ebea {_gabf =append (_gabf ,_cgc ("\u0036.\u0035\u002e\u0033\u002d\u0034","\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0061\u006e\u006e\u006ft\u0061\u0074\u0069\u006f\u006e\u0020d\u0069\u0063t\u0069\u006f\u006ea\u0072\u0069\u0065\u0073 \u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0069\u006e\u0067\u0020\u0061\u006e\u0020\u0041\u0050 \u006b\u0065\u0079\u002c\u0020\u0074\u0068\u0065\u0020\u0061p\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0073\u0020\u0061\u0073\u0020it\u0073\u0020\u0076\u0061\u006cu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061i\u006e\u0020o\u006e\u006c\u0079\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u002e\u0020\u0049\u0066\u0020\u0061\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064i\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0027\u0073\u0020\u0053\u0075\u0062ty\u0070\u0065\u0020\u006b\u0065\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0057\u0069\u0064g\u0065\u0074\u0020\u0061\u006e\u0064\u0020\u0069\u0074s\u0020\u0046\u0054 \u006be\u0079\u0020\u0068\u0061\u0073\u0020\u0061\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020B\u0074\u006e,\u0020\u0074he \u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u004e\u0020\u006b\u0065\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0064\u0069\u0063\u0074\u0069\u006fn\u0061r\u0079; \u006f\u0074\u0068\u0065\u0072\u0077\u0069s\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020th\u0065\u0020N\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062e\u0020\u0061\u006e\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0061n\u0063\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"));
_dbdfb =true ;if _efga (){return _gabf ;};continue ;};};};if !_gegg {if _eeefa .Get ("\u0043")!=nil ||_eeefa .Get ("\u0049\u0043")!=nil {_dcdfgd ,_abfba :=_aeeb (_ggdfe );if !_abfba {_gabf =append (_gabf ,_cgc ("\u0036.\u0035\u002e\u0033\u002d\u0033","\u0041\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006fn\u0074a\u0069\u006e\u0020t\u0068e\u0020\u0043\u0020\u0061\u0072\u0072\u0061\u0079\u0020\u006f\u0072\u0020\u0074\u0068e\u0020\u0049\u0043\u0020\u0061\u0072\u0072\u0061\u0079\u0020\u0075\u006e\u006c\u0065\u0073\u0073\u0020\u0074\u0068\u0065\u0020\u0063o\u006c\u006f\u0072\u0020\u0073\u0070\u0061\u0063\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0044\u0065\u0073\u0074\u004f\u0075\u0074\u0070\u0075\u0074\u0050\u0072\u006ff\u0069\u006ce\u0020\u0069\u006e\u0020\u0074h\u0065\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002c\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069n\u0020\u0036\u002e\u0032\u002e2\u002c\u0020\u0069\u0073\u0020\u0052\u0047\u0042."));
_gegg =true ;if _efga (){return _gabf ;};}else {_ddb ,_bccb :=_dd .GetIntVal (_dcdfgd .Get ("\u004e"));if !_bccb ||_ddb !=3{_gabf =append (_gabf ,_cgc ("\u0036.\u0035\u002e\u0033\u002d\u0033","\u0041\u006e\u0020\u0061\u006e\u006e\u006f\u0074\u0061\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006fn\u0074a\u0069\u006e\u0020t\u0068e\u0020\u0043\u0020\u0061\u0072\u0072\u0061\u0079\u0020\u006f\u0072\u0020\u0074\u0068e\u0020\u0049\u0043\u0020\u0061\u0072\u0072\u0061\u0079\u0020\u0075\u006e\u006c\u0065\u0073\u0073\u0020\u0074\u0068\u0065\u0020\u0063o\u006c\u006f\u0072\u0020\u0073\u0070\u0061\u0063\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0044\u0065\u0073\u0074\u004f\u0075\u0074\u0070\u0075\u0074\u0050\u0072\u006ff\u0069\u006ce\u0020\u0069\u006e\u0020\u0074h\u0065\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002c\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069n\u0020\u0036\u002e\u0032\u002e2\u002c\u0020\u0069\u0073\u0020\u0052\u0047\u0042."));
_gegg =true ;if _efga (){return _gabf ;};};};};};_fgdb ,_edefc :=_gcaf .GetContext ().(*_bf .PdfAnnotationWidget );if !_edefc {continue ;};if !_cdfc {if _fgdb .A !=nil {_gabf =append (_gabf ,_cgc ("\u0036.\u0036\u002e\u0031\u002d\u0033","A \u0057\u0069d\u0067\u0065\u0074\u0020\u0061\u006e\u006e\u006f\u0074a\u0074\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0069\u006ec\u006cu\u0064\u0065\u0020\u0061\u006e\u0020\u0041\u0020e\u006et\u0072\u0079."));
_cdfc =true ;if _efga (){return _gabf ;};};};if !_afee {if _fgdb .AA !=nil {_gabf =append (_gabf ,_cgc ("\u0036.\u0036\u002e\u0032\u002d\u0031","\u0041\u0020\u0057\u0069\u0064\u0067\u0065\u0074\u0020\u0061\u006e\u006eo\u0074\u0061\u0074i\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079\u0020\u0073h\u0061\u006c\u006c\u0020n\u006f\u0074\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061\u006e\u0020\u0041\u0041\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0066\u006f\u0072\u0020\u0061\u006e\u0020\u0061d\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u002d\u0061\u0063t\u0069\u006f\u006e\u0073\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e"));
_afee =true ;if _efga (){return _gabf ;};};};};};return _gabf ;};var _ Profile =(*Profile1B )(nil );

// Profile1Options are the options that changes the way how optimizer may try to adapt document into PDF/A standard.
type Profile1Options struct{

// CMYKDefaultColorSpace is an option that refers PDF/A-1
CMYKDefaultColorSpace bool ;

// Now is a function that returns current time.
Now func ()_aa .Time ;

// Xmp is the xmp options information.
Xmp XmpOptions ;};func _gcc (_fbeb *_bf .CompliancePdfReader )ViolatedRule {_cdagg :=_fbeb .ParserMetadata ().HeaderCommentBytes ();if _cdagg [0]> 127&&_cdagg [1]> 127&&_cdagg [2]> 127&&_cdagg [3]> 127{return _cf ;};return _cgc ("\u0036.\u0031\u002e\u0032\u002d\u0032","\u0054\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0020\u0068\u0065\u0061\u0064\u0065\u0072\u0020\u006c\u0069\u006e\u0065\u0020\u0073\u0068\u0061\u006c\u006c b\u0065\u0020i\u006d\u006d\u0065\u0064\u0069a\u0074\u0065\u006c\u0079 \u0066\u006f\u006c\u006co\u0077\u0065\u0064\u0020\u0062\u0079\u0020\u0061\u0020\u0063\u006f\u006d\u006d\u0065n\u0074\u0020\u0063\u006f\u006e\u0073\u0069s\u0074\u0069\u006e\u0067\u0020o\u0066\u0020\u0061\u0020\u0025\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0066\u006f\u006c\u006c\u006fwe\u0064\u0020\u0062y\u0020a\u0074\u0009\u006c\u0065a\u0073\u0074\u0020f\u006f\u0075\u0072\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065r\u0073\u002c\u0020e\u0061\u0063\u0068\u0020\u006f\u0066\u0020\u0077\u0068\u006f\u0073\u0065 \u0065\u006e\u0063\u006f\u0064e\u0064\u0020\u0062\u0079\u0074e\u0020\u0076\u0061\u006c\u0075\u0065s\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0068\u0061\u0076\u0065\u0020\u0061\u0020\u0064e\u0063\u0069\u006d\u0061\u006c \u0076\u0061\u006c\u0075\u0065\u0020\u0067\u0072\u0065\u0061\u0074\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0031\u0032\u0037\u002e");
};func _ecbg (_ddgb *_bf .CompliancePdfReader )(_bbdf []ViolatedRule ){var _ggfde ,_gbba ,_ggeeg ,_egdc ,_cgbe ,_geae ,_gabb bool ;_gaaa :=func ()bool {return _ggfde &&_gbba &&_ggeeg &&_egdc &&_cgbe &&_geae &&_gabb };for _ ,_dgda :=range _ddgb .PageList {if _dgda .Resources ==nil {continue ;
};_dcgc ,_fecc :=_dd .GetDict (_dgda .Resources .Font );if !_fecc {continue ;};for _ ,_baabba :=range _dcgc .Keys (){_ebda ,_acda :=_dd .GetDict (_dcgc .Get (_baabba ));if !_acda {if !_ggfde {_bbdf =append (_bbdf ,_cgc ("\u0036.\u0033\u002e\u0032\u002d\u0031","\u0041\u006c\u006c\u0020\u0066\u006fn\u0074\u0073\u0020\u0075\u0073e\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020c\u006f\u006e\u0066\u006f\u0072m\u0020\u0074\u006f\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0073\u0070\u0065\u0063\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006f\u006e\u0073\u0020d\u0065\u0066\u0069\u006e\u0065d \u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0035\u002e\u0035\u002e"));
_ggfde =true ;if _gaaa (){return _bbdf ;};};continue ;};if _fabe ,_dbdd :=_dd .GetName (_ebda .Get ("\u0054\u0079\u0070\u0065"));!_ggfde &&(!_dbdd ||_fabe .String ()!="\u0046\u006f\u006e\u0074"){_bbdf =append (_bbdf ,_cgc ("\u0036.\u0033\u002e\u0032\u002d\u0031","\u0054\u0079\u0070e\u0020\u002d\u0020\u006e\u0061\u006d\u0065\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075i\u0072\u0065\u0064\u0029 Th\u0065\u0020\u0074\u0079\u0070\u0065\u0020\u006f\u0066 \u0050\u0044\u0046\u0020\u006fbj\u0065\u0063\u0074\u0020\u0074\u0068\u0061t\u0020\u0074\u0068\u0069s\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0064\u0065\u0073c\u0072\u0069\u0062\u0065\u0073\u003b\u0020\u006d\u0075\u0073t\u0020\u0062\u0065\u0020\u0046\u006f\u006e\u0074\u0020\u0066\u006fr\u0020\u0061\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002e"));
_ggfde =true ;if _gaaa (){return _bbdf ;};};_egcc ,_fdge :=_bf .NewPdfFontFromPdfObject (_ebda );if _fdge !=nil {continue ;};var _afaa string ;if _fcbb ,_fcaf :=_dd .GetName (_ebda .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_fcaf {_afaa =_fcbb .String ();
};if !_gbba {switch _afaa {case "\u0054\u0079\u0070e\u0030","\u0054\u0079\u0070e\u0031","\u004dM\u0054\u0079\u0070\u0065\u0031","\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065","\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0030","\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0032":default:_gbba =true ;
_bbdf =append (_bbdf ,_cgc ("\u0036.\u0033\u002e\u0032\u002d\u0032","\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0020\u002d\u0020\u006e\u0061\u006d\u0065\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075\u0069\u0072\u0065d\u0029\u0020\u0054\u0068e \u0074\u0079\u0070\u0065 \u006f\u0066\u0020\u0066\u006f\u006et\u003b\u0020\u006d\u0075\u0073\u0074\u0020b\u0065\u0020\u0022\u0054\u0079\u0070\u0065\u0031\u0022\u0020f\u006f\u0072\u0020\u0054\u0079\u0070\u0065\u0020\u0031\u0020f\u006f\u006e\u0074\u0073\u002c\u0020\u0022\u004d\u004d\u0054\u0079\u0070\u0065\u0031\u0022\u0020\u0066\u006f\u0072\u0020\u006d\u0075\u006c\u0074\u0069\u0070\u006c\u0065\u0020\u006da\u0073\u0074e\u0072\u0020\u0066\u006f\u006e\u0074s\u002c\u0020\u0022\u0054\u0072\u0075\u0065T\u0079\u0070\u0065\u0022\u0020\u0066\u006f\u0072\u0020\u0054\u0072\u0075\u0065T\u0079\u0070\u0065\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0022\u0054\u0079\u0070\u0065\u0033\u0022\u0020\u0066\u006f\u0072\u0020\u0054\u0079\u0070e\u0020\u0033\u0020\u0066\u006f\u006e\u0074\u0073\u002c\u0020\"\u0054\u0079\u0070\u0065\u0030\"\u0020\u0066\u006f\u0072\u0020\u0054\u0079\u0070\u0065\u0020\u0030\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0061\u006ed\u0020\u0022\u0043\u0049\u0044\u0046\u006fn\u0074\u0054\u0079\u0070\u0065\u0030\u0022 \u006f\u0072\u0020\u0022\u0043\u0049\u0044\u0046\u006f\u006e\u0074T\u0079\u0070e\u0032\u0022\u0020\u0066\u006f\u0072\u0020\u0043\u0049\u0044\u0020\u0066\u006f\u006e\u0074\u0073\u002e"));
if _gaaa (){return _bbdf ;};};};if !_ggeeg {if _afaa !="\u0054\u0079\u0070e\u0033"{_cabb ,_gdabf :=_dd .GetName (_ebda .Get ("\u0042\u0061\u0073\u0065\u0046\u006f\u006e\u0074"));if !_gdabf ||_cabb .String ()==""{_bbdf =append (_bbdf ,_cgc ("\u0036.\u0033\u002e\u0032\u002d\u0033","B\u0061\u0073\u0065\u0046\u006f\u006e\u0074\u0020\u002d\u0020\u006e\u0061\u006d\u0065\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075\u0069\u0072\u0065\u0064)\u0020T\u0068\u0065\u0020\u0050o\u0073\u0074S\u0063\u0072\u0069\u0070\u0074\u0020\u006e\u0061\u006d\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u002e"));
_ggeeg =true ;if _gaaa (){return _bbdf ;};};};};if _afaa !="\u0054\u0079\u0070e\u0031"{continue ;};_fgda :=_dcb .IsStdFont (_dcb .StdFontName (_egcc .BaseFont ()));if _fgda {continue ;};_afcb ,_gcebb :=_dd .GetIntVal (_ebda .Get ("\u0046i\u0072\u0073\u0074\u0043\u0068\u0061r"));
if !_gcebb &&!_egdc {_bbdf =append (_bbdf ,_cgc ("\u0036.\u0033\u002e\u0032\u002d\u0034","\u0046\u0069r\u0073t\u0043\u0068\u0061\u0072\u0020\u002d\u0020\u0069\u006e\u0074\u0065\u0067\u0065\u0072\u0020\u002d\u0020\u0028\u0052\u0065\u0071\u0075i\u0072\u0065\u0064\u0020\u0065\u0078\u0063\u0065\u0070t\u0020\u0066\u006f\u0072\u0020\u0074h\u0065\u0020\u0073\u0074\u0061\u006e\u0064\u0061\u0072d\u0020\u0031\u0034\u0020\u0066\u006f\u006e\u0074\u0073\u0029\u0020\u0054\u0068\u0065\u0020\u0066\u0069\u0072\u0073\u0074\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0063\u006f\u0064e\u0020\u0064\u0065\u0066i\u006ee\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0027\u0073\u0020\u0057i\u0064\u0074\u0068\u0073 \u0061r\u0072\u0061y\u002e"));
_egdc =true ;if _gaaa (){return _bbdf ;};};_cadb ,_geda :=_dd .GetIntVal (_ebda .Get ("\u004c\u0061\u0073\u0074\u0043\u0068\u0061\u0072"));if !_geda &&!_cgbe {_bbdf =append (_bbdf ,_cgc ("\u0036.\u0033\u002e\u0032\u002d\u0035","\u004c\u0061\u0073t\u0043\u0068\u0061\u0072\u0020\u002d\u0020\u0069n\u0074\u0065\u0067e\u0072 \u002d\u0020\u0028\u0052\u0065\u0071u\u0069\u0072\u0065d\u0020\u0065\u0078\u0063\u0065\u0070\u0074\u0020\u0066\u006f\u0072\u0020t\u0068\u0065 s\u0074\u0061\u006e\u0064\u0061\u0072\u0064\u0020\u0031\u0034\u0020\u0066\u006f\u006ets\u0029\u0020\u0054\u0068\u0065\u0020\u006c\u0061\u0073t\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0063\u006f\u0064\u0065\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0027\u0073\u0020\u0057\u0069\u0064\u0074h\u0073\u0020\u0061\u0072\u0072\u0061\u0079\u002e"));
_cgbe =true ;if _gaaa (){return _bbdf ;};};if !_geae {_gdga ,_fee :=_dd .GetArray (_ebda .Get ("\u0057\u0069\u0064\u0074\u0068\u0073"));if !_fee ||!_gcebb ||!_geda ||_gdga .Len ()!=_cadb -_afcb +1{_bbdf =append (_bbdf ,_cgc ("\u0036.\u0033\u002e\u0032\u002d\u0036","\u0057\u0069\u0064\u0074\u0068\u0073\u0020\u002d a\u0072\u0072\u0061y \u002d\u0020\u0028\u0052\u0065\u0071\u0075\u0069\u0072\u0065\u0064\u0020\u0065\u0078\u0063\u0065\u0070t\u0020\u0066\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u0073\u0074a\u006e\u0064a\u0072\u0064\u00201\u0034\u0020\u0066\u006f\u006e\u0074\u0073\u003b\u0020\u0069\u006ed\u0069\u0072\u0065\u0063\u0074\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0070\u0072\u0065\u0066e\u0072\u0072e\u0064\u0029\u0020\u0041\u006e \u0061\u0072\u0072\u0061\u0079\u0020\u006f\u0066\u0020\u0028\u004c\u0061\u0073\u0074\u0043\u0068\u0061\u0072\u0020\u2212 F\u0069\u0072\u0073\u0074\u0043\u0068\u0061\u0072\u0020\u002b\u00201\u0029\u0020\u0077\u0069\u0064\u0074\u0068\u0073."));
_geae =true ;if _gaaa (){return _bbdf ;};};};};};return _bbdf ;};func _cdb (_eced *_dc .Document ){_ggef ,_ecga :=_eced .FindCatalog ();if !_ecga {return ;};_fdc ,_ecga :=_ggef .GetMarkInfo ();if !_ecga {_fdc =_dd .MakeDict ();};_dcee ,_ecga :=_dd .GetBool (_fdc .Get ("\u004d\u0061\u0072\u006b\u0065\u0064"));
if !_ecga ||!bool (*_dcee ){_fdc .Set ("\u004d\u0061\u0072\u006b\u0065\u0064",_dd .MakeBool (true ));_ggef .SetMarkInfo (_fdc );};};

// Profile1B is the implementation of the PDF/A-1B standard profile.
// Implements model.StandardImplementer, Profile interfaces.
type Profile1B struct{profile1 };func _cd ()standardType {return standardType {_ecg :1,_bc :"\u0042"}};

// DefaultProfile1Options are the default options for the Profile1.
func DefaultProfile1Options ()*Profile1Options {return &Profile1Options {Now :_aa .Now ,Xmp :XmpOptions {MarshalIndent :"\u0009"}};};func _eac (_bed *_bf .CompliancePdfReader )ViolatedRule {return _cf };func _fgd (_cge *_dc .Document ,_feg int ){if _cge .Version .Major ==0{_cge .Version .Major =1;
};if _cge .Version .Minor < _feg {_cge .Version .Minor =_feg ;};};func _fbea (_cfec *_bf .CompliancePdfReader )(_bagfe []ViolatedRule ){return _bagfe };func _cgde (_fca *_dc .Document ,_gbfe bool )error {_fgfa ,_fead :=_fca .GetPages ();if !_fead {return nil ;
};for _ ,_bbf :=range _fgfa {_baee :=_bbf .FindXObjectForms ();for _ ,_acca :=range _baee {_ebf ,_gdeb :=_bf .NewXObjectFormFromStream (_acca );if _gdeb !=nil {return _gdeb ;};_eeaa ,_gdeb :=_ebf .GetContentStream ();if _gdeb !=nil {return _gdeb ;};_cbd :=_bd .NewContentStreamParser (string (_eeaa ));
_gceb ,_gdeb :=_cbd .Parse ();if _gdeb !=nil {return _gdeb ;};_agga ,_gdeb :=_fgg (_ebf .Resources ,_gceb ,_gbfe );if _gdeb !=nil {return _gdeb ;};if len (_agga )==0{continue ;};if _gdeb =_ebf .SetContentStream (_agga ,_dd .NewFlateEncoder ());_gdeb !=nil {return _gdeb ;
};_ebf .ToPdfObject ();};};return nil ;};func _eefa (_ddab *_bf .PdfFont ,_fddg *_dd .PdfObjectDictionary )ViolatedRule {const (_edcg ="\u0036.\u0033\u002e\u0037\u002d\u0031";_gcff ="\u0041\u006cl \u006e\u006f\u006e\u002d\u0073\u0079\u006db\u006f\u006c\u0069\u0063\u0020\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065\u0020\u0066o\u006e\u0074s\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0068\u0061\u0076\u0065\u0020e\u0069\u0074h\u0065\u0072\u0020\u004d\u0061\u0063\u0052\u006f\u006d\u0061\u006e\u0045\u006e\u0063\u006fd\u0069\u006e\u0067\u0020\u006f\u0072\u0020\u0057\u0069\u006e\u0041\u006e\u0073i\u0045n\u0063\u006f\u0064\u0069n\u0067\u0020\u0061\u0073\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0066o\u0072\u0020t\u0068\u0065 \u0045n\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u006b\u0065\u0079 \u0069\u006e\u0020t\u0068e\u0020\u0046o\u006e\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u006f\u0072\u0020\u0061\u0073\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0066\u006f\u0072 \u0074\u0068\u0065\u0020\u0042\u0061\u0073\u0065\u0045\u006e\u0063\u006fd\u0069\u006e\u0067\u0020\u006b\u0065\u0079\u0020\u0069\u006e\u0020\u0074\u0068\u0065 \u0064i\u0063\u0074i\u006fn\u0061\u0072\u0079\u0020\u0077\u0068\u0069\u0063\u0068\u0020\u0069s\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006ff\u0020\u0074\u0068e\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u006be\u0079\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0046\u006f\u006e\u0074 \u0064\u0069\u0063\u0074i\u006f\u006e\u0061\u0072\u0079\u002e\u0020\u0049\u006e\u0020\u0061\u0064\u0064\u0069\u0074\u0069\u006f\u006e, \u006eo\u0020n\u006f\u006e\u002d\u0073\u0079\u006d\u0062\u006f\u006c\u0069\u0063\u0020\u0054\u0072\u0075\u0065\u0054\u0079p\u0065 \u0066\u006f\u006e\u0074\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0020\u0061\u0020\u0044\u0069\u0066\u0066e\u0072\u0065\u006e\u0063\u0065\u0073\u0020a\u0072\u0072\u0061\u0079\u0020\u0075n\u006c\u0065s\u0073\u0020\u0061\u006c\u006c\u0020\u006f\u0066\u0020\u0074h\u0065\u0020\u0067\u006c\u0079\u0070\u0068\u0020\u006e\u0061\u006d\u0065\u0073 \u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0044\u0069f\u0066\u0065\u0072\u0065\u006ec\u0065\u0073\u0020a\u0072\u0072\u0061\u0079\u0020\u0061\u0072\u0065\u0020\u006c\u0069\u0073\u0074\u0065\u0064 \u0069\u006e \u0074\u0068\u0065\u0020\u0041\u0064\u006f\u0062\u0065 G\u006c\u0079\u0070\u0068\u0020\u004c\u0069\u0073t\u0020\u0061\u006e\u0064\u0020\u0074h\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0020\u0066o\u006e\u0074\u0020\u0070\u0072\u006f\u0067\u0072a\u006d\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0073\u0020\u0061\u0074\u0020\u006c\u0065\u0061\u0073t\u0020\u0074\u0068\u0065\u0020\u004d\u0069\u0063\u0072o\u0073o\u0066\u0074\u0020\u0055\u006e\u0069\u0063\u006f\u0064\u0065\u0020\u0028\u0033\u002c\u0031 \u2013 P\u006c\u0061\u0074\u0066\u006f\u0072\u006d\u0020I\u0044\u003d\u0033\u002c\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067 I\u0044\u003d\u0031\u0029\u0020\u0065\u006e\u0063\u006f\u0064i\u006e\u0067 \u0069\u006e\u0020t\u0068\u0065\u0020'\u0063\u006d\u0061\u0070\u0027\u0020\u0074\u0061\u0062\u006c\u0065\u002e";
);var _caag string ;if _cdgd ,_bgdb :=_dd .GetName (_fddg .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_bgdb {_caag =_cdgd .String ();};if _caag !="\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065"{return _cf ;};_beeba :=_ddab .FontDescriptor ();_aggad ,_faec :=_dd .GetIntVal (_beeba .Flags );
if !_faec {_ee .Log .Debug ("\u0066\u006c\u0061\u0067\u0073 \u006e\u006f\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0066o\u0072\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0070\u0074\u006f\u0072");
return _cgc (_edcg ,_gcff );};_fdbd :=(uint32 (_aggad )>>3)!=0;if _fdbd {return _cf ;};_feec ,_faec :=_dd .GetName (_fddg .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067"));if !_faec {return _cgc (_edcg ,_gcff );};switch _feec .String (){case "\u004d\u0061c\u0052\u006f\u006da\u006e\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067","\u0057i\u006eA\u006e\u0073\u0069\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067":return _cf ;
default:return _cgc (_edcg ,_gcff );};};func _dced (_agd *_dc .Document ){if _agd .ID [0]!=""&&_agd .ID [1]!=""{return ;};_agd .UseHashBasedID =true ;};func _bga (_fegc *_dc .Document ,_gecb bool )error {_baf ,_accd :=_fegc .GetPages ();if !_accd {return nil ;
};for _ ,_cdd :=range _baf {_egcg ,_daf :=_cdd .GetContents ();if !_daf {continue ;};var _add *_bf .PdfPageResources ;_fgb ,_daf :=_cdd .GetResources ();if _daf {_add ,_ =_bf .NewPdfPageResourcesFromDict (_fgb );};for _bbe ,_cfbea :=range _egcg {_gcdf ,_geg :=_cfbea .GetData ();
if _geg !=nil {continue ;};_fbee :=_bd .NewContentStreamParser (string (_gcdf ));_baaa ,_geg :=_fbee .Parse ();if _geg !=nil {continue ;};_bgg ,_geg :=_fgg (_add ,_baaa ,_gecb );if _geg !=nil {return _geg ;};if _bgg ==nil {continue ;};if _geg =(&_egcg [_bbe ]).SetData (_bgg );
_geg !=nil {return _geg ;};};};return nil ;};

// XmpOptions are the options used by the optimization of the XMP metadata.
type XmpOptions struct{

// Copyright information.
Copyright string ;

// OriginalDocumentID is the original document identifier.
// By default, if this field is empty the value is extracted from the XMP Metadata or generated UUID.
OriginalDocumentID string ;

// DocumentID is the original document identifier.
// By default, if this field is empty the value is extracted from the XMP Metadata or generated UUID.
DocumentID string ;

// InstanceID is the original document identifier.
// By default, if this field is empty the value is set to generated UUID.
InstanceID string ;

// NewDocumentVersion is a flag that defines if a document was overwritten.
// If the new document was created this should be true. On changing given document file, and overwriting it it should be true.
NewDocumentVersion bool ;

// MarshalIndent defines marshaling indent of the XMP metadata.
MarshalIndent string ;

// MarshalPrefix defines marshaling prefix of the XMP metadata.
MarshalPrefix string ;};func _cddg (_dcbe *_dd .PdfObjectDictionary )ViolatedRule {const (_efcc ="\u0036.\u0033\u002e\u0033\u002d\u0032";_fdea ="\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0054y\u0070\u0065\u0020\u0032\u0020\u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0061\u0072\u0065\u0020\u0075\u0073\u0065\u0064\u0020f\u006f\u0072 \u0072\u0065\u006e\u0064\u0065\u0072\u0069\u006e\u0067,\u0020\u0074\u0068\u0065\u0020\u0043\u0049\u0044\u0046\u006fn\u0074\u0020\u0064\u0069c\u0074\u0069o\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c \u0063\u006f\u006e\u0074\u0061i\u006e\u0020\u0061\u0020\u0043\u0049\u0044\u0054\u006f\u0047\u0049D\u004d\u0061\u0070\u0020\u0065\u006e\u0074\u0072\u0079\u0020\u0074\u0068\u0061\u0074\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020a\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006d\u0061\u0070\u0070\u0069\u006e\u0067\u0020\u0066\u0072\u006f\u006d\u0020\u0043\u0049\u0044\u0073\u0020\u0074\u006f\u0020\u0067\u006c\u0079\u0070\u0068\u0020\u0069\u006e\u0064\u0069c\u0065\u0073\u0020\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u006e\u0061\u006d\u0065\u0020\u0049d\u0065\u006e\u0074\u0069\u0074\u0079\u002c\u0020\u0061s d\u0065\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069n\u0020P\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072e\u006e\u0063\u0065\u0020\u0054a\u0062\u006c\u0065\u0020\u0035\u002e\u00313";
);var _afce string ;if _bdfd ,_cbe :=_dd .GetName (_dcbe .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_cbe {_afce =_bdfd .String ();};if _afce !="\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0032"{return _cf ;};if _dcbe .Get ("C\u0049\u0044\u0054\u006f\u0047\u0049\u0044\u004d\u0061\u0070")==nil {return _cgc (_efcc ,_fdea );
};return _cf ;};

// NewProfile1A creates a new Profile1A with given options.
func NewProfile1A (options *Profile1Options )*Profile1A {if options ==nil {options =DefaultProfile1Options ();};_edffc (options );return &Profile1A {profile1 {_dgba :*options ,_gbff :_dde ()}};};type standardType struct{_ecg int ;_bc string ;};func _efed (_dgeee *_bf .PdfFont ,_cddd *_dd .PdfObjectDictionary )ViolatedRule {const (_fcd ="\u0036.\u0033\u002e\u0037\u002d\u0032";
_dgfg ="\u0041l\u006c\u0020\u0073\u0079\u006d\u0062\u006f\u006c\u0069\u0063\u0020\u0054\u0072u\u0065\u0054\u0079p\u0065\u0020\u0066\u006f\u006e\u0074s\u0020\u0073h\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0073\u0070\u0065\u0063\u0069\u0066\u0079\u0020\u0061\u006e\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u0065n\u0074\u0072\u0079\u0020\u0069n\u0020\u0074\u0068e\u0020\u0066\u006f\u006e\u0074 \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e";
);var _cdc string ;if _fdbb ,_afcg :=_dd .GetName (_cddd .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_afcg {_cdc =_fdbb .String ();};if _cdc !="\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065"{return _cf ;};_eaad :=_dgeee .FontDescriptor ();_gacdg ,_cdgc :=_dd .GetIntVal (_eaad .Flags );
if !_cdgc {_ee .Log .Debug ("\u0066\u006c\u0061\u0067\u0073 \u006e\u006f\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0066o\u0072\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0070\u0074\u006f\u0072");
return _cgc (_fcd ,_dgfg );};_cafc :=(uint32 (_gacdg )>>3)&1;_daffg :=_cafc !=0;if !_daffg {return _cf ;};if _cddd .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067")!=nil {return _cgc (_fcd ,_dgfg );};return _cf ;};func _edef (_cddc *_bf .CompliancePdfReader )(_efce []ViolatedRule ){_eaee :=_cddc .GetObjectNums ();
for _ ,_aaee :=range _eaee {_cddf ,_ggc :=_cddc .GetIndirectObjectByNumber (_aaee );if _ggc !=nil {continue ;};_effee ,_fgfaa :=_dd .GetDict (_cddf );if !_fgfaa {continue ;};_ccbb ,_fgfaa :=_dd .GetName (_effee .Get ("\u0054\u0079\u0070\u0065"));if !_fgfaa {continue ;
};if _ccbb .String ()!="\u0046\u0069\u006c\u0065\u0073\u0070\u0065\u0063"{continue ;};if _effee .Get ("\u0045\u0046")!=nil {_efce =append (_efce ,_cgc ("\u0036\u002e\u0031\u002e\u0031\u0031\u002d\u0031","\u0041 \u0066\u0069\u006c\u0065 \u0073p\u0065\u0063\u0069\u0066\u0069\u0063\u0061\u0074\u0069o\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006fn\u0061\u0072\u0079\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066i\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046 \u0033\u002e\u0031\u0030\u002e\u0032\u002c\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063o\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0045\u0046 \u006be\u0079\u002e"));
break ;};};_ffd ,_debe :=_eecg (_cddc );if !_debe {return _efce ;};_ccea ,_debe :=_dd .GetDict (_ffd .Get ("\u004e\u0061\u006de\u0073"));if !_debe {return _efce ;};if _ccea .Get ("\u0045\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0046\u0069\u006c\u0065\u0073")!=nil {_efce =append (_efce ,_cgc ("\u0036\u002e\u0031\u002e\u0031\u0031\u002d\u0032","\u0041\u0020\u0066i\u006c\u0065\u0027\u0073\u0020\u006e\u0061\u006d\u0065\u0020d\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002c\u0020\u0061\u0073\u0020d\u0065\u0066\u0069\u006ee\u0064\u0020\u0069\u006e\u0020PD\u0046 \u0052\u0065\u0066er\u0065\u006e\u0063\u0065\u0020\u0033\u002e6\u002e\u0033\u002c\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074h\u0065\u0020\u0045m\u0062\u0065\u0064\u0064\u0065\u0064\u0046i\u006c\u0065\u0073\u0020\u006b\u0065\u0079\u002e"));
};return _efce ;};func _fcgc (_bba *_dc .Document )error {_eggd ,_agcc :=_bba .GetPages ();if !_agcc {return nil ;};for _ ,_bac :=range _eggd {_dac ,_bacg :=_dd .GetArray (_bac .Object .Get ("\u0041\u006e\u006e\u006f\u0074\u0073"));if !_bacg {continue ;
};for _ ,_baaaf :=range _dac .Elements (){_baaaf =_dd .ResolveReference (_baaaf );if _ ,_eccg :=_baaaf .(*_dd .PdfObjectNull );_eccg {continue ;};_cgbce ,_gbfd :=_dd .GetDict (_baaaf );if !_gbfd {continue ;};_eag ,_ :=_dd .GetIntVal (_cgbce .Get ("\u0046"));
_eag &=^(1<<0);_eag &=^(1<<1);_eag &=^(1<<5);_eag |=1<<2;_cgbce .Set ("\u0046",_dd .MakeInteger (int64 (_eag )));};};return nil ;};func _ggeg (_cdge *_bf .CompliancePdfReader )ViolatedRule {return _cf };func _ada (_bcc *_dc .Document ,_dga func ()_aa .Time )error {_dbg ,_cfbe :=_bf .NewPdfInfoFromObject (_bcc .Info );
if _cfbe !=nil {return _cfbe ;};if _efd :=_cbc (_dbg ,_dga );_efd !=nil {return _efd ;};_bcc .Info =_dbg .ToPdfObject ();return nil ;};func _cgc (_gb string ,_df string )ViolatedRule {return ViolatedRule {RuleNo :_gb ,Detail :_df }};var _cf =ViolatedRule {};
func _bacc (_cgf *_bf .CompliancePdfReader )(_ccbd []ViolatedRule ){var _cee ,_gecd ,_gbe bool ;if _cgf .ParserMetadata ().HasNonConformantStream (){_ccbd =[]ViolatedRule {_cgc ("\u0036.\u0031\u002e\u0037\u002d\u0031","T\u0068\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006b\u0065\u0079\u0077\u006fr\u0064\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020f\u006f\u006cl\u006fw\u0065\u0064\u0020e\u0069\u0074h\u0065\u0072\u0020\u0062\u0079\u0020\u0061 \u0043\u0041\u0052\u0052I\u0041\u0047\u0045\u0020\u0052E\u0054\u0055\u0052\u004e\u0020\u00280\u0044\u0068\u0029\u0020\u0061\u006e\u0064\u0020\u004c\u0049\u004e\u0045\u0020F\u0045\u0045\u0044\u0020\u0028\u0030\u0041\u0068\u0029\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0073\u0065\u0071\u0075\u0065\u006e\u0063\u0065\u0020o\u0072\u0020\u0062\u0079\u0020\u0061 \u0073\u0069ng\u006c\u0065\u0020\u004cIN\u0045 \u0046\u0045\u0045\u0044 \u0063\u0068\u0061r\u0061\u0063\u0074\u0065\u0072\u002e\u0020T\u0068\u0065\u0020e\u006e\u0064\u0073\u0074r\u0065\u0061\u006d\u0020\u006b\u0065\u0079\u0077\u006fr\u0064\u0020\u0073\u0068\u0061\u006c\u006c \u0062e\u0020p\u0072\u0065\u0063\u0065\u0064\u0065\u0064\u0020\u0062\u0079\u0020\u0061n\u0020\u0045\u004f\u004c \u006d\u0061\u0072\u006b\u0065\u0072\u002e")};
};for _ ,_dgad :=range _cgf .GetObjectNums (){_addf ,_ :=_cgf .GetIndirectObjectByNumber (_dgad );if _addf ==nil {continue ;};_cdga ,_bggd :=_dd .GetStream (_addf );if !_bggd {continue ;};if !_cee {_cce :=_cdga .Get ("\u004c\u0065\u006e\u0067\u0074\u0068");
if _cce ==nil {_ccbd =append (_ccbd ,_cgc ("\u0036.\u0031\u002e\u0037\u002d\u0032","\u006e\u006f\u0020'\u004c\u0065\u006e\u0067\u0074\u0068\u0027\u0020\u006b\u0065\u0079\u0020\u0066\u006f\u0075\u006e\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0073\u0074\u0072\u0065a\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074"));
_cee =true ;}else {_cffd ,_bef :=_dd .GetIntVal (_cce );if !_bef {_ccbd =append (_ccbd ,_cgc ("\u0036.\u0031\u002e\u0037\u002d\u0032","s\u0074\u0072\u0065\u0061\u006d\u0020\u0027\u004c\u0065\u006e\u0067\u0074\u0068\u0027\u0020\u006b\u0065\u0079 \u0073\u0068\u006f\u0075\u006c\u0064\u0020\u0062\u0065\u0020an\u0020\u0069\u006et\u0065g\u0065\u0072"));
_cee =true ;}else {if len (_cdga .Stream )!=_cffd {_ccbd =append (_ccbd ,_cgc ("\u0036.\u0031\u002e\u0037\u002d\u0032","\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006c\u0065\u006e\u0067th\u0020v\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020m\u0061\u0074\u0063\u0068\u0020\u0074\u0068\u0065\u0020\u0073\u0069\u007a\u0065\u0020\u006f\u0066\u0020t\u0068\u0065\u0020\u0073\u0074\u0072\u0065\u0061\u006d"));
_cee =true ;};};};};if !_gecd {if _cdga .Get ("\u0046")!=nil {_gecd =true ;_ccbd =append (_ccbd ,_cgc ("\u0036.\u0031\u002e\u0037\u002d\u0033","\u0073\u0074r\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020\u0027\u0046\u0027\u002c\u0027\u0046\u0046\u0069\u006c\u0074\u0065r\u0027\u002c'\u0046\u0044\u0065\u0063o\u0064\u0065\u0050\u0061\u0072a\u006d\u0073\u0027\u0020\u006b\u0065\u0079"));
};if _cdga .Get ("\u0046F\u0069\u006c\u0074\u0065\u0072")!=nil &&!_gecd {_gecd =true ;_ccbd =append (_ccbd ,_cgc ("\u0036.\u0031\u002e\u0037\u002d\u0033","\u0073\u0074r\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020\u0027\u0046\u0027\u002c\u0027\u0046\u0046\u0069\u006c\u0074\u0065r\u0027\u002c'\u0046\u0044\u0065\u0063o\u0064\u0065\u0050\u0061\u0072a\u006d\u0073\u0027\u0020\u006b\u0065\u0079"));
continue ;};if _cdga .Get ("\u0046\u0044\u0065\u0063\u006f\u0064\u0065\u0050\u0061\u0072\u0061\u006d\u0073")!=nil &&!_gecd {_gecd =true ;_ccbd =append (_ccbd ,_cgc ("\u0036.\u0031\u002e\u0037\u002d\u0033","\u0073\u0074r\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0068\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0063\u006f\u006e\u0074a\u0069\u006e\u0020\u0027\u0046\u0027\u002c\u0027\u0046\u0046\u0069\u006c\u0074\u0065r\u0027\u002c'\u0046\u0044\u0065\u0063o\u0064\u0065\u0050\u0061\u0072a\u006d\u0073\u0027\u0020\u006b\u0065\u0079"));
continue ;};};if !_gbe {_gafc ,_ebdb :=_dd .GetName (_dd .TraceToDirectObject (_cdga .Get ("\u0046\u0069\u006c\u0074\u0065\u0072")));if !_ebdb {continue ;};if *_gafc ==_dd .StreamEncodingFilterNameLZW {_gbe =true ;_ccbd =append (_ccbd ,_cgc ("\u0036\u002e\u0031\u002e\u0031\u0030\u002d\u0031","\u0054h\u0065\u0020L\u005a\u0057\u0044\u0065c\u006f\u0064\u0065 \u0066\u0069\u006c\u0074\u0065\u0072\u0020\u0073\u0068al\u006c\u0020\u006eo\u0074\u0020b\u0065\u0020\u0070\u0065\u0072\u006di\u0074\u0074e\u0064\u002e"));
};};};return _ccbd ;};func _aeeb (_dcce *_bf .CompliancePdfReader )(*_dd .PdfObjectDictionary ,bool ){_ccaf ,_abab :=_eecg (_dcce );if !_abab {return nil ,false ;};_ffda ,_abab :=_dd .GetArray (_ccaf .Get ("\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073"));
if !_abab {return nil ,false ;};if _ffda .Len ()==0{return nil ,false ;};return _dd .GetDict (_ffda .Get (0));};type documentImages struct{_bae ,_cgg ,_gf bool ;_dba map[_dd .PdfObject ]struct{};_ed []*imageInfo ;};func _addd (_dbafc *_bf .PdfFont ,_ffbf *_dd .PdfObjectDictionary )ViolatedRule {const (_accag ="\u0036.\u0033\u002e\u0037\u002d\u0033";
_ceeb ="\u0046\u006f\u006e\u0074\u0020\u0070\u0072\u006f\u0067\u0072\u0061\u006d\u0073\u0027\u0020\u0022\u0063\u006d\u0061\u0070\u0022\u0020\u0074\u0061\u0062\u006c\u0065\u0073\u0020\u0066\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0073\u0079\u006d\u0062o\u006c\u0069c\u0020\u0054\u0072\u0075e\u0054\u0079\u0070\u0065\u0020\u0066\u006f\u006e\u0074\u0073 \u0073\u0068\u0061\u006c\u006c\u0020\u0063\u006f\u006et\u0061\u0069\u006e\u0020\u0065\u0078\u0061\u0063\u0074\u006cy\u0020\u006f\u006ee\u0020\u0065\u006e\u0063\u006f\u0064\u0069n\u0067\u002e";
);var _dgeg string ;if _cega ,_dgeb :=_dd .GetName (_ffbf .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_dgeb {_dgeg =_cega .String ();};if _dgeg !="\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065"{return _cf ;};_dedb :=_dbafc .FontDescriptor ();_fgdd ,_ggfce :=_dd .GetIntVal (_dedb .Flags );
if !_ggfce {_ee .Log .Debug ("\u0066\u006c\u0061\u0067\u0073 \u006e\u006f\u0074\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0066o\u0072\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0070\u0074\u006f\u0072");
return _cgc (_accag ,_ceeb );};_fdeab :=(uint32 (_fgdd )>>3)!=0;if !_fdeab {return _cf ;};return _cf ;};func _adfc (_gfgg *_bf .CompliancePdfReader )(_efbe ViolatedRule ){_gbgf ,_dbea :=_eecg (_gfgg );if !_dbea {return _cf ;};_dcedf ,_dbea :=_dd .GetDict (_gbgf .Get ("\u0041\u0063\u0072\u006f\u0046\u006f\u0072\u006d"));
if !_dbea {return _cf ;};_bdcg ,_dbea :=_dd .GetArray (_dcedf .Get ("\u0046\u0069\u0065\u006c\u0064\u0073"));if !_dbea {return _cf ;};for _aebdf :=0;_aebdf < _bdcg .Len ();_aebdf ++{_gabe ,_cbbd :=_dd .GetDict (_bdcg .Get (_aebdf ));if !_cbbd {continue ;
};if _gabe .Get ("\u0041\u0041")!=nil {return _cgc ("\u0036.\u0036\u002e\u0032\u002d\u0032","\u0041\u0020F\u0069\u0065\u006cd\u0020\u0064\u0069\u0063\u0074i\u006f\u006e\u0061\u0072\u0079 s\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061n\u0020A\u0041\u0020\u0065\u006e\u0074\u0072y f\u006f\u0072\u0020\u0061\u006e\u0020\u0061\u0064\u0064\u0069\u0074\u0069on\u0061l\u002d\u0061\u0063\u0074i\u006fn\u0073 \u0064\u0069c\u0074\u0069on\u0061\u0072\u0079\u002e");
};};return _cf ;};func _aec (_gge *_dc .Document )error {_aba :=map[string ]*_dd .PdfObjectDictionary {};_da :=_fg .NewFinder (&_fg .FinderOpts {Extensions :[]string {"\u002e\u0074\u0074\u0066"}});_abaa :=map[_dd .PdfObject ]struct{}{};_ccb :=map[_dd .PdfObject ]struct{}{};
for _ ,_affa :=range _gge .Objects {_aad ,_bcgd :=_dd .GetDict (_affa );if !_bcgd {continue ;};_fff :=_aad .Get ("\u0054\u0079\u0070\u0065");if _fff ==nil {continue ;};if _gcf ,_gcg :=_dd .GetName (_fff );_gcg &&_gcf .String ()!="\u0046\u006f\u006e\u0074"{continue ;
};if _ ,_acc :=_abaa [_affa ];_acc {continue ;};_gebc ,_eedc :=_bf .NewPdfFontFromPdfObject (_aad );if _eedc !=nil {_ee .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0063\u006f\u0075\u006c\u0064\u0020\u006e\u006f\u0074\u0020\u006c\u006f\u0061\u0064\u0020\u0066\u006fn\u0074\u0020\u0066\u0072\u006fm\u0020\u006fb\u006a\u0065\u0063\u0074");
return _eedc ;};_ade ,_eedc :=_gebc .GetFontDescriptor ();if _eedc !=nil {return _eedc ;};if _ade !=nil &&(_ade .FontFile !=nil ||_ade .FontFile2 !=nil ||_ade .FontFile3 !=nil ){continue ;};_fcc :=_gebc .BaseFont ();if _fcc ==""{return _a .Errorf ("\u006f\u006e\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u006f\u0062\u006a\u0065c\u0074\u0073\u0020\u0073\u0079\u006e\u0074\u0061\u0078\u0020\u0069\u0073\u0020\u006e\u006f\u0074\u0020\u0076\u0061\u006c\u0069d\u0020\u002d\u0020\u0042\u0061\u0073\u0065\u0046\u006f\u006e\u0074\u0020\u0075\u006ed\u0065\u0066\u0069n\u0065\u0064\u003a\u0020\u0025\u0073",_aad .String ());
};_ega ,_cgd :=_aba [_fcc ];if !_cgd {if len (_fcc )> 7&&_fcc [6]=='+'{_fcc =_fcc [7:];};_abe :=[]string {_fcc ,"\u0054i\u006de\u0073\u0020\u004e\u0065\u0077\u0020\u0052\u006f\u006d\u0061\u006e","\u0041\u0072\u0069a\u006c","D\u0065\u006a\u0061\u0056\u0075\u0020\u0053\u0061\u006e\u0073"};
for _ ,_aac :=range _abe {_ee .Log .Debug ("\u0044\u0045\u0042\u0055\u0047\u003a \u0073\u0065\u0061\u0072\u0063\u0068\u0069\u006e\u0067\u0020\u0073\u0079\u0073t\u0065\u006d\u0020\u0066\u006f\u006e\u0074 \u0060\u0025\u0073\u0060",_aac );if _ega ,_cgd =_aba [_aac ];
_cgd {break ;};_gbb :=_da .Match (_aac );if _gbb ==nil {_ee .Log .Debug ("c\u006f\u0075\u006c\u0064\u0020\u006eo\u0074\u0020\u0066\u0069\u006e\u0064\u0020\u0066\u006fn\u0074\u0020\u0066i\u006ce\u0020\u0025\u0073",_aac );continue ;};_ffe ,_egga :=_bf .NewPdfFontFromTTFFile (_gbb .Filename );
if _egga !=nil {return _egga ;};_bce :=_ffe .FontDescriptor ();if _bce .FontFile !=nil {if _ ,_cgd =_ccb [_bce .FontFile ];!_cgd {_gge .Objects =append (_gge .Objects ,_bce .FontFile );_ccb [_bce .FontFile ]=struct{}{};};};if _bce .FontFile2 !=nil {if _ ,_cgd =_ccb [_bce .FontFile2 ];
!_cgd {_gge .Objects =append (_gge .Objects ,_bce .FontFile2 );_ccb [_bce .FontFile2 ]=struct{}{};};};if _bce .FontFile3 !=nil {if _ ,_cgd =_ccb [_bce .FontFile3 ];!_cgd {_gge .Objects =append (_gge .Objects ,_bce .FontFile3 );_ccb [_bce .FontFile3 ]=struct{}{};
};};_cfa ,_dcc :=_ffe .ToPdfObject ().(*_dd .PdfIndirectObject );if !_dcc {_ee .Log .Debug ("\u0066\u006f\u006e\u0074\u0020\u0069\u0073\u0020\u006e\u006ft\u0020\u0061\u006e\u0020\u0069\u006e\u0064i\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074");
continue ;};_ag ,_dcc :=_cfa .PdfObject .(*_dd .PdfObjectDictionary );if !_dcc {_ee .Log .Debug ("\u0046\u006fn\u0074\u0020\u0074\u0079p\u0065\u0020i\u0073\u0020\u006e\u006f\u0074\u0020\u0061\u006e \u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079");
continue ;};_aba [_aac ]=_ag ;_ega =_ag ;break ;};if _ega ==nil {_ee .Log .Debug ("\u004e\u006f\u0020\u006d\u0061\u0074\u0063\u0068\u0069\u006eg\u0020\u0066\u006f\u006e\u0074\u0020\u0066o\u0075\u006e\u0064\u0020\u0066\u006f\u0072\u003a\u0020\u0025\u0073",_gebc .BaseFont ());
return _fc .New ("\u006e\u006f m\u0061\u0074\u0063h\u0069\u006e\u0067\u0020fon\u0074 f\u006f\u0075\u006e\u0064\u0020\u0069\u006e t\u0068\u0065\u0020\u0073\u0079\u0073\u0074e\u006d");};};for _ ,_ecda :=range _ega .Keys (){_aad .Set (_ecda ,_ega .Get (_ecda ));
};_ggea :=_ega .Get ("\u0057\u0069\u0064\u0074\u0068\u0073");if _ggea !=nil {if _ ,_cgd =_ccb [_ggea ];!_cgd {_gge .Objects =append (_gge .Objects ,_ggea );_ccb [_ggea ]=struct{}{};};};_abaa [_affa ]=struct{}{};_ecb :=_aad .Get ("\u0046\u006f\u006e\u0074\u0044\u0065\u0073\u0063\u0072i\u0070\u0074\u006f\u0072");
if _ecb !=nil {_gge .Objects =append (_gge .Objects ,_ecb );_ccb [_ecb ]=struct{}{};};};return nil ;};func _dfd (_edeb *_bf .CompliancePdfReader )ViolatedRule {_fddc ,_edaa :=_edeb .GetTrailer ();if _edaa !=nil {_ee .Log .Debug ("\u0043\u0061\u006en\u006f\u0074\u0020\u0067e\u0074\u0020\u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0074\u0072\u0061\u0069\u006c\u0065\u0072\u003a\u0020\u0025\u0076",_edaa );
return _cf ;};_eefge ,_fdef :=_fddc .Get ("\u0052\u006f\u006f\u0074").(*_dd .PdfObjectReference );if !_fdef {_ee .Log .Debug ("\u0043a\u006e\u006e\u006f\u0074 \u0066\u0069\u006e\u0064\u0020d\u006fc\u0075m\u0065\u006e\u0074\u0020\u0072\u006f\u006ft");return _cf ;
};_adde ,_fdef :=_dd .GetDict (_dd .ResolveReference (_eefge ));if !_fdef {_ee .Log .Debug ("\u0063\u0061\u006e\u006e\u006f\u0074 \u0072\u0065\u0073\u006f\u006c\u0076\u0065\u0020\u0063\u0061\u0074\u0061\u006co\u0067\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079");
return _cf ;};if _adde .Get ("\u004f\u0043\u0050r\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073")!=nil {return _cgc ("\u0036\u002e\u0031\u002e\u0031\u0033\u002d\u0031","\u0054\u0068\u0065\u0020\u0064\u006f\u0063u\u006d\u0065\u006e\u0074\u0020\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0020s\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u0020\u006b\u0065\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0074\u0068\u0065\u0020\u006e\u0061\u006d\u0065\u0020\u004f\u0043\u0050\u0072\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073");
};return _cf ;};func _ffbdde (_ebefb *_bf .CompliancePdfReader )(_ggdg []ViolatedRule ){_gcfg :=true ;_bfbc ,_ageb :=_ebefb .GetCatalogMarkInfo ();if !_ageb {_gcfg =false ;}else {_gafca ,_bfbb :=_dd .GetDict (_bfbc );if _bfbb {_bccd ,_baca :=_dd .GetBool (_gafca .Get ("\u004d\u0061\u0072\u006b\u0065\u0064"));
if !bool (*_bccd )||!_baca {_gcfg =false ;};}else {_gcfg =false ;};};if !_gcfg {_ggdg =append (_ggdg ,_cgc ("\u0036.\u0038\u002e\u0032\u002d\u0031","\u0054\u0068\u0065\u0020\u0064\u006f\u0063\u0075\u006d\u0065\u006e\u0074\u0020\u0063\u0061\u0074\u0061\u006cog\u0020d\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061\u0020M\u0061r\u006b\u0049\u006e\u0066\u006f\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0061 \u004d\u0061\u0072\u006b\u0065\u0064\u0020\u0065\u006et\u0072\u0079\u0020\u0069\u006e\u0020\u0069\u0074,\u0020\u0077\u0068\u006f\u0073\u0065\u0020\u0076\u0061lu\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0074\u0072\u0075\u0065"));
};_ ,_ageb =_ebefb .GetCatalogStructTreeRoot ();if !_ageb {_ggdg =append (_ggdg ,_cgc ("\u0036.\u0038\u002e\u0033\u002d\u0031","\u0054\u0068\u0065\u0020\u006c\u006f\u0067\u0069\u0063\u0061\u006c\u0020\u0073\u0074\u0072\u0075\u0063\u0074\u0075r\u0065\u0020\u006f\u0066\u0020\u0074\u0068e\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067 \u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0062\u0065d \u0062\u0079\u0020a\u0020s\u0074\u0072\u0075\u0063\u0074\u0075\u0072e\u0020\u0068\u0069\u0065\u0072\u0061\u0072\u0063\u0068\u0079\u0020\u0072\u006f\u006ft\u0065\u0064\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0053\u0074\u0072\u0075\u0063\u0074\u0054\u0072\u0065\u0065\u0052\u006f\u006f\u0074\u0020\u0065\u006e\u0074r\u0079\u0020\u006f\u0066\u0020\u0074h\u0065\u0020d\u006fc\u0075\u006d\u0065\u006e\u0074\u0020\u0063\u0061t\u0061\u006c\u006fg \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0073\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069n\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065 \u0039\u002e\u0036\u002e"));
};return _ggdg ;};func _cfgee (_aga *_bf .CompliancePdfReader )ViolatedRule {_geca ,_fadf :=_aga .PdfReader .GetTrailer ();if _fadf !=nil {return _cgc ("\u0036.\u0031\u002e\u0033\u002d\u0031","\u006d\u0069\u0073s\u0069\u006e\u0067\u0020t\u0072\u0061\u0069\u006c\u0065\u0072\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0064\u006f\u0063\u0075\u006d\u0065\u006e\u0074");
};if _geca .Get ("\u0049\u0044")==nil {return _cgc ("\u0036.\u0031\u002e\u0033\u002d\u0031","\u0054\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0020\u0074\u0072\u0061\u0069\u006c\u0065\u0072\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068a\u006c\u006c\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074\u0068e\u0020\u0027\u0049\u0044\u0027\u0020k\u0065\u0079\u0077o\u0072\u0064");
};if _geca .Get ("\u0045n\u0063\u0072\u0079\u0070\u0074")!=nil {return _cgc ("\u0036.\u0031\u002e\u0033\u002d\u0032","\u0054\u0068\u0065\u0020\u006b\u0065y\u0077\u006f\u0072\u0064\u0020'\u0045\u006e\u0063\u0072\u0079\u0070t\u0027\u0020\u0073\u0068\u0061l\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0075\u0073\u0065d\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0074\u0072\u0061\u0069\u006c\u0065\u0072 \u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079\u002e\u0020");
};return _cf ;};func _fgea (_cdff *_bf .CompliancePdfReader )(_cacf []ViolatedRule ){var _fcac ,_edeg ,_ffbd ,_cbb ,_agbf ,_gcab bool ;_daaf :=map[*_dd .PdfObjectStream ]struct{}{};for _ ,_gceg :=range _cdff .GetObjectNums (){if _fcac &&_edeg &&_agbf &&_ffbd &&_cbb &&_gcab {return _cacf ;
};_ggcg ,_bcdd :=_cdff .GetIndirectObjectByNumber (_gceg );if _bcdd !=nil {continue ;};_eafg ,_dbbe :=_dd .GetStream (_ggcg );if !_dbbe {continue ;};if _ ,_dbbe =_daaf [_eafg ];_dbbe {continue ;};_daaf [_eafg ]=struct{}{};_ffad ,_dbbe :=_dd .GetName (_eafg .Get ("\u0053u\u0062\u0054\u0079\u0070\u0065"));
if !_dbbe {continue ;};if !_cbb {if _eafg .Get ("\u0052\u0065\u0066")!=nil {_cacf =append (_cacf ,_cgc ("\u0036.\u0032\u002e\u0036\u002d\u0031","\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068a\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0058O\u0062\u006a\u0065\u0063\u0074s\u002e"));
_cbb =true ;};};if _ffad .String ()=="\u0050\u0053"{if !_gcab {_cacf =append (_cacf ,_cgc ("\u0036.\u0032\u002e\u0037\u002d\u0031","A \u0063\u006fn\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066i\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0050\u006f\u0073t\u0053c\u0072\u0069\u0070\u0074\u0020\u0058\u004f\u0062j\u0065c\u0074\u0073."));
continue ;};};if _ffad .String ()=="\u0046\u006f\u0072\u006d"{if _edeg &&_ffbd &&_cbb {continue ;};if !_edeg &&_eafg .Get ("\u004f\u0050\u0049")!=nil {_cacf =append (_cacf ,_cgc ("\u0036.\u0032\u002e\u0034\u002d\u0032","\u0041\u006e\u0020\u0058\u004f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072y\u0020\u0028\u0049\u006d\u0061\u0067\u0065\u0020\u006f\u0072\u0020\u0046\u006f\u0072\u006d\u0029\u0020\u0073\u0068\u0061\u006cl\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074h\u0065\u0020\u004fP\u0049\u0020\u006b\u0065\u0079\u002e"));
_edeg =true ;};if !_ffbd {if _eafg .Get ("\u0050\u0053")!=nil {_ffbd =true ;};if _afcc :=_eafg .Get ("\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032");_afcc !=nil &&!_ffbd {if _acg ,_cegf :=_dd .GetName (_afcc );_cegf &&*_acg =="\u0050\u0053"{_ffbd =true ;
};};if _ffbd {_cacf =append (_cacf ,_cgc ("\u0036.\u0032\u002e\u0035\u002d\u0031","A\u0020\u0066\u006fr\u006d\u0020\u0058\u004f\u0062\u006a\u0065\u0063\u0074\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006ft\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e \u0074\u0068\u0065\u0020\u0053\u0075\u0062\u0074\u0079\u0070\u0065\u0032\u0020\u006b\u0065\u0079 \u0077\u0069\u0074\u0068\u0020a\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0050\u0053\u0020o\u0072\u0020\u0074\u0068e\u0020\u0050\u0053\u0020\u006b\u0065\u0079\u002e"));
};};continue ;};if _ffad .String ()!="\u0049\u006d\u0061g\u0065"{continue ;};if !_fcac &&_eafg .Get ("\u0041\u006c\u0074\u0065\u0072\u006e\u0061\u0074\u0065\u0073")!=nil {_cacf =append (_cacf ,_cgc ("\u0036.\u0032\u002e\u0034\u002d\u0031","\u0041\u006e\u0020\u0049m\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006et\u0061\u0069\u006e\u0020\u0074h\u0065\u0020\u0041\u006c\u0074\u0065\u0072\u006e\u0061\u0074\u0065\u0073\u0020\u006b\u0065\u0079\u002e"));
_fcac =true ;};if !_agbf &&_eafg .Get ("I\u006e\u0074\u0065\u0072\u0070\u006f\u006c\u0061\u0074\u0065")!=nil {_bbab ,_aafge :=_dd .GetBool (_eafg .Get ("I\u006e\u0074\u0065\u0072\u0070\u006f\u006c\u0061\u0074\u0065"));if _aafge &&bool (*_bbab ){continue ;
};_cacf =append (_cacf ,_cgc ("\u0036.\u0032\u002e\u0034\u002d\u0033","\u0049\u0066 a\u006e\u0020\u0049\u006d\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0063o\u006e\u0074\u0061\u0069n\u0073\u0020\u0074\u0068e \u0049\u006et\u0065r\u0070\u006f\u006c\u0061\u0074\u0065 \u006b\u0065\u0079,\u0020\u0069t\u0073\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020b\u0065\u0020\u0066\u0061\u006c\u0073\u0065\u002e"));
_agbf =true ;};};return _cacf ;};func _dbacf (_gffa *_bf .CompliancePdfReader )ViolatedRule {if _gffa .ParserMetadata ().HeaderPosition ()!=0{return _cgc ("\u0036.\u0031\u002e\u0032\u002d\u0031","h\u0065\u0061\u0064\u0065\u0072\u0020\u0070\u006f\u0073\u0069\u0074\u0069\u006f\u006e\u0020\u0069\u0073\u0020n\u006f\u0074\u0020\u0061\u0074\u0020\u0074\u0068\u0065\u0020fi\u0072\u0073\u0074 \u0062y\u0074\u0065");
};return _cf ;};func _eecg (_cgeed *_bf .CompliancePdfReader )(*_dd .PdfObjectDictionary ,bool ){_ccca ,_eeca :=_cgeed .GetTrailer ();if _eeca !=nil {_ee .Log .Debug ("\u0043\u0061\u006en\u006f\u0074\u0020\u0067e\u0074\u0020\u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0074\u0072\u0061\u0069\u006c\u0065\u0072\u003a\u0020\u0025\u0076",_eeca );
return nil ,false ;};_ebdd ,_dabd :=_ccca .Get ("\u0052\u006f\u006f\u0074").(*_dd .PdfObjectReference );if !_dabd {_ee .Log .Debug ("\u0043a\u006e\u006e\u006f\u0074 \u0066\u0069\u006e\u0064\u0020d\u006fc\u0075m\u0065\u006e\u0074\u0020\u0072\u006f\u006ft");
return nil ,false ;};_fgga ,_dabd :=_dd .GetDict (_dd .ResolveReference (_ebdd ));if !_dabd {_ee .Log .Debug ("\u0063\u0061\u006e\u006e\u006f\u0074 \u0072\u0065\u0073\u006f\u006c\u0076\u0065\u0020\u0063\u0061\u0074\u0061\u006co\u0067\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079");
return nil ,false ;};return _fgga ,true ;};func _cfeg (_fega *_dc .Document ,_gdec standardType ,_aacd *_dc .OutputIntents )error {var (_fcg *_bf .PdfOutputIntent ;_bbfb error ;);if _fega .Version .Minor <=4{_fcg ,_bbfb =_egg .NewSRGBv2OutputIntent (_gdec .outputIntentSubtype ());
}else {_fcg ,_bbfb =_egg .NewSRGBv4OutputIntent (_gdec .outputIntentSubtype ());};if _bbfb !=nil {return _bbfb ;};if _bbfb =_aacd .Add (_fcg .ToPdfObject ());_bbfb !=nil {return _bbfb ;};return nil ;};func _fcae (_cegg *_bf .CompliancePdfReader )ViolatedRule {return _cf };
func _bfe (_gfdf *_bf .CompliancePdfReader )(_fage []ViolatedRule ){var _bcfd ,_gfea bool ;_afef :=func ()bool {return _bcfd &&_gfea };for _ ,_caaf :=range _gfdf .GetObjectNums (){_fgcg ,_gffgd :=_gfdf .GetIndirectObjectByNumber (_caaf );if _gffgd !=nil {_ee .Log .Debug ("G\u0065\u0074\u0074\u0069\u006e\u0067\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068 \u006e\u0075\u006d\u0062\u0065\u0072\u0020\u0025\u0064\u0020fa\u0069\u006c\u0065d\u003a \u0025\u0076",_caaf ,_gffgd );
continue ;};_aafbe ,_adbg :=_dd .GetDict (_fgcg );if !_adbg {continue ;};_dfgc ,_adbg :=_dd .GetName (_aafbe .Get ("\u0054\u0079\u0070\u0065"));if !_adbg {continue ;};if *_dfgc !="\u0041\u0063\u0074\u0069\u006f\u006e"{continue ;};_efeb ,_adbg :=_dd .GetName (_aafbe .Get ("\u0053"));
if !_adbg {if !_bcfd {_fage =append (_fage ,_cgc ("\u0036.\u0036\u002e\u0031\u002d\u0031","\u0054\u0068\u0065\u0020\u004c\u0061\u0075\u006e\u0063\u0068\u002c\u0020\u0053\u006f\u0075\u006e\u0064\u002c\u0020\u004d\u006f\u0076\u0069\u0065\u002c\u0020\u0052\u0065\u0073\u0065\u0074\u0046o\u0072\u006d\u002c\u0020\u0049\u006d\u0070\u006f\u0072\u0074\u0044\u0061\u0074\u0061\u0020\u0061\u006e\u0064 \u004a\u0061\u0076a\u0053\u0063\u0072\u0069\u0070\u0074\u0020\u0061\u0063\u0074\u0069\u006f\u006e\u0073\u0020s\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074e\u0064\u002e \u0041\u0064\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u002c\u0020th\u0065\u0020\u0064\u0065p\u0072\u0065\u0063\u0061\u0074\u0065\u0064\u0020s\u0065\u0074\u002d\u0073\u0074\u0061\u0074\u0065\u0020\u0061\u006e\u0064\u0020\u006e\u006f\u002d\u006f\u0070\u0020\u0061\u0063\u0074\u0069\u006f\u006e\u0073\u0020\u0073\u0068a\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062e\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074e\u0064\u002e\u0020T\u0068\u0065\u0020\u0048\u0069\u0064\u0065\u0020a\u0063\u0074\u0069\u006f\u006e \u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_bcfd =true ;if _afef (){return _fage ;};};continue ;};switch _bf .PdfActionType (*_efeb ){case _bf .ActionTypeLaunch ,_bf .ActionTypeSound ,_bf .ActionTypeMovie ,_bf .ActionTypeResetForm ,_bf .ActionTypeImportData ,_bf .ActionTypeJavaScript :if !_bcfd {_fage =append (_fage ,_cgc ("\u0036.\u0036\u002e\u0031\u002d\u0031","\u0054\u0068\u0065\u0020\u004c\u0061\u0075\u006e\u0063\u0068\u002c\u0020\u0053\u006f\u0075\u006e\u0064\u002c\u0020\u004d\u006f\u0076\u0069\u0065\u002c\u0020\u0052\u0065\u0073\u0065\u0074\u0046o\u0072\u006d\u002c\u0020\u0049\u006d\u0070\u006f\u0072\u0074\u0044\u0061\u0074\u0061\u0020\u0061\u006e\u0064 \u004a\u0061\u0076a\u0053\u0063\u0072\u0069\u0070\u0074\u0020\u0061\u0063\u0074\u0069\u006f\u006e\u0073\u0020s\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074e\u0064\u002e \u0041\u0064\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u006c\u0079\u002c\u0020th\u0065\u0020\u0064\u0065p\u0072\u0065\u0063\u0061\u0074\u0065\u0064\u0020s\u0065\u0074\u002d\u0073\u0074\u0061\u0074\u0065\u0020\u0061\u006e\u0064\u0020\u006e\u006f\u002d\u006f\u0070\u0020\u0061\u0063\u0074\u0069\u006f\u006e\u0073\u0020\u0073\u0068a\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062e\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074e\u0064\u002e\u0020T\u0068\u0065\u0020\u0048\u0069\u0064\u0065\u0020a\u0063\u0074\u0069\u006f\u006e \u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_bcfd =true ;if _afef (){return _fage ;};};continue ;case _bf .ActionTypeNamed :if !_gfea {_ceacf ,_eaae :=_dd .GetName (_aafbe .Get ("\u004e"));if !_eaae {_fage =append (_fage ,_cgc ("\u0036.\u0036\u002e\u0031\u002d\u0032","N\u0061\u006d\u0065\u0064\u0020\u0061\u0063t\u0069\u006f\u006e\u0073\u0020\u006f\u0074\u0068e\u0072\u0020\u0074h\u0061\u006e\u0020\u004e\u0065\u0078\u0074\u0050\u0061\u0067\u0065\u002c\u0020P\u0072\u0065v\u0050\u0061\u0067\u0065\u002c\u0020\u0046\u0069\u0072\u0073\u0074\u0050a\u0067e\u002c\u0020\u0061\u006e\u0064\u0020\u004c\u0061\u0073\u0074\u0050\u0061\u0067\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_gfea =true ;if _afef (){return _fage ;};continue ;};switch *_ceacf {case "\u004e\u0065\u0078\u0074\u0050\u0061\u0067\u0065","\u0050\u0072\u0065\u0076\u0050\u0061\u0067\u0065","\u0046i\u0072\u0073\u0074\u0050\u0061\u0067e","\u004c\u0061\u0073\u0074\u0050\u0061\u0067\u0065":default:_fage =append (_fage ,_cgc ("\u0036.\u0036\u002e\u0031\u002d\u0032","N\u0061\u006d\u0065\u0064\u0020\u0061\u0063t\u0069\u006f\u006e\u0073\u0020\u006f\u0074\u0068e\u0072\u0020\u0074h\u0061\u006e\u0020\u004e\u0065\u0078\u0074\u0050\u0061\u0067\u0065\u002c\u0020P\u0072\u0065v\u0050\u0061\u0067\u0065\u002c\u0020\u0046\u0069\u0072\u0073\u0074\u0050a\u0067e\u002c\u0020\u0061\u006e\u0064\u0020\u004c\u0061\u0073\u0074\u0050\u0061\u0067\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u0070\u0065\u0072\u006d\u0069\u0074\u0074\u0065\u0064\u002e"));
_gfea =true ;if _afef (){return _fage ;};continue ;};};};};return _fage ;};

// ViolatedRule is the structure that defines violated PDF/A rule.
type ViolatedRule struct{RuleNo string ;Detail string ;};func _gadc (_faga *_bf .CompliancePdfReader )(_gfga ViolatedRule ){for _ ,_gaedc :=range _faga .GetObjectNums (){_aebg ,_ggbg :=_faga .GetIndirectObjectByNumber (_gaedc );if _ggbg !=nil {continue ;
};_ead ,_bbcf :=_dd .GetStream (_aebg );if !_bbcf {continue ;};_aggbc ,_bbcf :=_dd .GetName (_ead .Get ("\u0054\u0079\u0070\u0065"));if !_bbcf {continue ;};if *_aggbc !="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;};_fbf ,_bbcf :=_dd .GetName (_ead .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));
if !_bbcf {continue ;};if *_fbf =="\u0050\u0053"{return _cgc ("\u0036.\u0032\u002e\u0037\u002d\u0031","A \u0063\u006fn\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066i\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0050\u006f\u0073t\u0053c\u0072\u0069\u0070\u0074\u0020\u0058\u004f\u0062j\u0065c\u0074\u0073.");
};};return _gfga ;};func (_gg *documentImages )hasUncalibratedImages ()bool {return _gg ._bae ||_gg ._cgg ||_gg ._gf };func _dega (_cfbc *_bf .PdfFont ,_dgeea *_dd .PdfObjectDictionary ,_gcgc bool )ViolatedRule {const (_dbdf ="\u0036.\u0033\u002e\u0034\u002d\u0031";
_cccbd ="\u0054\u0068\u0065\u0020\u0066\u006f\u006et\u0020\u0070\u0072\u006f\u0067\u0072\u0061\u006d\u0073\u0020\u0066\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0075\u0073\u0065\u0064\u0020\u0077\u0069\u0074\u0068\u0069\u006e \u0061\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069l\u0065\u0020s\u0068\u0061\u006cl\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065\u0064\u0020\u0077\u0069\u0074\u0068i\u006e\u0020\u0074h\u0061\u0074\u0020\u0066\u0069\u006ce\u002c\u0020a\u0073\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052e\u0066\u0065\u0072\u0065\u006e\u0063\u0065 \u0035\u002e\u0038\u002c\u0020\u0065\u0078\u0063\u0065\u0070\u0074\u0020\u0077h\u0065\u006e\u0020\u0074\u0068\u0065 \u0066\u006f\u006e\u0074\u0073\u0020\u0061\u0072\u0065\u0020\u0075\u0073\u0065\u0064\u0020\u0065\u0078\u0063\u006cu\u0073i\u0076\u0065\u006c\u0079\u0020\u0077\u0069t\u0068\u0020\u0074\u0065\u0078\u0074\u0020\u0072e\u006ed\u0065\u0072\u0069\u006e\u0067\u0020\u006d\u006f\u0064\u0065\u0020\u0033\u002e";
);if _gcgc {return _cf ;};_dcfd :=_cfbc .FontDescriptor ();var _cfd string ;if _caf ,_becf :=_dd .GetName (_dgeea .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_becf {_cfd =_caf .String ();};switch _cfd {case "\u0054\u0079\u0070e\u0031":if _dcfd .FontFile ==nil {return _cgc (_dbdf ,_cccbd );
};case "\u0054\u0072\u0075\u0065\u0054\u0079\u0070\u0065":if _dcfd .FontFile2 ==nil {return _cgc (_dbdf ,_cccbd );};case "\u0054\u0079\u0070e\u0030","\u0054\u0079\u0070e\u0033":default:if _dcfd .FontFile3 ==nil {return _cgc (_dbdf ,_cccbd );};};return _cf ;
};func _egb (_dce *_dc .Document )error {_ga ,_gca :=_dce .GetPages ();if !_gca {return nil ;};for _ ,_dbae :=range _ga {_dee ,_afe :=_dbae .GetResources ();if !_afe {continue ;};_aff ,_abg :=_dd .GetDict (_dee .Get ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074e"));
if !_abg {return nil ;};_fbbb :=_aff .Keys ();for _ ,_cfb :=range _fbbb {_fbe ,_gead :=_dd .GetDict (_aff .Get (_cfb ));if !_gead {continue ;};if _fe :=_fbe .Get ("\u0053\u004d\u0061s\u006b");_fe !=nil {_fbe .Set ("\u0053\u004d\u0061s\u006b",_dd .MakeName ("\u004e\u006f\u006e\u0065"));
};_aae :=_fbe .Get ("\u0043\u0041");if _aae !=nil {_be ,_ebef :=_dd .GetNumberAsFloat (_aae );if _ebef !=nil {_ee .Log .Debug ("\u0045x\u0074\u0047S\u0074\u0061\u0074\u0065 \u006f\u0062\u006ae\u0063\u0074\u0020\u0043\u0041\u0020\u0076\u0061\u006cue\u0020\u0069\u0073 \u006e\u006ft\u0020\u0061\u0020\u0066\u006c\u006fa\u0074\u003a \u0025\u0076",_ebef );
_be =0;};if _be !=1.0{_fbe .Set ("\u0043\u0041",_dd .MakeFloat (1.0));};};_aae =_fbe .Get ("\u0063\u0061");if _aae !=nil {_ceb ,_egd :=_dd .GetNumberAsFloat (_aae );if _egd !=nil {_ee .Log .Debug ("\u0045\u0078t\u0047\u0053\u0074\u0061\u0074\u0065\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0027\u0063\u0061\u0027\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u0073\u0020\u006e\u006f\u0074\u0020\u0061\u0020\u0066\u006c\u006f\u0061\u0074\u003a\u0020\u0025\u0076",_egd );
_ceb =0;};if _ceb !=1.0{_fbe .Set ("\u0063\u0061",_dd .MakeFloat (1.0));};};_cfe :=_fbe .Get ("\u0042\u004d");if _cfe !=nil {_gac ,_cgaa :=_dd .GetName (_cfe );if _cgaa {_ee .Log .Debug ("E\u0078\u0074\u0047\u0053\u0074\u0061t\u0065\u0020\u006f\u0062\u006a\u0065c\u0074\u0020\u0027\u0042\u004d\u0027\u0020i\u0073\u0020\u006e\u006f\u0074\u0020\u0061\u0020\u004e\u0061m\u0065");
_gac =_dd .MakeName ("");};_cec :=_gac .String ();switch _cec {case "\u004e\u006f\u0072\u006d\u0061\u006c","\u0043\u006f\u006d\u0070\u0061\u0074\u0069\u0062\u006c\u0065":default:_fbe .Set ("\u0042\u004d",_dd .MakeName ("\u004e\u006f\u0072\u006d\u0061\u006c"));
};};};};return nil ;};func (_deg *documentImages )hasOnlyDeviceRGB ()bool {return _deg ._bae &&!_deg ._cgg &&!_deg ._gf };

// Conformance gets the PDF/A conformance.
func (_aecd *profile1 )Conformance ()string {return _aecd ._gbff ._bc };func _cggga (_gaed *_dc .Document ,_dffcb *_dc .Page ,_aaf []*_dc .Image )error {for _ ,_gefa :=range _aaf {if _gefa .SMask ==nil {continue ;};_afa ,_gedd :=_bf .NewXObjectImageFromStream (_gefa .Stream );
if _gedd !=nil {return _gedd ;};_debg ,_gedd :=_afa .ToImage ();if _gedd !=nil {return _gedd ;};_eeg ,_gedd :=_debg .ToGoImage ();if _gedd !=nil {return _gedd ;};_aaed ,_gedd :=_d .RGBAConverter .Convert (_eeg );if _gedd !=nil {return _gedd ;};_eeaag :=_aaed .Base ();
_gfg :=&_bf .Image {Width :int64 (_eeaag .Width ),Height :int64 (_eeaag .Height ),BitsPerComponent :int64 (_eeaag .BitsPerComponent ),ColorComponents :_eeaag .ColorComponents ,Data :_eeaag .Data };_gfg .SetDecode (_eeaag .Decode );_gfg .SetAlpha (_eeaag .Alpha );
if _gedd =_afa .SetImage (_gfg ,nil );_gedd !=nil {return _gedd ;};_afa .SMask =_dd .MakeNull ();var _dgb _dd .PdfObject ;_efa :=-1;for _efa ,_dgb =range _gaed .Objects {if _dgb ==_gefa .SMask .Stream {break ;};};if _efa !=-1{_gaed .Objects =append (_gaed .Objects [:_efa ],_gaed .Objects [_efa +1:]...);
};_gefa .SMask =nil ;_afa .ToPdfObject ();};return nil ;};func _ccgad (_deef *_bf .PdfInfo ,_dage *_fce .Document )bool {_bafg ,_cafb :=_dage .GetPdfInfo ();if !_cafb {return false ;};if _bafg .InfoDict ==nil {return false ;};_fgbb ,_ecca :=_bf .NewPdfInfoFromObject (_bafg .InfoDict );
if _ecca !=nil {return false ;};if _deef .Creator !=nil {if _fgbb .Creator ==nil ||_fgbb .Creator .String ()!=_deef .Creator .String (){return false ;};};if _deef .CreationDate !=nil {if _fgbb .CreationDate ==nil ||!_fgbb .CreationDate .ToGoTime ().Equal (_deef .CreationDate .ToGoTime ()){return false ;
};};if _deef .ModifiedDate !=nil {if _fgbb .ModifiedDate ==nil ||!_fgbb .ModifiedDate .ToGoTime ().Equal (_deef .ModifiedDate .ToGoTime ()){return false ;};};if _deef .Producer !=nil {if _fgbb .Producer ==nil ||_fgbb .Producer .String ()!=_deef .Producer .String (){return false ;
};};if _deef .Keywords !=nil {if _fgbb .Keywords ==nil ||_fgbb .Keywords .String ()!=_deef .Keywords .String (){return false ;};};if _deef .Trapped !=nil {if _fgbb .Trapped ==nil {return false ;};switch _deef .Trapped .String (){case "\u0054\u0072\u0075\u0065":if _fgbb .Trapped .String ()!="\u0054\u0072\u0075\u0065"{return false ;
};case "\u0046\u0061\u006cs\u0065":if _fgbb .Trapped .String ()!="\u0046\u0061\u006cs\u0065"{return false ;};default:if _fgbb .Trapped .String ()!="\u0046\u0061\u006cs\u0065"{return false ;};};};if _deef .Title !=nil {if _fgbb .Title ==nil ||_fgbb .Title .String ()!=_deef .Title .String (){return false ;
};};if _deef .Subject !=nil {if _fgbb .Subject ==nil ||_fgbb .Subject .String ()!=_deef .Subject .String (){return false ;};};return true ;};func _dgfd (_gbf []*_dc .Image ,_aeg bool )error {_efc :=_dd .PdfObjectName ("\u0044e\u0076\u0069\u0063\u0065\u0052\u0047B");
if _aeg {_efc ="\u0044\u0065\u0076\u0069\u0063\u0065\u0043\u004d\u0059\u004b";};for _ ,_eed :=range _gbf {if _eed .Colorspace ==_efc {continue ;};_ace ,_fcb :=_bf .NewXObjectImageFromStream (_eed .Stream );if _fcb !=nil {return _fcb ;};_bcf ,_fcb :=_ace .ToImage ();
if _fcb !=nil {return _fcb ;};_ebe ,_fcb :=_bcf .ToGoImage ();if _fcb !=nil {return _fcb ;};var _cbf _bf .PdfColorspace ;if _aeg {_cbf =_bf .NewPdfColorspaceDeviceCMYK ();_ebe ,_fcb =_d .CMYKConverter .Convert (_ebe );}else {_cbf =_bf .NewPdfColorspaceDeviceRGB ();
_ebe ,_fcb =_d .NRGBAConverter .Convert (_ebe );};if _fcb !=nil {return _fcb ;};_cca ,_fdf :=_ebe .(_d .Image );if !_fdf {return _fc .New ("\u0069\u006d\u0061\u0067\u0065\u0020\u0064\u006f\u0065\u0073\u006e\u0027\u0074 \u0069\u006d\u0070\u006c\u0065\u006de\u006e\u0074\u0020\u0069\u006d\u0061\u0067\u0065\u0075\u0074\u0069\u006c\u002eI\u006d\u0061\u0067\u0065");
};_fdfa :=_cca .Base ();_fgfb :=&_bf .Image {Width :int64 (_fdfa .Width ),Height :int64 (_fdfa .Height ),BitsPerComponent :int64 (_fdfa .BitsPerComponent ),ColorComponents :_fdfa .ColorComponents ,Data :_fdfa .Data };_fgfb .SetDecode (_fdfa .Decode );_fgfb .SetAlpha (_fdfa .Alpha );
if _fcb =_ace .SetImage (_fgfb ,_cbf );_fcb !=nil {return _fcb ;};_ace .ToPdfObject ();_eed .ColorComponents =_fdfa .ColorComponents ;_eed .Colorspace =_efc ;};return nil ;};

// StandardName gets the name of the standard.
func (_dedf *profile1 )StandardName ()string {return _a .Sprintf ("\u0050D\u0046\u002f\u0041\u002d\u0031\u0025s",_dedf ._gbff ._bc );};func _eacbc (_ggdb *_bf .CompliancePdfReader )ViolatedRule {_baae :=map[*_dd .PdfObjectStream ]struct{}{};for _ ,_dbee :=range _ggdb .PageList {if _dbee .Resources ==nil &&_dbee .Contents ==nil {continue ;
};if _dffa :=_dbee .GetPageDict ();_dffa !=nil {_feeb ,_cbbc :=_dd .GetDict (_dffa .Get ("\u0047\u0072\u006fu\u0070"));if _cbbc {if _eega :=_feeb .Get ("\u0053");_eega !=nil {_bdea ,_ccba :=_dd .GetName (_eega );if _ccba &&_bdea .String ()=="\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079"{return _cgc ("\u0036\u002e\u0034-\u0033","\u0041\u0020\u0047\u0072\u006f\u0075\u0070\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020\u0053\u0020\u0078Ob\u006a\u0065c\u0074\u0020\u0077\u0069\u0074h\u0020\u0061\u0020\u0076a\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061\u006e\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064\u0065\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0066\u006f\u0072\u006d\u0020\u0058\u004f\u0062je\u0063\u0074\u002e\n\u0041 \u0047\u0072\u006f\u0075p\u0020\u006f\u0062j\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020S\u0020\u0078\u004fb\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u0020v\u0061\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006ec\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064e\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0070\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e");
};};};};if _dbee .Resources !=nil {if _dbfd ,_gecg :=_dd .GetDict (_dbee .Resources .XObject );_gecg {for _ ,_bbdd :=range _dbfd .Keys (){_agfe ,_dgfbd :=_dd .GetStream (_dbfd .Get (_bbdd ));if !_dgfbd {continue ;};if _ ,_fgfaf :=_baae [_agfe ];_fgfaf {continue ;
};_adba ,_dgfbd :=_dd .GetDict (_agfe .Get ("\u0047\u0072\u006fu\u0070"));if !_dgfbd {_baae [_agfe ]=struct{}{};continue ;};_bcec :=_adba .Get ("\u0053");if _bcec !=nil {_gccc ,_adf :=_dd .GetName (_bcec );if _adf &&_gccc .String ()=="\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079"{return _cgc ("\u0036\u002e\u0034-\u0033","\u0041\u0020\u0047\u0072\u006f\u0075\u0070\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020\u0053\u0020\u0078Ob\u006a\u0065c\u0074\u0020\u0077\u0069\u0074h\u0020\u0061\u0020\u0076a\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061\u006e\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064\u0065\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0066\u006f\u0072\u006d\u0020\u0058\u004f\u0062je\u0063\u0074\u002e\n\u0041 \u0047\u0072\u006f\u0075p\u0020\u006f\u0062j\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020S\u0020\u0078\u004fb\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u0020v\u0061\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006ec\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064e\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0070\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e");
};};_baae [_agfe ]=struct{}{};continue ;};};};if _dbee .Contents !=nil {_gfc ,_dbbb :=_dbee .GetContentStreams ();if _dbbb !=nil {continue ;};for _ ,_efdg :=range _gfc {_agde ,_geaa :=_bd .NewContentStreamParser (_efdg ).Parse ();if _geaa !=nil {continue ;
};for _ ,_faee :=range *_agde {if len (_faee .Params )==0{continue ;};_fcgd ,_afac :=_dd .GetName (_faee .Params [0]);if !_afac {continue ;};_gcgf ,_ebfac :=_dbee .Resources .GetXObjectByName (*_fcgd );if _ebfac !=_bf .XObjectTypeForm {continue ;};if _ ,_ffee :=_baae [_gcgf ];
_ffee {continue ;};_eagg ,_afac :=_dd .GetDict (_gcgf .Get ("\u0047\u0072\u006fu\u0070"));if !_afac {_baae [_gcgf ]=struct{}{};continue ;};_cbga :=_eagg .Get ("\u0053");if _cbga !=nil {_fgbee ,_eaeb :=_dd .GetName (_cbga );if _eaeb &&_fgbee .String ()=="\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079"{return _cgc ("\u0036\u002e\u0034-\u0033","\u0041\u0020\u0047\u0072\u006f\u0075\u0070\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020\u0053\u0020\u0078Ob\u006a\u0065c\u0074\u0020\u0077\u0069\u0074h\u0020\u0061\u0020\u0076a\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061\u006e\u0073\u0070\u0061\u0072\u0065\u006e\u0063\u0079 \u0073\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064\u0065\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0066\u006f\u0072\u006d\u0020\u0058\u004f\u0062je\u0063\u0074\u002e\n\u0041 \u0047\u0072\u006f\u0075p\u0020\u006f\u0062j\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u006e\u0020S\u0020\u0078\u004fb\u006a\u0065\u0063\u0074\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u0020v\u0061\u006c\u0075\u0065\u0020o\u0066\u0020\u0054\u0072\u0061n\u0073\u0070\u0061\u0072\u0065\u006ec\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0062\u0065\u0020i\u006e\u0063\u006c\u0075\u0064e\u0064\u0020\u0069\u006e\u0020\u0061\u0020\u0070\u0061\u0067\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e");
};};_baae [_gcgf ]=struct{}{};};};};};return _cf ;};

// Profile is the model.StandardImplementer enhanced by the information about the profile conformance level.
type Profile interface{_bf .StandardImplementer ;Conformance ()string ;Part ()int ;};type colorspaceModification struct{_fad _d .ColorConverter ;_cde _bf .PdfColorspace ;};func _effe (_dbd standardType ,_age *_dc .OutputIntents )error {_cgbc ,_eaac :=_egg .NewISOCoatedV2Gray1CBasOutputIntent (_dbd .outputIntentSubtype ());
if _eaac !=nil {return _eaac ;};if _eaac =_age .Add (_cgbc .ToPdfObject ());_eaac !=nil {return _eaac ;};return nil ;};func _afbbf (_edee *_bf .CompliancePdfReader ,_deeb standardType )(_gee []ViolatedRule ){var _bgba ,_bcb ,_fbfg ,_dbaf ,_efbb ,_dcba ,_babc ,_gadg ,_dafc ,_geddg ,_eaaf bool ;
_ecac :=func ()bool {return _bgba &&_bcb &&_fbfg &&_dbaf &&_efbb &&_dcba &&_babc &&_gadg &&_dafc &&_geddg &&_eaaf ;};_bggb :=map[*_dd .PdfObjectStream ]*_cc .CMap {};_beee :=map[*_dd .PdfObjectStream ][]byte {};_ffce :=map[_dd .PdfObject ]*_bf .PdfFont {};
for _ ,_bfdf :=range _edee .GetObjectNums (){_gdd ,_fae :=_edee .GetIndirectObjectByNumber (_bfdf );if _fae !=nil {continue ;};_abb ,_dgbg :=_dd .GetDict (_gdd );if !_dgbg {continue ;};_aafc ,_dgbg :=_dd .GetName (_abb .Get ("\u0054\u0079\u0070\u0065"));
if !_dgbg {continue ;};if *_aafc !="\u0046\u006f\u006e\u0074"{continue ;};_ddag ,_fae :=_bf .NewPdfFontFromPdfObject (_abb );if _fae !=nil {_ee .Log .Debug ("g\u0065\u0074\u0074\u0069\u006e\u0067 \u0066\u006f\u006e\u0074\u0020\u0066r\u006f\u006d\u0020\u006f\u0062\u006a\u0065c\u0074\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020%\u0076",_fae );
continue ;};_ffce [_abb ]=_ddag ;};for _ ,_dfdac :=range _edee .PageList {_bgde ,_gdaf :=_dfdac .GetContentStreams ();if _gdaf !=nil {_ee .Log .Debug ("G\u0065\u0074\u0074\u0069\u006e\u0067 \u0070\u0061\u0067\u0065\u0020\u0063o\u006e\u0074\u0065\u006e\u0074\u0020\u0073t\u0072\u0065\u0061\u006d\u0073\u0020\u0066\u0061\u0069\u006ce\u0064");
continue ;};for _ ,_degg :=range _bgde {_dagd :=_bd .NewContentStreamParser (_degg );_ggdf ,_bceg :=_dagd .Parse ();if _bceg !=nil {_ee .Log .Debug ("\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0063\u006f\u006e\u0074\u0065\u006e\u0074s\u0074r\u0065\u0061\u006d\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_bceg );
continue ;};var _ddaf bool ;for _ ,_egacd :=range *_ggdf {if _egacd .Operand !="\u0054\u0072"{continue ;};if len (_egacd .Params )!=1{_ee .Log .Debug ("\u0069\u006e\u0076\u0061\u006ci\u0064\u0020\u006e\u0075\u006d\u0062\u0065r\u0020\u006f\u0066\u0020\u0070\u0061\u0072\u0061\u006d\u0065\u0074\u0065\u0072\u0073\u0020\u0066\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u0027\u0054\u0072\u0027\u0020\u006f\u0070\u0065\u0072\u0061\u006e\u0064\u002c\u0020\u0065\u0078\u0070e\u0063\u0074\u0065\u0064\u0020\u0027\u0031\u0027\u0020\u0062\u0075\u0074 \u0069\u0073\u003a\u0020\u0027\u0025d\u0027",len (_egacd .Params ));
continue ;};_bgga ,_bbbc :=_dd .GetIntVal (_egacd .Params [0]);if !_bbbc {_ee .Log .Debug ("\u0072\u0065\u006e\u0064\u0065\u0072\u0069\u006e\u0067\u0020\u006d\u006f\u0064\u0065\u0020i\u0073 \u006e\u006f\u0074\u0020\u0061\u006e\u0020\u0069\u006e\u0074\u0065\u0067\u0065\u0072");
continue ;};if _bgga ==3{_ddaf =true ;break ;};};for _ ,_aced :=range *_ggdf {if _aced .Operand !="\u0054\u0066"{continue ;};if len (_aced .Params )!=2{_ee .Log .Debug ("i\u006eva\u006ci\u0064 \u006e\u0075\u006d\u0062\u0065r\u0020\u006f\u0066 \u0070\u0061\u0072\u0061\u006de\u0074\u0065\u0072s\u0020\u0066\u006f\u0072\u0020\u0074\u0068\u0065\u0020\u0027\u0054f\u0027\u0020\u006fper\u0061\u006e\u0064\u002c\u0020\u0065x\u0070\u0065\u0063\u0074\u0065\u0064\u0020\u0027\u0032\u0027\u0020\u0069s\u003a \u0027\u0025\u0064\u0027",len (_aced .Params ));
continue ;};_afbed ,_fbfgc :=_dd .GetName (_aced .Params [0]);if !_fbfgc {_ee .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a \u0054\u0066\u0020\u006f\u0070\u003d\u0025\u0073\u0020\u0047\u0065\u0074\u004ea\u006d\u0065\u0056\u0061\u006c\u0020\u0066a\u0069\u006c\u0065\u0064",_aced );
continue ;};_ecbgd ,_ecgd :=_dfdac .Resources .GetFontByName (*_afbed );if !_ecgd {_ee .Log .Debug ("\u0066\u006f\u006e\u0074\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");continue ;};_ebee ,_fbfgc :=_dd .GetDict (_ecbgd );if !_fbfgc {_ee .Log .Debug ("\u0066\u006f\u006e\u0074 d\u0069\u0063\u0074\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");
continue ;};_dbga ,_fbfgc :=_ffce [_ebee ];if !_fbfgc {var _aegb error ;_dbga ,_aegb =_bf .NewPdfFontFromPdfObject (_ebee );if _aegb !=nil {_ee .Log .Debug ("\u0067\u0065\u0074\u0074i\u006e\u0067\u0020\u0066\u006f\u006e\u0074\u0020\u0066\u0072o\u006d \u006f\u0062\u006a\u0065\u0063\u0074\u003a \u0025\u0076",_aegb );
continue ;};_ffce [_ebee ]=_dbga ;};if !_bgba {_edfa :=_gfddc (_ebee ,_beee ,_bggb );if _edfa !=_cf {_gee =append (_gee ,_edfa );_bgba =true ;if _ecac (){return _gee ;};};};if !_bcb {_eggdf :=_cddg (_ebee );if _eggdf !=_cf {_gee =append (_gee ,_eggdf );
_bcb =true ;if _ecac (){return _gee ;};};};if !_fbfg {_eeef :=_adefd (_ebee ,_beee ,_bggb );if _eeef !=_cf {_gee =append (_gee ,_eeef );_fbfg =true ;if _ecac (){return _gee ;};};};if !_dbaf {_acff :=_eadg (_ebee ,_beee ,_bggb );if _acff !=_cf {_gee =append (_gee ,_acff );
_dbaf =true ;if _ecac (){return _gee ;};};};if !_efbb {_gfe :=_dega (_dbga ,_ebee ,_ddaf );if _gfe !=_cf {_efbb =true ;_gee =append (_gee ,_gfe );if _ecac (){return _gee ;};};};if !_dcba {_aggf :=_ddga (_dbga ,_ebee );if _aggf !=_cf {_dcba =true ;_gee =append (_gee ,_aggf );
if _ecac (){return _gee ;};};};if !_babc {_ggda :=_bfdc (_dbga ,_ebee );if _ggda !=_cf {_babc =true ;_gee =append (_gee ,_ggda );if _ecac (){return _gee ;};};};if !_gadg {_dgeef :=_eefa (_dbga ,_ebee );if _dgeef !=_cf {_gadg =true ;_gee =append (_gee ,_dgeef );
if _ecac (){return _gee ;};};};if !_dafc {_dgde :=_efed (_dbga ,_ebee );if _dgde !=_cf {_dafc =true ;_gee =append (_gee ,_dgde );if _ecac (){return _gee ;};};};if !_geddg {_aacdff :=_addd (_dbga ,_ebee );if _aacdff !=_cf {_geddg =true ;_gee =append (_gee ,_aacdff );
if _ecac (){return _gee ;};};};if !_eaaf &&_deeb ._bc =="\u0041"{_eddg :=_ecae (_ebee ,_beee ,_bggb );if _eddg !=_cf {_eaaf =true ;_gee =append (_gee ,_eddg );if _ecac (){return _gee ;};};};};};};return _gee ;};func _caad (_cegc *_bf .CompliancePdfReader )ViolatedRule {for _ ,_cbbe :=range _cegc .PageList {_dgbd ,_bbag :=_cbbe .GetContentStreams ();
if _bbag !=nil {continue ;};for _ ,_dcf :=range _dgbd {_cdagf :=_bd .NewContentStreamParser (_dcf );_ ,_bbag =_cdagf .Parse ();if _bbag !=nil {return _cgc ("\u0036\u002e\u0032\u002e\u0031\u0030\u002d\u0031","\u0041\u0020\u0063onten\u0074\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u0073\u0068\u0061\u006c\u006c n\u006f\u0074\u0020c\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079 \u006f\u0070\u0065\u0072\u0061\u0074\u006f\u0072\u0073\u0020\u006e\u006ft\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065f\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0065\u0076\u0065\u006e\u0020\u0069\u0066\u0020s\u0075\u0063\u0068\u0020\u006f\u0070\u0065r\u0061\u0074\u006f\u0072\u0073\u0020\u0061\u0072\u0065\u0020\u0062\u0072\u0061\u0063\u006b\u0065\u0074\u0065\u0064\u0020\u0062\u0079\u0020\u0074\u0068\u0065\u0020\u0042\u0058\u002f\u0045\u0058\u0020\u0063\u006f\u006d\u0070\u0061\u0074\u0069\u0062i\u006c\u0069\u0074\u0079\u0020\u006f\u0070\u0065\u0072\u0061\u0074\u006f\u0072\u0073\u002e");
};};};return _cf ;};

// Profile1A is the implementation of the PDF/A-1A standard profile.
// Implements model.StandardImplementer, Profile interfaces.
type Profile1A struct{profile1 };func _fegd (_effa *_bf .CompliancePdfReader )ViolatedRule {for _ ,_cadf :=range _effa .PageList {_bfcf :=_cadf .GetContentStreamObjs ();for _ ,_aecdc :=range _bfcf {_aecdc =_dd .TraceToDirectObject (_aecdc );var _bdc string ;
switch _ggfd :=_aecdc .(type ){case *_dd .PdfObjectString :_bdc =_ggfd .Str ();case *_dd .PdfObjectStream :_ccga ,_dagc :=_dd .GetName (_dd .TraceToDirectObject (_ggfd .Get ("\u0046\u0069\u006c\u0074\u0065\u0072")));if _dagc {if *_ccga ==_dd .StreamEncodingFilterNameLZW {return _cgc ("\u0036\u002e\u0031\u002e\u0031\u0030\u002d\u0032","\u0054h\u0065\u0020L\u005a\u0057\u0044\u0065c\u006f\u0064\u0065 \u0066\u0069\u006c\u0074\u0065\u0072\u0020\u0073\u0068al\u006c\u0020\u006eo\u0074\u0020b\u0065\u0020\u0070\u0065\u0072\u006di\u0074\u0074e\u0064\u002e");
};};_acd ,_cfgc :=_dd .DecodeStream (_ggfd );if _cfgc !=nil {_ee .Log .Debug ("\u0045r\u0072\u003a\u0020\u0025\u0076",_cfgc );continue ;};_bdc =string (_acd );default:_ee .Log .Debug ("\u0049\u006e\u0076\u0061\u006c\u0069d\u0020\u0063\u006f\u006e\u0074\u0065\u006e\u0074\u0020\u0073\u0074\u0072\u0065a\u006d\u0020\u006f\u0062\u006a\u0065\u0063t\u003a\u0020\u0025\u0054",_aecdc );
continue ;};_cbac :=_bd .NewContentStreamParser (_bdc );_abde ,_edab :=_cbac .Parse ();if _edab !=nil {_ee .Log .Debug ("\u0049\u006e\u0076\u0061\u006c\u0069\u0064\u0020\u0063\u006f\u006et\u0065\u006e\u0074\u0020\u0073\u0074\u0072\u0065\u0061\u006d:\u0020\u0025\u0076",_edab );
continue ;};for _ ,_ceeg :=range *_abde {if !(_ceeg .Operand =="\u0042\u0049"&&len (_ceeg .Params )==1){continue ;};_acafg ,_gag :=_ceeg .Params [0].(*_bd .ContentStreamInlineImage );if !_gag {continue ;};_dgdf ,_fcbad :=_acafg .GetEncoder ();if _fcbad !=nil {_ee .Log .Debug ("\u0067\u0065\u0074\u0074\u0069\u006e\u0067\u0020\u0069\u006e\u006c\u0069\u006ee\u0020\u0069\u006d\u0061\u0067\u0065 \u0065\u006e\u0063\u006f\u0064\u0065\u0072\u0020\u0066\u0061\u0069\u006c\u0065d\u003a\u0020\u0025\u0076",_fcbad );
continue ;};if _dgdf .GetFilterName ()==_dd .StreamEncodingFilterNameLZW {return _cgc ("\u0036\u002e\u0031\u002e\u0031\u0030\u002d\u0032","\u0054h\u0065\u0020L\u005a\u0057\u0044\u0065c\u006f\u0064\u0065 \u0066\u0069\u006c\u0074\u0065\u0072\u0020\u0073\u0068al\u006c\u0020\u006eo\u0074\u0020b\u0065\u0020\u0070\u0065\u0072\u006di\u0074\u0074e\u0064\u002e");
};};};};return _cf ;};func (_bab standardType )outputIntentSubtype ()_bf .PdfOutputIntentType {switch _bab ._ecg {case 1:return _bf .PdfOutputIntentTypeA1 ;case 2:return _bf .PdfOutputIntentTypeA2 ;case 3:return _bf .PdfOutputIntentTypeA3 ;case 4:return _bf .PdfOutputIntentTypeA4 ;
default:return 0;};};func _edda (_cef *_bf .CompliancePdfReader )(*_bf .PdfOutputIntent ,bool ){_dbaef ,_ddgbc :=_aeeb (_cef );if !_ddgbc {return nil ,false ;};_fcfg ,_cbdb :=_bf .NewPdfOutputIntentFromPdfObject (_dbaef );if _cbdb !=nil {return nil ,false ;
};return _fcfg ,true ;};type imageInfo struct{ColorSpace _dd .PdfObjectName ;BitsPerComponent int ;ColorComponents int ;Width int ;Height int ;Stream *_dd .PdfObjectStream ;_bcg bool ;};func _eadg (_bega *_dd .PdfObjectDictionary ,_afgcb map[*_dd .PdfObjectStream ][]byte ,_ddeg map[*_dd .PdfObjectStream ]*_cc .CMap )ViolatedRule {const (_gbdg ="\u0036.\u0033\u002e\u0033\u002d\u0034";
_fgef ="\u0046\u006f\u0072\u0020\u0074\u0068\u006fs\u0065\u0020\u0043\u004d\u0061\u0070\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0061\u0072e\u0020\u0065m\u0062\u0065\u0064de\u0064\u002c\u0020\u0074\u0068\u0065\u0020\u0069\u006et\u0065\u0067\u0065\u0072 \u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0057\u004d\u006f\u0064\u0065\u0020\u0065\u006e\u0074r\u0079\u0020i\u006e t\u0068\u0065\u0020CM\u0061\u0070\u0020\u0064\u0069\u0063\u0074\u0069o\u006ea\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0069\u0064\u0065\u006e\u0074\u0069\u0063\u0061\u006c\u0020\u0074\u006f \u0074h\u0065\u0020\u0057\u004d\u006f\u0064e\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u006e\u0020\u0074h\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064ed\u0020\u0043\u004d\u0061\u0070\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e";
);var _abcd string ;if _dcdfg ,_aggbb :=_dd .GetName (_bega .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_aggbb {_abcd =_dcdfg .String ();};if _abcd !="\u0054\u0079\u0070e\u0030"{return _cf ;};_gafd :=_bega .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067");
if _ ,_aagf :=_dd .GetName (_gafd );_aagf {return _cf ;};_egbc ,_aed :=_dd .GetStream (_gafd );if !_aed {return _cgc (_gbdg ,_fgef );};_abede ,_ccfe :=_daadb (_egbc ,_afgcb ,_ddeg );if _ccfe !=nil {return _cgc (_gbdg ,_fgef );};_agac ,_feee :=_dd .GetIntVal (_egbc .Get ("\u0057\u004d\u006fd\u0065"));
_decg ,_ebeg :=_abede .WMode ();if _feee &&_ebeg {if _decg !=_agac {return _cgc (_gbdg ,_fgef );};};if (_feee &&!_ebeg )||(!_feee &&_ebeg ){return _cgc (_gbdg ,_fgef );};return _cf ;};func _facc (_bcegd string ,_gcfa string ,_fcab string )(string ,bool ){_ageaf :=_af .Index (_bcegd ,_gcfa );
if _ageaf ==-1{return "",false ;};_ageaf +=len (_gcfa );_eaec :=_af .Index (_bcegd [_ageaf :],_fcab );if _eaec ==-1{return "",false ;};_eaec =_ageaf +_eaec ;return _bcegd [_ageaf :_eaec ],true ;};func _abfb (_afag *_bf .CompliancePdfReader )(_fcacg []ViolatedRule ){var _eeba ,_bbgf ,_gdffa ,_eeefd ,_dbba ,_dddf bool ;
_fbcb :=func ()bool {return _eeba &&_bbgf &&_gdffa &&_eeefd &&_dbba &&_dddf };_ccgae :=func (_acag *_dd .PdfObjectDictionary )bool {if !_eeba &&_acag .Get ("\u0054\u0052")!=nil {_eeba =true ;_fcacg =append (_fcacg ,_cgc ("\u0036.\u0032\u002e\u0038\u002d\u0031","\u0041\u006e\u0020\u0045\u0078\u0074\u0047\u0053\u0074\u0061\u0074e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072y\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e \u0074\u0068\u0065\u0020\u0054\u0052\u0020\u006b\u0065\u0079\u002e"));
};if _bgcg :=_acag .Get ("\u0054\u0052\u0032");!_bbgf &&_bgcg !=nil {_bacd ,_cgbf :=_dd .GetName (_bgcg );if !_cgbf ||(_cgbf &&*_bacd !="\u0044e\u0066\u0061\u0075\u006c\u0074"){_bbgf =true ;_fcacg =append (_fcacg ,_cgc ("\u0036.\u0032\u002e\u0038\u002d\u0032","\u0041\u006e \u0045\u0078\u0074G\u0053\u0074\u0061\u0074\u0065 \u0064\u0069\u0063\u0074\u0069on\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074a\u0069n\u0020\u0074\u0068\u0065\u0020\u0054R2 \u006b\u0065\u0079\u0020\u0077\u0069\u0074\u0068\u0020\u0061\u0020\u0076al\u0075e\u0020\u006f\u0074\u0068e\u0072 \u0074h\u0061\u006e \u0044\u0065fa\u0075\u006c\u0074\u002e"));
if _fbcb (){return true ;};};};if _bbge :=_acag .Get ("\u0053\u004d\u0061s\u006b");!_gdffa &&_bbge !=nil {_cfaa ,_dfbgf :=_dd .GetName (_bbge );if !_dfbgf ||(_dfbgf &&*_cfaa !="\u004e\u006f\u006e\u0065"){_gdffa =true ;_fcacg =append (_fcacg ,_cgc ("\u0036\u002e\u0034-\u0031","\u0049\u0066\u0020\u0061\u006e \u0053\u004d\u0061\u0073\u006b\u0020\u006be\u0079\u0020\u0061\u0070\u0070\u0065\u0061\u0072\u0073\u0020\u0069\u006e\u0020\u0061\u006e\u0020\u0045\u0078\u0074\u0047\u0053\u0074\u0061\u0074\u0065\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002c\u0020\u0069\u0074s\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u004e\u006f\u006ee\u002e"));
if _fbcb (){return true ;};};};if _efg :=_acag .Get ("\u0043\u0041");!_dbba &&_efg !=nil {_deca ,_fddce :=_dd .GetNumberAsFloat (_efg );if _fddce ==nil &&_deca !=1.0{_dbba =true ;_fcacg =append (_fcacg ,_cgc ("\u0036\u002e\u0034-\u0035","\u0054\u0068\u0065\u0020\u0066ol\u006c\u006fw\u0069\u006e\u0067\u0020\u006b\u0065\u0079\u0073\u002c\u0020\u0069\u0066\u0020\u0070\u0072\u0065\u0073\u0065\u006e\u0074\u0020\u0069\u006e\u0020\u0061\u006e\u0020\u0045\u0078t\u0047\u0053\u0074a\u0074\u0065\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u002c\u0020\u0073\u0068a\u006c\u006c\u0020\u0068\u0061v\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0073 \u0073h\u006f\u0077\u006e\u003a\u0020\u0043\u0041 \u002d\u0020\u0031\u002e\u0030\u002e"));
if _fbcb (){return true ;};};};if _eddb :=_acag .Get ("\u0063\u0061");!_dddf &&_eddb !=nil {_fffb ,_bcdda :=_dd .GetNumberAsFloat (_eddb );if _bcdda ==nil &&_fffb !=1.0{_dddf =true ;_fcacg =append (_fcacg ,_cgc ("\u0036\u002e\u0034-\u0036","\u0054\u0068\u0065\u0020\u0066ol\u006c\u006fw\u0069\u006e\u0067\u0020\u006b\u0065\u0079\u0073\u002c\u0020\u0069\u0066\u0020\u0070\u0072\u0065\u0073\u0065\u006e\u0074\u0020\u0069\u006e\u0020\u0061\u006e\u0020\u0045\u0078t\u0047\u0053\u0074a\u0074\u0065\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u002c\u0020\u0073\u0068a\u006c\u006c\u0020\u0068\u0061v\u0065\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006cu\u0065\u0073 \u0073h\u006f\u0077\u006e\u003a\u0020\u0063\u0061 \u002d\u0020\u0031\u002e\u0030\u002e"));
if _fbcb (){return true ;};};};if _egad :=_acag .Get ("\u0042\u004d");!_eeefd &&_egad !=nil {_gbed ,_fagf :=_dd .GetName (_egad );if _fagf {switch _gbed .String (){case "\u004e\u006f\u0072\u006d\u0061\u006c","\u0043\u006f\u006d\u0070\u0061\u0074\u0069\u0062\u006c\u0065":default:_eeefd =true ;
_fcacg =append (_fcacg ,_cgc ("\u0036\u002e\u0034-\u0034","T\u0068\u0065\u0020\u0066\u006f\u006cl\u006f\u0077\u0069\u006e\u0067 \u006b\u0065y\u0073\u002c\u0020\u0069\u0066 \u0070res\u0065\u006e\u0074\u0020\u0069\u006e\u0020\u0061\u006e\u0020\u0045\u0078\u0074\u0047S\u0074\u0061t\u0065\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u002c\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0068\u0061\u0076\u0065 \u0074\u0068\u0065 \u0076\u0061\u006c\u0075\u0065\u0073\u0020\u0073\u0068\u006f\u0077n\u003a\u0020\u0042\u004d\u0020\u002d\u0020\u004e\u006f\u0072m\u0061\u006c\u0020\u006f\u0072\u0020\u0043\u006f\u006d\u0070\u0061t\u0069\u0062\u006c\u0065\u002e"));
if _fbcb (){return true ;};};};};return false ;};for _ ,_dgfe :=range _afag .PageList {_cbad :=_dgfe .Resources ;if _cbad ==nil {continue ;};if _cbad .ExtGState ==nil {continue ;};_fdfg ,_edaga :=_dd .GetDict (_cbad .ExtGState );if !_edaga {continue ;};
_agae :=_fdfg .Keys ();for _ ,_aadf :=range _agae {_eaff ,_bdec :=_dd .GetDict (_fdfg .Get (_aadf ));if !_bdec {continue ;};if _ccgae (_eaff ){return _fcacg ;};};};for _ ,_bfa :=range _afag .PageList {_cafcf :=_bfa .Resources ;if _cafcf ==nil {continue ;
};_cfdd ,_cgfb :=_dd .GetDict (_cafcf .XObject );if !_cgfb {continue ;};for _ ,_bdb :=range _cfdd .Keys (){_bfb ,_agea :=_dd .GetStream (_cfdd .Get (_bdb ));if !_agea {continue ;};_bbdg ,_agea :=_dd .GetDict (_bfb .Get ("\u0052e\u0073\u006f\u0075\u0072\u0063\u0065s"));
if !_agea {continue ;};_ffg ,_agea :=_dd .GetDict (_bbdg .Get ("\u0045x\u0074\u0047\u0053\u0074\u0061\u0074e"));if !_agea {continue ;};for _ ,_bcff :=range _ffg .Keys (){_faag ,_dccb :=_dd .GetDict (_ffg .Get (_bcff ));if !_dccb {continue ;};if _ccgae (_faag ){return _fcacg ;
};};};};return _fcacg ;};func _afdf (_dg []_dd .PdfObject )(*documentImages ,error ){_eef :=_dd .PdfObjectName ("\u0053u\u0062\u0074\u0079\u0070\u0065");_ef :=make (map[*_dd .PdfObjectStream ]struct{});_ge :=make (map[_dd .PdfObject ]struct{});var (_bgf ,_ceg ,_ggg bool ;
_ad []*imageInfo ;_gggf error ;);for _ ,_cga :=range _dg {_ca ,_gce :=_dd .GetStream (_cga );if !_gce {continue ;};if _ ,_baa :=_ef [_ca ];_baa {continue ;};_ef [_ca ]=struct{}{};_fb :=_ca .PdfObjectDictionary .Get (_eef );_gff ,_gce :=_dd .GetName (_fb );
if !_gce ||string (*_gff )!="\u0049\u006d\u0061g\u0065"{continue ;};if _ccc :=_ca .PdfObjectDictionary .Get ("\u0053\u004d\u0061s\u006b");_ccc !=nil {_ge [_ccc ]=struct{}{};};_ea :=imageInfo {BitsPerComponent :8,Stream :_ca };_ea .ColorSpace ,_gggf =_bf .DetermineColorspaceNameFromPdfObject (_ca .PdfObjectDictionary .Get ("\u0043\u006f\u006c\u006f\u0072\u0053\u0070\u0061\u0063\u0065"));
if _gggf !=nil {return nil ,_gggf ;};if _dgg ,_dbag :=_dd .GetIntVal (_ca .PdfObjectDictionary .Get ("\u0042\u0069t\u0073\u0050\u0065r\u0043\u006f\u006d\u0070\u006f\u006e\u0065\u006e\u0074"));_dbag {_ea .BitsPerComponent =_dgg ;};if _aag ,_dgf :=_dd .GetIntVal (_ca .PdfObjectDictionary .Get ("\u0057\u0069\u0064t\u0068"));
_dgf {_ea .Width =_aag ;};if _bgfb ,_eb :=_dd .GetIntVal (_ca .PdfObjectDictionary .Get ("\u0048\u0065\u0069\u0067\u0068\u0074"));_eb {_ea .Height =_bgfb ;};switch _ea .ColorSpace {case "\u0044\u0065\u0076\u0069\u0063\u0065\u0047\u0072\u0061\u0079":_ggg =true ;
_ea .ColorComponents =1;case "\u0044e\u0076\u0069\u0063\u0065\u0052\u0047B":_bgf =true ;_ea .ColorComponents =3;case "\u0044\u0065\u0076\u0069\u0063\u0065\u0043\u004d\u0059\u004b":_ceg =true ;_ea .ColorComponents =4;default:_ea ._bcg =true ;};_ad =append (_ad ,&_ea );
};if len (_ge )> 0{if len (_ge )==len (_ad ){_ad =nil ;}else {_ac :=make ([]*imageInfo ,len (_ad )-len (_ge ));var _eefe int ;for _ ,_fa :=range _ad {if _ ,_dge :=_ge [_fa .Stream ];_dge {continue ;};_ac [_eefe ]=_fa ;_eefe ++;};_ad =_ac ;};};return &documentImages {_bae :_bgf ,_cgg :_ceg ,_gf :_ggg ,_dba :_ge ,_ed :_ad },nil ;
};func _cbc (_baba *_bf .PdfInfo ,_gbg func ()_aa .Time )error {var _effef *_bf .PdfDate ;if _baba .CreationDate ==nil {_cdf ,_cbcc :=_bf .NewPdfDateFromTime (_gbg ());if _cbcc !=nil {return _cbcc ;};_effef =&_cdf ;_baba .CreationDate =_effef ;};if _baba .ModifiedDate ==nil {if _effef !=nil {_cfef ,_fbgc :=_bf .NewPdfDateFromTime (_gbg ());
if _fbgc !=nil {return _fbgc ;};_effef =&_cfef ;};_baba .ModifiedDate =_effef ;};return nil ;};type documentColorspaceOptimizeFunc func (_cae *_dc .Document ,_adb []*_dc .Image )error ;func _cdg (_gedf *_dc .Document ,_dgee standardType ,_ddd XmpOptions )error {_bcdc ,_aagg :=_gedf .FindCatalog ();
if !_aagg {return nil ;};var _fde *_fce .Document ;_gec ,_aagg :=_bcdc .GetMetadata ();if !_aagg {_fde =_fce .NewDocument ();}else {var _gad error ;_fde ,_gad =_fce .LoadDocument (_gec .Stream );if _gad !=nil {return _gad ;};};_edad :=_fce .PdfInfoOptions {InfoDict :_gedf .Info ,PdfVersion :_a .Sprintf ("\u0025\u0064\u002e%\u0064",_gedf .Version .Major ,_gedf .Version .Minor ),Copyright :_ddd .Copyright ,Overwrite :true };
_fef ,_aagg :=_bcdc .GetMarkInfo ();if _aagg {_feb ,_fegb :=_dd .GetBool (_fef .Get ("\u004d\u0061\u0072\u006b\u0065\u0064"));if _fegb &&bool (*_feb ){_edad .Marked =true ;};};if _cea :=_fde .SetPdfInfo (&_edad );_cea !=nil {return _cea ;};if _fea :=_fde .SetPdfAID (_dgee ._ecg ,_dgee ._bc );
_fea !=nil {return _fea ;};_cfg :=_fce .MediaManagementOptions {OriginalDocumentID :_ddd .OriginalDocumentID ,DocumentID :_ddd .DocumentID ,InstanceID :_ddd .InstanceID ,NewDocumentID :!_ddd .NewDocumentVersion ,ModifyComment :"O\u0070\u0074\u0069\u006d\u0069\u007ae\u0020\u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0074\u006f\u0020\u0050D\u0046\u002f\u0041\u0020\u0073\u0074\u0061\u006e\u0064\u0061r\u0064"};
_ccbc ,_aagg :=_dd .GetDict (_gedf .Info );if _aagg {if _gdf ,_cfbf :=_dd .GetString (_ccbc .Get ("\u004do\u0064\u0044\u0061\u0074\u0065"));_cfbf &&_gdf .String ()!=""{_aee ,_cfc :=_de .ParsePdfTime (_gdf .String ());if _cfc !=nil {return _a .Errorf ("\u0069n\u0076\u0061\u006c\u0069d\u0020\u004d\u006f\u0064\u0044a\u0074e\u0020f\u0069\u0065\u006c\u0064\u003a\u0020\u0025w",_cfc );
};_cfg .ModifyDate =_aee ;};};if _aca :=_fde .SetMediaManagement (&_cfg );_aca !=nil {return _aca ;};if _aagd :=_fde .SetPdfAExtension ();_aagd !=nil {return _aagd ;};_fbeg ,_eefg :=_fde .MarshalIndent (_ddd .MarshalPrefix ,_ddd .MarshalIndent );if _eefg !=nil {return _eefg ;
};if _fdd :=_bcdc .SetMetadata (_fbeg );_fdd !=nil {return _fdd ;};return nil ;};func _bbg (_febb *_bf .CompliancePdfReader )ViolatedRule {if _febb .ParserMetadata ().HasDataAfterEOF (){return _cgc ("\u0036.\u0031\u002e\u0033\u002d\u0033","\u004e\u006f\u0020\u0064\u0061ta\u0020\u0073h\u0061\u006c\u006c\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0020\u0074\u0068\u0065\u0020\u006c\u0061\u0073\u0074\u0020\u0065\u006e\u0064\u002d\u006f\u0066\u002d\u0066\u0069l\u0065\u0020\u006da\u0072\u006b\u0065\u0072\u0020\u0065\u0078\u0063\u0065\u0070\u0074\u0020\u0061 \u0073\u0069\u006e\u0067\u006ce\u0020\u006f\u0070\u0074\u0069\u006f\u006e\u0061\u006c \u0065\u006ed\u002do\u0066\u002d\u006c\u0069\u006e\u0065\u0020m\u0061\u0072\u006b\u0065\u0072\u002e");
};return _cf ;};func _ecae (_gcca *_dd .PdfObjectDictionary ,_dacg map[*_dd .PdfObjectStream ][]byte ,_gedb map[*_dd .PdfObjectStream ]*_cc .CMap )ViolatedRule {const (_ebcb ="\u0036.\u0033\u002e\u0038\u002d\u0031";_afae ="\u0054\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0073\u0068\u0061\u006cl\u0020\u0069\u006e\u0063l\u0075\u0064e\u0020\u0061 \u0054\u006f\u0055\u006e\u0069\u0063\u006f\u0064\u0065\u0020\u0065\u006e\u0074\u0072\u0079\u0020w\u0068\u006f\u0073\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u0073 \u0061\u0020\u0043M\u0061\u0070\u0020\u0073\u0074\u0072\u0065\u0061\u006d \u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0074\u0068\u0061\u0074\u0020\u006d\u0061p\u0073\u0020\u0063\u0068\u0061\u0072ac\u0074\u0065\u0072\u0020\u0063\u006fd\u0065s\u0020\u0074\u006f\u0020\u0055\u006e\u0069\u0063\u006f\u0064e \u0076a\u006c\u0075\u0065\u0073,\u0020\u0061\u0073\u0020\u0064\u0065\u0073\u0063r\u0069\u0062\u0065\u0064\u0020\u0069\u006e\u0020P\u0044\u0046\u0020\u0052\u0065f\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0035.\u0039\u002c\u0020\u0075\u006e\u006ce\u0073\u0073\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006e\u0074\u0020\u006d\u0065\u0065\u0074\u0073 \u0061\u006e\u0079\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006c\u006c\u006f\u0077\u0069\u006e\u0067\u0020\u0074\u0068\u0072\u0065\u0065\u0020\u0063\u006f\u006e\u0064\u0069\u0074\u0069\u006f\u006e\u0073\u003a\u000a\u0020\u002d\u0020\u0066o\u006e\u0074\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0075\u0073\u0065\u0020\u0074\u0068\u0065\u0020\u0070\u0072\u0065\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0065\u006e\u0063\u006f\u0064\u0069n\u0067\u0073\u0020M\u0061\u0063\u0052o\u006d\u0061\u006e\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u002c\u0020\u004d\u0061\u0063\u0045\u0078\u0070\u0065\u0072\u0074E\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u006f\u0072\u0020\u0057\u0069\u006e\u0041n\u0073\u0069\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067\u002c\u0020\u006f\u0072\u0020\u0074\u0068\u0061\u0074\u0020\u0075\u0073\u0065\u0020t\u0068\u0065\u0020\u0070\u0072\u0065d\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048\u0020\u006f\u0072\u0020\u0049\u0064\u0065n\u0074\u0069\u0074\u0079\u002d\u0056\u0020C\u004d\u0061\u0070s\u003b\u000a\u0020\u002d\u0020\u0054\u0079\u0070\u0065\u0020\u0031\u0020\u0066\u006f\u006e\u0074\u0073\u0020\u0077\u0068\u006f\u0073\u0065\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u006e\u0061\u006d\u0065\u0073\u0020a\u0072\u0065 \u0074\u0061k\u0065\u006e\u0020\u0066\u0072\u006f\u006d\u0020\u0074\u0068\u0065\u0020\u0041\u0064\u006f\u0062\u0065\u0020\u0073\u0074\u0061n\u0064\u0061\u0072\u0064\u0020L\u0061t\u0069\u006e\u0020\u0063\u0068a\u0072\u0061\u0063\u0074\u0065\u0072\u0020\u0073\u0065\u0074\u0020\u006fr\u0020\u0074\u0068\u0065 \u0073\u0065\u0074\u0020\u006f\u0066 \u006e\u0061\u006d\u0065\u0064\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074\u0065r\u0073\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0053\u0079\u006d\u0062\u006f\u006c\u0020\u0066\u006f\u006e\u0074\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020i\u006e\u0020\u0050\u0044\u0046 \u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0041\u0070\u0070\u0065\u006e\u0064\u0069\u0078 \u0044\u003b\u000a\u0020\u002d\u0020\u0054\u0079\u0070\u0065\u0020\u0030\u0020\u0066\u006f\u006e\u0074\u0073\u0020w\u0068\u006f\u0073e\u0020d\u0065\u0073\u0063\u0065n\u0064\u0061\u006e\u0074 \u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0020\u0075\u0073\u0065\u0073\u0020\u0074\u0068\u0065\u0020\u0041\u0064\u006f\u0062\u0065\u002d\u0047B\u0031\u002c\u0020\u0041\u0064\u006fb\u0065\u002d\u0043\u004e\u0053\u0031\u002c\u0020\u0041\u0064\u006f\u0062\u0065\u002d\u004a\u0061\u0070\u0061\u006e\u0031\u0020\u006f\u0072\u0020\u0041\u0064\u006f\u0062\u0065\u002d\u004b\u006fr\u0065\u0061\u0031\u0020\u0063\u0068\u0061r\u0061\u0063\u0074\u0065\u0072\u0020\u0063\u006f\u006c\u006c\u0065\u0063\u0074\u0069\u006f\u006e\u0073\u002e";
);_dccab ,_acafb :=_dd .GetStream (_gcca .Get ("\u0054o\u0055\u006e\u0069\u0063\u006f\u0064e"));if _acafb {_ ,_geba :=_daadb (_dccab ,_dacg ,_gedb );if _geba !=nil {return _cgc (_ebcb ,_afae );};return _cf ;};_bgaa ,_acafb :=_dd .GetName (_gcca .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));
if !_acafb {return _cgc (_ebcb ,_afae );};switch _bgaa .String (){case "\u0054\u0079\u0070e\u0031":return _cf ;};return _cgc (_ebcb ,_afae );};func _bfdc (_dbbce *_bf .PdfFont ,_gfaf *_dd .PdfObjectDictionary )ViolatedRule {const (_degf ="\u0036.\u0033\u002e\u0035\u002d\u0033";
_begf ="\u0046\u006f\u0072\u0020\u0061\u006c\u006c\u0020\u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0020\u0073\u0075\u0062\u0073\u0065\u0074\u0073 \u0072e\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0064\u0020\u0077i\u0074\u0068\u0069n\u0020\u0061\u0020c\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069l\u0065\u002c\u0020\u0074\u0068\u0065\u0020\u0066\u006f\u006et\u0020\u0064\u0065s\u0063\u0072\u0069\u0070\u0074\u006f\u0072\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061r\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061\u0020\u0043\u0049\u0044\u0053\u0065\u0074\u0020s\u0074\u0072\u0065\u0061\u006d\u0020\u0069\u0064\u0065\u006e\u0074\u0069\u0066\u0079\u0069\u006eg\u0020\u0077\u0068i\u0063\u0068\u0020\u0043\u0049\u0044\u0073 \u0061\u0072e\u0020\u0070\u0072\u0065\u0073\u0065\u006e\u0074\u0020\u0069\u006e \u0074\u0068\u0065\u0020\u0065\u006d\u0062\u0065\u0064d\u0065\u0064\u0020\u0043\u0049D\u0046\u006f\u006e\u0074\u0020\u0066\u0069l\u0065,\u0020\u0061\u0073 \u0064\u0065\u0073\u0063\u0072\u0069b\u0065\u0064 \u0069\u006e\u0020\u0050\u0044\u0046\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063e\u0020\u0054ab\u006c\u0065\u0020\u0035.\u00320\u002e";
);var _fdee string ;if _acedc ,_gcgb :=_dd .GetName (_gfaf .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_gcgb {_fdee =_acedc .String ();};switch _fdee {case "\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0030","\u0043\u0049\u0044F\u006f\u006e\u0074\u0054\u0079\u0070\u0065\u0032":_egbb :=_dbbce .FontDescriptor ();
if _egbb .CIDSet ==nil {return _cgc (_degf ,_begf );};return _cf ;default:return _cf ;};};type pageColorspaceOptimizeFunc func (_cecd *_dc .Document ,_cgec *_dc .Page ,_gef []*_dc .Image )error ;

// String gets a string representation of the violated rule.
func (_cb ViolatedRule )String ()string {return _a .Sprintf ("\u0025\u0073\u003a\u0020\u0025\u0073",_cb .RuleNo ,_cb .Detail );};func _daadb (_adgd *_dd .PdfObjectStream ,_cfeag map[*_dd .PdfObjectStream ][]byte ,_baaef map[*_dd .PdfObjectStream ]*_cc .CMap )(*_cc .CMap ,error ){_eegag ,_afeg :=_baaef [_adgd ];
if !_afeg {var _effeb error ;_gefad ,_ddabd :=_cfeag [_adgd ];if !_ddabd {_gefad ,_effeb =_dd .DecodeStream (_adgd );if _effeb !=nil {_ee .Log .Debug ("\u0064\u0065\u0063\u006f\u0064\u0069\u006e\u0067\u0020\u0073\u0074r\u0065\u0061\u006d\u0020\u0066\u0061\u0069\u006c\u0065\u0064:\u0020\u0025\u0076",_effeb );
return nil ,_effeb ;};_cfeag [_adgd ]=_gefad ;};_eegag ,_effeb =_cc .LoadCmapFromData (_gefad ,false );if _effeb !=nil {return nil ,_effeb ;};_baaef [_adgd ]=_eegag ;};return _eegag ,nil ;};

// Validate checks if provided input document reader matches given PDF/A profile.
func Validate (d *_bf .CompliancePdfReader ,profile Profile )error {return profile .ValidateStandard (d )};type imageModifications struct{_dff *colorspaceModification ;_gda _dd .StreamEncoder ;};func _abea (_cbgag *_bf .CompliancePdfReader ,_ecab standardType ,_bbce bool )(_egde []ViolatedRule ){_acb ,_cdac :=_eecg (_cbgag );
if !_cdac {return []ViolatedRule {_cgc ("\u0036.\u0037\u002e\u0032\u002d\u0031","\u0063a\u0074a\u006c\u006f\u0067\u0020\u006eo\u0074\u0020f\u006f\u0075\u006e\u0064\u002e")};};_fefb :=_acb .Get ("\u004d\u0065\u0074\u0061\u0064\u0061\u0074\u0061");if _fefb ==nil {return []ViolatedRule {_cgc ("\u0036.\u0037\u002e\u0032\u002d\u0031","\u006e\u006f\u0020\u0027\u004d\u0065\u0074\u0061d\u0061\u0074\u0061' \u006b\u0065\u0079\u0020\u0066\u006fu\u006e\u0064\u0020\u0069\u006e\u0020\u0074\u0068\u0065\u0020\u0064\u006f\u0063\u0075\u006de\u006e\u0074\u0020\u0063\u0061\u0074\u0061\u006co\u0067\u002e"),_cgc ("\u0036.\u0037\u002e\u0033\u002d\u0031","\u0049\u0066\u0020\u005b\u0061\u0020\u0064\u006fc\u0075\u006d\u0065\u006e\u0074\u0020\u0069\u006e\u0066o\u0072\u006d\u0061t\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0061\u0070p\u0065\u0061r\u0073\u0020\u0069n\u0020\u0061 \u0064\u006f\u0063um\u0065\u006e\u0074\u005d\u002c\u0020\u0074\u0068\u0065n\u0020\u0061\u006c\u006c\u0020\u006f\u0066\u0020\u0069\u0074\u0073\u0020\u0065\u006e\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0068\u0061\u0076\u0065\u0020\u0061\u006e\u0061\u006c\u006f\u0067\u006fu\u0073\u0020\u0070\u0072\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073 \u0069\u006e\u0020\u0070\u0072\u0065\u0064e\u0066\u0069\u006e\u0065\u0064\u0020\u0058\u004d\u0050\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073\u0020\u2026 \u0073\u0068\u0061\u006c\u006c\u0020\u0061\u006c\u0073\u006f\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0069\u006e\u0020\u0074he\u0020\u0066i\u006c\u0065 \u0069\u006e\u0020\u0058\u004d\u0050\u0020\u0066\u006f\u0072\u006d\u0020\u0077\u0069\u0074\u0068\u0020\u0065\u0071\u0075\u0069\u0076\u0061\u006c\u0065\u006e\u0074\u0020\u0076\u0061\u006c\u0075\u0065\u0073\u002e")};
};_bff ,_cdac :=_dd .GetStream (_fefb );if !_cdac {return []ViolatedRule {_cgc ("\u0036.\u0037\u002e\u0032\u002d\u0032","\u0063\u0061\u0074a\u006c\u006f\u0067\u0020\u0027\u004d\u0065\u0074\u0061\u0064\u0061\u0074\u0061\u0027\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0069\u0073\u0020\u006e\u006f\u0074\u0020a\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u002e"),_cgc ("\u0036.\u0037\u002e\u0033\u002d\u0031","\u0049\u0066\u0020\u005b\u0061\u0020\u0064\u006fc\u0075\u006d\u0065\u006e\u0074\u0020\u0069\u006e\u0066o\u0072\u006d\u0061t\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0061\u0070p\u0065\u0061r\u0073\u0020\u0069n\u0020\u0061 \u0064\u006f\u0063um\u0065\u006e\u0074\u005d\u002c\u0020\u0074\u0068\u0065n\u0020\u0061\u006c\u006c\u0020\u006f\u0066\u0020\u0069\u0074\u0073\u0020\u0065\u006e\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0068\u0061\u0076\u0065\u0020\u0061\u006e\u0061\u006c\u006f\u0067\u006fu\u0073\u0020\u0070\u0072\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073 \u0069\u006e\u0020\u0070\u0072\u0065\u0064e\u0066\u0069\u006e\u0065\u0064\u0020\u0058\u004d\u0050\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073\u0020\u2026 \u0073\u0068\u0061\u006c\u006c\u0020\u0061\u006c\u0073\u006f\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0069\u006e\u0020\u0074he\u0020\u0066i\u006c\u0065 \u0069\u006e\u0020\u0058\u004d\u0050\u0020\u0066\u006f\u0072\u006d\u0020\u0077\u0069\u0074\u0068\u0020\u0065\u0071\u0075\u0069\u0076\u0061\u006c\u0065\u006e\u0074\u0020\u0076\u0061\u006c\u0075\u0065\u0073\u002e")};
};if _bff .Get ("\u0046\u0069\u006c\u0074\u0065\u0072")!=nil {_egde =append (_egde ,_cgc ("\u0036.\u0037\u002e\u0032\u002d\u0032","M\u0065\u0074a\u0064\u0061\u0074\u0061\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u0064i\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0069\u0065\u0073\u0020\u0073\u0068\u0061\u006c\u006c \u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0074h\u0065\u0020\u0046\u0069\u006c\u0074\u0065\u0072\u0020\u006b\u0065y\u002e"));
};_ddgbe ,_ebca :=_fce .LoadDocument (_bff .Stream );if _ebca !=nil {return []ViolatedRule {_cgc ("\u0036.\u0037\u002e\u0039\u002d\u0031","The\u0020\u006d\u0065\u0074a\u0064\u0061t\u0061\u0020\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0063o\u006e\u0066\u006f\u0072\u006d\u0020\u0074o\u0020\u0058\u004d\u0050\u0020\u0053\u0070\u0065\u0063\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006f\u006e\u0020\u0061\u006e\u0064\u0020\u0077\u0065\u006c\u006c\u0020\u0066\u006f\u0072\u006de\u0064\u0020\u0050\u0044\u0046\u0041\u0045\u0078\u0074e\u006e\u0073\u0069\u006f\u006e\u0020\u0053\u0063\u0068\u0065\u006da\u0020\u0066\u006fr\u0020\u0061\u006c\u006c\u0020\u0065\u0078\u0074\u0065\u006e\u0073\u0069\u006f\u006e\u0073\u002e")};
};_dgacb :=_ddgbe .GetGoXmpDocument ();var _cecc []*_afd .Namespace ;for _ ,_abgb :=range _dgacb .Namespaces (){switch _abgb .Name {case _ba .NsDc .Name ,_cg .NsPDF .Name ,_c .NsXmp .Name ,_eg .NsXmpRights .Name ,_ec .Namespace .Name ,_ab .Namespace .Name ,_bg .NsXmpMM .Name ,_ab .FieldNS .Name ,_ab .SchemaNS .Name ,_ab .PropertyNS .Name ,"\u0073\u0074\u0045v\u0074","\u0073\u0074\u0056e\u0072","\u0073\u0074\u0052e\u0066","\u0073\u0074\u0044i\u006d","\u0078a\u0070\u0047\u0049\u006d\u0067","\u0073\u0074\u004ao\u0062","\u0078\u006d\u0070\u0069\u0064\u0071":continue ;
};_cecc =append (_cecc ,_abgb );};_cbaf :=true ;_aeeg ,_ebca :=_ddgbe .GetPdfaExtensionSchemas ();if _ebca ==nil {for _ ,_gbbe :=range _cecc {var _bccg bool ;for _gbga :=range _aeeg {if _gbbe .URI ==_aeeg [_gbga ].NamespaceURI {_bccg =true ;break ;};};
if !_bccg {_cbaf =false ;break ;};};}else {_cbaf =false ;};if !_cbaf {_egde =append (_egde ,_cgc ("\u0036.\u0037\u002e\u0039\u002d\u0032","\u0050\u0072\u006f\u0070\u0065\u0072\u0074i\u0065\u0073 \u0073\u0070\u0065\u0063\u0069\u0066\u0069ed\u0020\u0069\u006e\u0020\u0058M\u0050\u0020\u0066\u006f\u0072\u006d\u0020\u0073\u0068\u0061\u006cl\u0020\u0075\u0073\u0065\u0020\u0065\u0069\u0074\u0068\u0065\u0072\u0020\u0074\u0068\u0065\u0020\u0070\u0072\u0065\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073 \u0064\u0065\u0066i\u006e\u0065\u0064\u0020\u0069\u006e\u0020\u0058\u004d\u0050\u0020\u0053\u0070\u0065\u0063\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006fn\u002c\u0020\u006f\u0072\u0020\u0065\u0078\u0074\u0065ns\u0069\u006f\u006e\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073\u0020\u0074\u0068\u0061\u0074 \u0063\u006f\u006d\u0070\u006c\u0079\u0020\u0077\u0069\u0074h\u0020\u0058\u004d\u0050\u0020\u0053\u0070e\u0063\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006f\u006e\u002e"));
};_ddgc ,_ebca :=_cbgag .GetPdfInfo ();if _ebca ==nil {if !_ccgad (_ddgc ,_ddgbe ){_egde =append (_egde ,_cgc ("\u0036.\u0037\u002e\u0033\u002d\u0031","\u0049\u0066\u0020\u005b\u0061\u0020\u0064\u006fc\u0075\u006d\u0065\u006e\u0074\u0020\u0069\u006e\u0066o\u0072\u006d\u0061t\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0061\u0070p\u0065\u0061r\u0073\u0020\u0069n\u0020\u0061 \u0064\u006f\u0063um\u0065\u006e\u0074\u005d\u002c\u0020\u0074\u0068\u0065n\u0020\u0061\u006c\u006c\u0020\u006f\u0066\u0020\u0069\u0074\u0073\u0020\u0065\u006e\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0068\u0061\u0076\u0065\u0020\u0061\u006e\u0061\u006c\u006f\u0067\u006fu\u0073\u0020\u0070\u0072\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073 \u0069\u006e\u0020\u0070\u0072\u0065\u0064e\u0066\u0069\u006e\u0065\u0064\u0020\u0058\u004d\u0050\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073\u0020\u2026 \u0073\u0068\u0061\u006c\u006c\u0020\u0061\u006c\u0073\u006f\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0069\u006e\u0020\u0074he\u0020\u0066i\u006c\u0065 \u0069\u006e\u0020\u0058\u004d\u0050\u0020\u0066\u006f\u0072\u006d\u0020\u0077\u0069\u0074\u0068\u0020\u0065\u0071\u0075\u0069\u0076\u0061\u006c\u0065\u006e\u0074\u0020\u0076\u0061\u006c\u0075\u0065\u0073\u002e"));
};}else if _ ,_bdge :=_ddgbe .GetMediaManagement ();_bdge {_egde =append (_egde ,_cgc ("\u0036.\u0037\u002e\u0033\u002d\u0031","\u0049\u0066\u0020\u005b\u0061\u0020\u0064\u006fc\u0075\u006d\u0065\u006e\u0074\u0020\u0069\u006e\u0066o\u0072\u006d\u0061t\u0069\u006f\u006e\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0061\u0070p\u0065\u0061r\u0073\u0020\u0069n\u0020\u0061 \u0064\u006f\u0063um\u0065\u006e\u0074\u005d\u002c\u0020\u0074\u0068\u0065n\u0020\u0061\u006c\u006c\u0020\u006f\u0066\u0020\u0069\u0074\u0073\u0020\u0065\u006e\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0068\u0061\u0076\u0065\u0020\u0061\u006e\u0061\u006c\u006f\u0067\u006fu\u0073\u0020\u0070\u0072\u006f\u0070\u0065\u0072\u0074\u0069\u0065\u0073 \u0069\u006e\u0020\u0070\u0072\u0065\u0064e\u0066\u0069\u006e\u0065\u0064\u0020\u0058\u004d\u0050\u0020\u0073\u0063\u0068\u0065\u006d\u0061\u0073\u0020\u2026 \u0073\u0068\u0061\u006c\u006c\u0020\u0061\u006c\u0073\u006f\u0020\u0062\u0065\u0020\u0065\u006d\u0062\u0065\u0064\u0064\u0065d\u0020\u0069\u006e\u0020\u0074he\u0020\u0066i\u006c\u0065 \u0069\u006e\u0020\u0058\u004d\u0050\u0020\u0066\u006f\u0072\u006d\u0020\u0077\u0069\u0074\u0068\u0020\u0065\u0071\u0075\u0069\u0076\u0061\u006c\u0065\u006e\u0074\u0020\u0076\u0061\u006c\u0075\u0065\u0073\u002e"));
};_ccee ,_cdac :=_ddgbe .GetPdfAID ();if !_cdac {_egde =append (_egde ,_cgc ("\u0036\u002e\u0037\u002e\u0031\u0031\u002d\u0031","\u0054\u0068\u0065\u0020\u0050\u0044\u0046\u002f\u0041\u0020\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020\u0061n\u0064\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006ec\u0065\u0020\u006c\u0065\u0076\u0065l\u0020\u006f\u0066\u0020\u0061\u0020\u0066\u0069\u006c\u0065\u0020\u0073h\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0073\u0070e\u0063\u0069\u0066\u0069\u0065\u0064\u0020\u0075\u0073\u0069\u006e\u0067\u0020\u0074\u0068\u0065\u0020\u0050\u0044\u0046\u002f\u0041\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0066\u0069\u0063\u0061\u0074\u0069\u006f\u006e\u0020\u0065\u0078\u0074\u0065\u006e\u0073\u0069\u006f\u006e\u0020\u0073\u0063h\u0065\u006da."));
}else {if _ccee .Part !=_ecab ._ecg {_egde =append (_egde ,_cgc ("\u0036\u002e\u0037\u002e\u0031\u0031\u002d\u0032","\u0054h\u0065\u0020\u0076\u0061lue\u0020\u006f\u0066\u0020p\u0064\u0066\u0061\u0069\u0064\u003a\u0070\u0061\u0072\u0074 \u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0074\u0068\u0065\u0020\u0070\u0061\u0072\u0074\u0020\u006e\u0075\u006d\u0062\u0065r\u0020\u006f\u0066\u0020\u0049\u0053\u004f\u002019\u0030\u0030\u0035 \u0074\u006f\u0020\u0077\u0068i\u0063h\u0020\u0074\u0068\u0065\u0020\u0066\u0069\u006c\u0065 \u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0073\u002e"));
};if _ecab ._bc =="\u0041"&&_ccee .Conformance !="\u0041"{_egde =append (_egde ,_cgc ("\u0036\u002e\u0037\u002e\u0031\u0031\u002d\u0033","\u0041\u0020\u004c\u0065\u0076e\u006c\u0020\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065 \u0073\u0068\u0061\u006c\u006c\u0020s\u0070\u0065\u0063i\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069\u0064\u003a\u0063o\u006e\u0066\u006fr\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0041\u002e\u0020\u0041\u0020\u004c\u0065\u0076e\u006c\u0020\u0042\u0020\u0063\u006f\u006e\u0066o\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0073\u0070e\u0063\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069d\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0042\u002e"));
}else if _ecab ._bc =="\u0042"&&(_ccee .Conformance !="\u0041"&&_ccee .Conformance !="\u0042"){_egde =append (_egde ,_cgc ("\u0036\u002e\u0037\u002e\u0031\u0031\u002d\u0033","\u0041\u0020\u004c\u0065\u0076e\u006c\u0020\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065 \u0073\u0068\u0061\u006c\u006c\u0020s\u0070\u0065\u0063i\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069\u0064\u003a\u0063o\u006e\u0066\u006fr\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0041\u002e\u0020\u0041\u0020\u004c\u0065\u0076e\u006c\u0020\u0042\u0020\u0063\u006f\u006e\u0066o\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0073\u0070e\u0063\u0069\u0066\u0079\u0020\u0074\u0068\u0065\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0070\u0064\u0066\u0061\u0069d\u003a\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0063\u0065\u0020\u0061\u0073\u0020\u0042\u002e"));
};};return _egde ;};func _ddga (_aadc *_bf .PdfFont ,_fcf *_dd .PdfObjectDictionary )ViolatedRule {const (_faab ="\u0036.\u0033\u002e\u0035\u002d\u0032";_cafg ="\u0046\u006f\u0072\u0020\u0061l\u006c\u0020\u0054\u0079\u0070\u0065\u0020\u0031\u0020\u0066\u006f\u006e\u0074 \u0073\u0075bs\u0065\u0074\u0073 \u0072\u0065\u0066e\u0072\u0065\u006e\u0063\u0065\u0064\u0020\u0077\u0069\u0074\u0068\u0069\u006e\u0020\u0061\u0020\u0063\u006fn\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u002c\u0020\u0074he\u0020f\u006f\u006e\u0074\u0020\u0064\u0065s\u0063r\u0069\u0070\u0074o\u0072\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0069\u006ec\u006c\u0075\u0064e\u0020\u0061\u0020\u0043\u0068\u0061\u0072\u0053\u0065\u0074\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0020\u006c\u0069\u0073\u0074\u0069\u006e\u0067\u0020\u0074\u0068\u0065\u0020\u0063\u0068\u0061\u0072a\u0063\u0074\u0065\u0072 \u006e\u0061\u006d\u0065\u0073\u0020d\u0065\u0066i\u006e\u0065\u0064\u0020i\u006e\u0020\u0074\u0068\u0065\u0020f\u006f\u006e\u0074\u0020s\u0075\u0062\u0073\u0065\u0074, \u0061\u0073 \u0064\u0065s\u0063\u0072\u0069\u0062\u0065\u0064\u0020\u0069\u006e \u0050\u0044\u0046\u0020\u0052e\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0054\u0061\u0062\u006ce\u0020\u0035\u002e1\u0038\u002e";
);var _bgfd string ;if _cecb ,_befe :=_dd .GetName (_fcf .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_befe {_bgfd =_cecb .String ();};if _bgfd !="\u0054\u0079\u0070e\u0031"{return _cf ;};if _dcb .IsStdFont (_dcb .StdFontName (_aadc .BaseFont ())){return _cf ;
};_dfabc :=_aadc .FontDescriptor ();if _dfabc .CharSet ==nil {return _cgc (_faab ,_cafg );};return _cf ;};func _bbc (_afdb ,_caeg ,_gggfb ,_afb string )(string ,bool ){_cgcgf :=_af .Index (_afdb ,_caeg );if _cgcgf ==-1{return "",false ;};_dddc :=_af .Index (_afdb ,_gggfb );
if _dddc ==-1{return "",false ;};if _dddc < _cgcgf {return "",false ;};return _afdb [:_cgcgf ]+_caeg +_afb +_afdb [_dddc :],true ;};func _fegcg (_agff *_bf .CompliancePdfReader )(_bbd []ViolatedRule ){_bbbe ,_abed :=_eecg (_agff );if !_abed {return _bbd ;
};_bdf :=_cgc ("\u0036.\u0032\u002e\u0032\u002d\u0031","\u0041\u0020\u0050\u0044\u0046\u002f\u0041\u002d\u0031\u0020\u004f\u0075\u0074p\u0075\u0074\u0049\u006e\u0074e\u006e\u0074\u0020\u0069\u0073\u0020a\u006e \u004f\u0075\u0074\u0070\u0075\u0074\u0049n\u0074\u0065\u006e\u0074\u0020\u0064i\u0063\u0074\u0069\u006fn\u0061\u0072\u0079\u002c\u0020\u0061\u0073\u0020\u0064\u0065\u0066\u0069\u006e\u0065\u0064\u0020\u0062y\u0020\u0050\u0044F\u0020\u0052\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065 \u0039\u002e\u0031\u0030.4\u002c\u0020\u0074\u0068\u0061\u0074\u0020\u0069\u0073 \u0069\u006e\u0063\u006c\u0075\u0064e\u0064\u0020i\u006e\u0020\u0074\u0068\u0065\u0020\u0066\u0069\u006c\u0065\u0027\u0073\u0020O\u0075\u0074p\u0075\u0074I\u006e\u0074\u0065\u006e\u0074\u0073\u0020\u0061\u0072\u0072\u0061\u0079\u0020a\u006e\u0064\u0020h\u0061\u0073\u0020\u0047\u0054\u0053\u005f\u0050\u0044\u0046\u0041\u0031\u0020\u0061\u0073 \u0074\u0068\u0065\u0020\u0076a\u006c\u0075e\u0020\u006f\u0066\u0020i\u0074\u0073 \u0053\u0020\u006b\u0065\u0079\u0020\u0061\u006e\u0064\u0020\u0061\u0020\u0076\u0061\u006c\u0069\u0064\u0020I\u0043\u0043\u0020\u0070\u0072\u006f\u0066\u0069\u006ce\u0020s\u0074\u0072\u0065\u0061\u006d \u0061\u0073\u0020\u0074h\u0065\u0020\u0076a\u006c\u0075\u0065\u0020\u0069\u0074\u0073\u0020\u0044\u0065\u0073t\u004f\u0075t\u0070\u0075\u0074P\u0072\u006f\u0066\u0069\u006c\u0065 \u006b\u0065\u0079\u002e");
_gdff ,_abed :=_dd .GetArray (_bbbe .Get ("\u004f\u0075\u0074\u0070\u0075\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073"));if !_abed {_bbd =append (_bbd ,_bdf );return _bbd ;};_fcce :=_cgc ("\u0036.\u0032\u002e\u0032\u002d\u0032","\u0049\u0066\u0020\u0061\u0020\u0066\u0069\u006c\u0065's\u0020O\u0075\u0074\u0070u\u0074\u0049\u006e\u0074\u0065\u006e\u0074\u0073 \u0061\u0072\u0072a\u0079\u0020\u0063\u006f\u006e\u0074\u0061\u0069n\u0073\u0020\u006d\u006f\u0072\u0065\u0020\u0074\u0068a\u006e\u0020\u006f\u006ee\u0020\u0065\u006e\u0074\u0072\u0079\u002c\u0020\u0074\u0068\u0065\u006e\u0020\u0061\u006c\u006c\u0020\u0065n\u0074\u0072\u0069\u0065\u0073\u0020\u0074\u0068\u0061\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e a \u0044\u0065\u0073\u0074\u004f\u0075\u0074\u0070\u0075\u0074\u0050\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u006b\u0065y\u0020\u0073\u0068\u0061\u006cl\u0020\u0068\u0061\u0076\u0065 \u0061\u0073\u0020\u0074\u0068\u0065 \u0076\u0061\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068a\u0074\u0020\u006b\u0065\u0079 \u0074\u0068\u0065\u0020\u0073\u0061\u006d\u0065\u0020\u0069\u006e\u0064\u0069\u0072\u0065c\u0074\u0020\u006fb\u006ae\u0063t\u002c\u0020\u0077h\u0069\u0063\u0068\u0020\u0073\u0068\u0061\u006c\u006c \u0062\u0065\u0020\u0061\u0020\u0076\u0061\u006c\u0069d\u0020\u0049\u0043\u0043\u0020\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0073\u0074r\u0065\u0061m\u002e");
if _gdff .Len ()> 1{_gfdd :=map[*_dd .PdfObjectDictionary ]struct{}{};for _ggge :=0;_ggge < _gdff .Len ();_ggge ++{_dgbc ,_dacc :=_dd .GetDict (_gdff .Get (_ggge ));if !_dacc {_bbd =append (_bbd ,_bdf );return _bbd ;};if _ggge ==0{_gfdd [_dgbc ]=struct{}{};
continue ;};if _ ,_dfb :=_gfdd [_dgbc ];!_dfb {_bbd =append (_bbd ,_fcce );break ;};};}else if _gdff .Len ()==0{_bbd =append (_bbd ,_bdf );return _bbd ;};_bbaf ,_abed :=_dd .GetDict (_gdff .Get (0));if !_abed {_bbd =append (_bbd ,_bdf );return _bbd ;};
if _dccf ,_cgdd :=_dd .GetName (_bbaf .Get ("\u0053"));!_cgdd ||(*_dccf )!="\u0047T\u0053\u005f\u0050\u0044\u0046\u00411"{_bbd =append (_bbd ,_bdf );return _bbd ;};_abfd ,_acafgb :=_bf .NewPdfOutputIntentFromPdfObject (_bbaf );if _acafgb !=nil {_ee .Log .Debug ("\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u006f\u0075\u0074\u0070\u0075\u0074\u0020i\u006et\u0065\u006e\u0074\u0020\u0066\u0061\u0069\u006c\u0065\u0064\u003a\u0020\u0025\u0076",_acafgb );
return _bbd ;};_bace ,_acafgb :=_egg .ParseHeader (_abfd .DestOutputProfile );if _acafgb !=nil {_ee .Log .Debug ("\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0063\u006f\u006c\u006f\u0072\u0070\u0072\u006f\u0066\u0069\u006c\u0065\u0020\u0068\u0065\u0061d\u0065\u0072\u0020\u0066\u0061i\u006c\u0065d\u003a\u0020\u0025\u0076",_acafgb );
return _bbd ;};if (_bace .DeviceClass ==_egg .DeviceClassPRTR ||_bace .DeviceClass ==_egg .DeviceClassMNTR )&&(_bace .ColorSpace ==_egg .ColorSpaceRGB ||_bace .ColorSpace ==_egg .ColorSpaceCMYK ||_bace .ColorSpace ==_egg .ColorSpaceGRAY ){return _bbd ;
};_bbd =append (_bbd ,_bdf );return _bbd ;};

// Error implements error interface.
func (_ff VerificationError )Error ()string {_g :=_af .Builder {};_g .WriteString ("\u0053\u0074\u0061\u006e\u0064\u0061\u0072\u0064\u003a\u0020");_g .WriteString (_a .Sprintf ("\u0050\u0044\u0046\u002f\u0041\u002d\u0025\u0064\u0025\u0073",_ff .ConformanceLevel ,_ff .ConformanceVariant ));
_g .WriteString ("\u0020\u0056\u0069\u006f\u006c\u0061\u0074\u0065\u0064\u0020\u0072\u0075l\u0065\u0073\u003a\u0020");for _gd ,_gc :=range _ff .ViolatedRules {_g .WriteString (_gc .String ());if _gd !=len (_ff .ViolatedRules )-1{_g .WriteRune ('\n');};
};return _g .String ();};func _dcd (_aege *_dc .Document )error {_adg ,_cdag :=_aege .FindCatalog ();if !_cdag {return _fc .New ("\u0063\u0061\u0074\u0061\u006c\u006f\u0067\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};_adg .SetVersion ();
return nil ;};func _bdef (_cabc *_bf .CompliancePdfReader )(_bgd []ViolatedRule ){_egec :=_cabc .ParserMetadata ();if _egec .HasInvalidSubsectionHeader (){_bgd =append (_bgd ,_cgc ("\u0036.\u0031\u002e\u0034\u002d\u0031","\u006e\u0020\u0061\u0020\u0063\u0072\u006f\u0073\u0073\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0073\u0075\u0062\u0073\u0065c\u0074\u0069\u006f\u006e\u0020h\u0065a\u0064\u0065\u0072\u0020t\u0068\u0065\u0020\u0073\u0074\u0061\u0072t\u0069\u006e\u0067\u0020\u006fb\u006a\u0065\u0063\u0074 \u006e\u0075\u006d\u0062\u0065\u0072\u0020\u0061\u006e\u0064\u0020\u0074\u0068\u0065\u0020\u0072\u0061n\u0067e\u0020s\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0073\u0065\u0070\u0061\u0072\u0061\u0074\u0065\u0064\u0020\u0062\u0079\u0020\u0061\u0020s\u0069\u006e\u0067\u006c\u0065\u0020\u0053\u0050\u0041C\u0045\u0020\u0063\u0068\u0061\u0072\u0061\u0063\u0074e\u0072\u0020\u0028\u0032\u0030\u0068\u0029\u002e"));
};if _egec .HasInvalidSeparationAfterXRef (){_bgd =append (_bgd ,_cgc ("\u0036.\u0031\u002e\u0034\u002d\u0032","\u0054\u0068\u0065 \u0078\u0072\u0065\u0066\u0020\u006b\u0065\u0079\u0077\u006fr\u0064\u0020\u0061\u006e\u0064\u0020\u0074\u0068\u0065\u0020\u0063\u0072\u006f\u0073s\u0020\u0072\u0065\u0066e\u0072\u0065\u006e\u0063\u0065 s\u0075b\u0073\u0065\u0063ti\u006f\u006e\u0020\u0068\u0065\u0061\u0064e\u0072\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0073\u0065\u0070\u0061\u0072\u0061\u0074\u0065\u0064\u0020\u0062\u0079 \u0061\u0020\u0073i\u006e\u0067\u006c\u0065\u0020\u0045\u004fL\u0020\u006d\u0061\u0072\u006b\u0065\u0072\u002e"));
};return _bgd ;};func _edffc (_aacdf *Profile1Options ){if _aacdf .Now ==nil {_aacdf .Now =_aa .Now ;};};

// Part gets the PDF/A version level.
func (_gabd *profile1 )Part ()int {return _gabd ._gbff ._ecg };var _ Profile =(*Profile1A )(nil );func _fac (_dea bool ,_agc standardType )(pageColorspaceOptimizeFunc ,documentColorspaceOptimizeFunc ){var _gcd ,_agf ,_agg bool ;_bfc :=func (_caa *_dc .Document ,_bb *_dc .Page ,_afg []*_dc .Image )error {for _ ,_bec :=range _afg {switch _bec .Colorspace {case "\u0044\u0065\u0076\u0069\u0063\u0065\u0047\u0072\u0061\u0079":_agf =true ;
case "\u0044e\u0076\u0069\u0063\u0065\u0052\u0047B":_gcd =true ;case "\u0044\u0065\u0076\u0069\u0063\u0065\u0043\u004d\u0059\u004b":_agg =true ;};};_cff ,_adc :=_bb .GetContents ();if !_adc {return nil ;};for _ ,_ffa :=range _cff {_efb ,_eeb :=_ffa .GetData ();
if _eeb !=nil {continue ;};_gcec :=_bd .NewContentStreamParser (string (_efb ));_ggac ,_eeb :=_gcec .Parse ();if _eeb !=nil {continue ;};for _ ,_ecgf :=range *_ggac {switch _ecgf .Operand {case "\u0047","\u0067":_agf =true ;case "\u0052\u0047","\u0072\u0067":_gcd =true ;
case "\u004b","\u006b":_agg =true ;case "\u0043\u0053","\u0063\u0073":if len (_ecgf .Params )==0{continue ;};_eede ,_cbfg :=_dd .GetName (_ecgf .Params [0]);if !_cbfg {continue ;};switch _eede .String (){case "\u0052\u0047\u0042","\u0044e\u0076\u0069\u0063\u0065\u0052\u0047B":_gcd =true ;
case "\u0047","\u0044\u0065\u0076\u0069\u0063\u0065\u0047\u0072\u0061\u0079":_agf =true ;case "\u0043\u004d\u0059\u004b","\u0044\u0065\u0076\u0069\u0063\u0065\u0043\u004d\u0059\u004b":_agg =true ;};};};};_ggf :=_bb .FindXObjectForms ();for _ ,_ceab :=range _ggf {_eee :=_bd .NewContentStreamParser (string (_ceab .Stream ));
_cac ,_egc :=_eee .Parse ();if _egc !=nil {continue ;};for _ ,_afc :=range *_cac {switch _afc .Operand {case "\u0047","\u0067":_agf =true ;case "\u0052\u0047","\u0072\u0067":_gcd =true ;case "\u004b","\u006b":_agg =true ;case "\u0043\u0053","\u0063\u0073":if len (_afc .Params )==0{continue ;
};_adbd ,_adef :=_dd .GetName (_afc .Params [0]);if !_adef {continue ;};switch _adbd .String (){case "\u0052\u0047\u0042","\u0044e\u0076\u0069\u0063\u0065\u0052\u0047B":_gcd =true ;case "\u0047","\u0044\u0065\u0076\u0069\u0063\u0065\u0047\u0072\u0061\u0079":_agf =true ;
case "\u0043\u004d\u0059\u004b","\u0044\u0065\u0076\u0069\u0063\u0065\u0043\u004d\u0059\u004b":_agg =true ;};};};};return nil ;};_eec :=func (_fag *_dc .Document ,_fcba []*_dc .Image )error {_aaea ,_edff :=_fag .FindCatalog ();if !_edff {return nil ;};
_gaf ,_edff :=_aaea .GetOutputIntents ();if _edff &&_gaf .Len ()> 0{return nil ;};if !_edff {_gaf =_aaea .NewOutputIntents ();};if !(_gcd ||_agg ||_agf ){return nil ;};defer _aaea .SetOutputIntents (_gaf );if _gcd &&!_agg &&!_agf {return _cfeg (_fag ,_agc ,_gaf );
};if _agg &&!_gcd &&!_agf {return _edd (_agc ,_gaf );};if _agf &&!_gcd &&!_agg {return _effe (_agc ,_gaf );};if _gcd &&_agg {if _ffb :=_dgfd (_fcba ,_dea );_ffb !=nil {return _ffb ;};if _ded :=_bga (_fag ,_dea );_ded !=nil {return _ded ;};if _ced :=_cgde (_fag ,_dea );
_ced !=nil {return _ced ;};if _dea {return _edd (_agc ,_gaf );};return _cfeg (_fag ,_agc ,_gaf );};return nil ;};return _bfc ,_eec ;};func _gfddc (_aaaf *_dd .PdfObjectDictionary ,_ccf map[*_dd .PdfObjectStream ][]byte ,_gcbc map[*_dd .PdfObjectStream ]*_cc .CMap )ViolatedRule {const (_dfdag ="\u0046\u006f\u0072 \u0061\u006e\u0079\u0020\u0067\u0069\u0076\u0065\u006e\u0020\u0063\u006f\u006d\u0070\u006f\u0073\u0069\u0074\u0065\u0020\u0028\u0054\u0079\u0070\u0065\u0020\u0030\u0029\u0020\u0066\u006f\u006et \u0072\u0065\u0066\u0065\u0072\u0065\u006ec\u0065\u0064 \u0077\u0069\u0074\u0068\u0069\u006e\u0020\u0061\u0020\u0063\u006fn\u0066\u006fr\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u002c\u0020\u0074\u0068\u0065\u0020\u0043I\u0044\u0053y\u0073\u0074\u0065\u006d\u0049nf\u006f\u0020\u0065\u006e\u0074\u0072\u0069\u0065\u0073\u0020\u006f\u0066\u0020i\u0074\u0073\u0020\u0043\u0049\u0044\u0046\u006f\u006e\u0074\u0020\u0061\u006e\u0064 \u0043\u004d\u0061\u0070 \u0064\u0069\u0063\u0074i\u006f\u006e\u0061\u0072\u0069\u0065\u0073\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0063\u006f\u006d\u0070\u0061\u0074i\u0062\u006c\u0065\u002e\u0020\u0049\u006e\u0020o\u0074\u0068\u0065\u0072\u0020\u0077\u006f\u0072\u0064\u0073\u002c\u0020\u0074\u0068\u0065\u0020R\u0065\u0067\u0069\u0073\u0074\u0072\u0079\u0020a\u006e\u0064\u0020\u004fr\u0064\u0065\u0072\u0069\u006e\u0067 \u0073\u0074\u0072i\u006e\u0067\u0073\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0043\u0049\u0044\u0053\u0079\u0073\u0074\u0065\u006d\u0049\u006e\u0066\u006f\u0020\u0064\u0069\u0063\u0074i\u006f\u006e\u0061\u0072\u0069\u0065\u0073\u0020\u0066\u006f\u0072 \u0074\u0068\u0061\u0074\u0020\u0066o\u006e\u0074\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u0062\u0065\u0020\u0069\u0064\u0065\u006e\u0074\u0069\u0063\u0061\u006c\u002c\u0020u\u006el\u0065ss \u0074\u0068\u0065\u0020\u0076a\u006c\u0075\u0065\u0020\u006f\u0066\u0020\u0074\u0068\u0065\u0020\u0045\u006e\u0063\u006f\u0064\u0069\u006eg\u0020\u006b\u0065\u0079\u0020\u0069\u006e\u0020\u0074h\u0065 \u0066\u006f\u006e\u0074\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0069\u0073 \u0049\u0064\u0065\u006e\u0074\u0069t\u0079\u002d\u0048\u0020o\u0072\u0020\u0049\u0064\u0065\u006e\u0074\u0069\u0074y\u002dV\u002e";
_eeag ="\u0036.\u0033\u002e\u0033\u002d\u0031";);var _fgdc string ;if _ecee ,_efcg :=_dd .GetName (_aaaf .Get ("\u0053u\u0062\u0074\u0079\u0070\u0065"));_efcg {_fgdc =_ecee .String ();};if _fgdc !="\u0054\u0079\u0070e\u0030"{return _cf ;};_deggd :=_aaaf .Get ("\u0045\u006e\u0063\u006f\u0064\u0069\u006e\u0067");
if _ceac ,_dbbc :=_dd .GetName (_deggd );_dbbc {switch _ceac .String (){case "\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0048","\u0049\u0064\u0065\u006e\u0074\u0069\u0074\u0079\u002d\u0056":return _cf ;};_bda ,_beebf :=_cc .LoadPredefinedCMap (_ceac .String ());
if _beebf !=nil {return _cgc (_eeag ,_dfdag );};_ffadg :=_bda .CIDSystemInfo ();if _ffadg .Ordering !=_ffadg .Registry {return _cgc (_eeag ,_dfdag );};return _cf ;};_bgbac ,_edg :=_dd .GetStream (_deggd );if !_edg {return _cgc (_eeag ,_dfdag );};_aacb ,_dggg :=_daadb (_bgbac ,_ccf ,_gcbc );
if _dggg !=nil {return _cgc (_eeag ,_dfdag );};_cbcf :=_aacb .CIDSystemInfo ();if _cbcf .Ordering !=_cbcf .Registry {return _cgc (_eeag ,_dfdag );};return _cf ;};

// ApplyStandard tries to change the content of the writer to match the PDF/A-1 standard.
// Implements model.StandardApplier.
func (_afff *profile1 )ApplyStandard (document *_dc .Document )(_caegd error ){_fgd (document ,4);if _caegd =_ada (document ,_afff ._dgba .Now );_caegd !=nil {return _caegd ;};if _caegd =_dcd (document );_caegd !=nil {return _caegd ;};_gffb ,_ggfc :=_fac (_afff ._dgba .CMYKDefaultColorSpace ,_afff ._gbff );
_caegd =_gbbc (document ,[]pageColorspaceOptimizeFunc {_cggga ,_gffb },[]documentColorspaceOptimizeFunc {_ggfc });if _caegd !=nil {return _caegd ;};_dced (document );if _caegd =_fcgc (document );_caegd !=nil {return _caegd ;};if _caegd =_egb (document );
_caegd !=nil {return _caegd ;};if _caegd =_aec (document );_caegd !=nil {return _caegd ;};if _afff ._gbff ._bc =="\u0041"{_cdb (document );};if _cebf :=_cdg (document ,_afff ._gbff ,_afff ._dgba .Xmp );_cebf !=nil {return _cebf ;};return nil ;};func _babab (_caef *_bf .CompliancePdfReader )(_egbg ViolatedRule ){for _ ,_bdgb :=range _caef .GetObjectNums (){_gggd ,_dfg :=_caef .GetIndirectObjectByNumber (_bdgb );
if _dfg !=nil {continue ;};_gafa ,_bdce :=_dd .GetStream (_gggd );if !_bdce {continue ;};_ecdc ,_bdce :=_dd .GetName (_gafa .Get ("\u0054\u0079\u0070\u0065"));if !_bdce {continue ;};if *_ecdc !="\u0058O\u0062\u006a\u0065\u0063\u0074"{continue ;};if _gafa .Get ("\u0052\u0065\u0066")!=nil {return _cgc ("\u0036.\u0032\u002e\u0036\u002d\u0031","\u0041\u0020\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0069\u006e\u0067\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0068a\u006c\u006c\u0020\u006e\u006f\u0074\u0020\u0063\u006f\u006e\u0074\u0061\u0069\u006e\u0020\u0061\u006e\u0079\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065\u0020\u0058O\u0062\u006a\u0065\u0063\u0074s\u002e");
};};return _egbg ;};func _daag (_bad *_bf .CompliancePdfReader )(_deebg ViolatedRule ){_fbge ,_fegdf :=_eecg (_bad );if !_fegdf {return _cf ;};if _fbge .Get ("\u0041\u0041")!=nil {return _cgc ("\u0036.\u0036\u002e\u0032\u002d\u0033","\u0054\u0068e\u0020\u0064\u006f\u0063\u0075\u006d\u0065n\u0074 \u0063\u0061\u0074a\u006c\u006f\u0067\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u0020\u0073\u0068\u0061\u006c\u006c\u0020\u006eo\u0074\u0020\u0069\u006e\u0063\u006c\u0075\u0064\u0065\u0020\u0061\u006e\u0020\u0041\u0041\u0020\u0065n\u0074r\u0079 \u0066\u006f\u0072 \u0061\u006e\u0020\u0061\u0064\u0064\u0069\u0074\u0069\u006f\u006e\u0061\u006c\u002d\u0061\u0063\u0074i\u006f\u006e\u0073\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079\u002e");
};return _cf ;};func _fbd (_adda *_bf .CompliancePdfReader )(_cgad []ViolatedRule ){var (_acab ,_ggd ,_bfce ,_gagb ,_cgcf ,_fgbe ,_egcb bool ;_gede func (_dd .PdfObject ););_gede =func (_fgfbd _dd .PdfObject ){switch _aaa :=_fgfbd .(type ){case *_dd .PdfObjectInteger :if !_acab &&(int64 (*_aaa )> _f .MaxInt32 ||int64 (*_aaa )< -_f .MaxInt32 ){_cgad =append (_cgad ,_cgc ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0031","L\u0061\u0072\u0067e\u0073\u0074\u0020\u0049\u006e\u0074\u0065\u0067\u0065\u0072\u0020\u0076\u0061\u006c\u0075\u0065\u0020\u0069\u0073\u0020\u0032\u002c\u0031\u0034\u0037,\u0034\u0038\u0033,\u0036\u0034\u0037\u002e\u0020\u0053\u006d\u0061\u006c\u006c\u0065\u0073\u0074 \u0069\u006e\u0074\u0065g\u0065\u0072\u0020\u0076a\u006c\u0075\u0065\u0020\u0069\u0073\u0020\u002d\u0032\u002c\u0031\u0034\u0037\u002c\u0034\u0038\u0033,\u0036\u0034\u0038\u002e"));
_acab =true ;};case *_dd .PdfObjectFloat :if !_ggd &&(_f .Abs (float64 (*_aaa ))> 32767.0){_cgad =append (_cgad ,_cgc ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0032","\u0041\u0062\u0073\u006f\u006c\u0075\u0074\u0065\u0020\u0072\u0065\u0061\u006c\u0020\u0076\u0061\u006c\u0075\u0065\u0020m\u0075\u0073\u0074\u0020\u0062\u0065\u0020\u006c\u0065s\u0073\u0020\u0074\u0068\u0061\u006e\u0020\u006f\u0072\u0020\u0065\u0071\u0075a\u006c\u0020\u0074\u006f\u0020\u00332\u0037\u0036\u0037.\u0030\u002e"));
};case *_dd .PdfObjectString :if !_bfce &&len ([]byte (_aaa .Str ()))> 65535{_cgad =append (_cgad ,_cgc ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0033","M\u0061\u0078\u0069\u006d\u0075\u006d\u0020\u006c\u0065n\u0067\u0074\u0068\u0020\u006f\u0066\u0020a \u0073\u0074\u0072\u0069n\u0067\u0020\u0028\u0069\u006e\u0020\u0062\u0079\u0074es\u0029\u0020i\u0073\u0020\u0036\u0035\u0035\u0033\u0035\u002e"));
_bfce =true ;};case *_dd .PdfObjectName :if !_gagb &&len ([]byte (*_aaa ))> 127{_cgad =append (_cgad ,_cgc ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0034","\u004d\u0061\u0078\u0069\u006d\u0075\u006d \u006c\u0065\u006eg\u0074\u0068\u0020\u006ff\u0020\u0061\u0020\u006e\u0061\u006d\u0065\u0020\u0028\u0069\u006e\u0020\u0062\u0079\u0074\u0065\u0073\u0029\u0020\u0069\u0073\u0020\u0031\u0032\u0037\u002e"));
_gagb =true ;};case *_dd .PdfObjectArray :if !_cgcf &&_aaa .Len ()> 8191{_cgad =append (_cgad ,_cgc ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0035","\u004d\u0061\u0078\u0069\u006d\u0075m\u0020\u006c\u0065\u006e\u0067\u0074\u0068\u0020\u006f\u0066\u0020\u0061\u006e\u0020\u0061\u0072\u0072\u0061\u0079\u0020(\u0069\u006e\u0020\u0065\u006c\u0065\u006d\u0065\u006e\u0074\u0073\u0029\u0020\u0069s\u00208\u0031\u0039\u0031\u002e"));
_cgcf =true ;};for _ ,_ecdb :=range _aaa .Elements (){_gede (_ecdb );};if !_egcb &&(_aaa .Len ()==4||_aaa .Len ()==5){_gfd ,_afbb :=_dd .GetName (_aaa .Get (0));if !_afbb {return ;};if *_gfd !="\u0044e\u0076\u0069\u0063\u0065\u004e"{return ;};_affd :=_aaa .Get (1);
_affd =_dd .TraceToDirectObject (_affd );_beab ,_afbb :=_dd .GetArray (_affd );if !_afbb {return ;};if _beab .Len ()> 8{_cgad =append (_cgad ,_cgc ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0039","\u004d\u0061\u0078i\u006d\u0075\u006d\u0020\u006e\u0075\u006d\u0062\u0065\u0072\u0020\u006f\u0066\u0020\u0044\u0065\u0076\u0069\u0063\u0065\u004e\u0020\u0063\u006f\u006d\u0070\u006f\u006e\u0065n\u0074\u0073\u0020\u0069\u0073\u0020\u0038\u002e"));
_egcb =true ;};};case *_dd .PdfObjectDictionary :_eeegc :=_aaa .Keys ();if !_fgbe &&len (_eeegc )> 4095{_cgad =append (_cgad ,_cgc ("\u0036.\u0031\u002e\u0031\u0032\u002d\u00311","\u004d\u0061\u0078\u0069\u006d\u0075\u006d\u0020\u0063\u0061\u0070\u0061\u0063\u0069\u0074y\u0020\u006f\u0066\u0020\u0061\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006ea\u0072\u0079\u0020\u0028\u0069\u006e\u0020\u0065\u006e\u0074\u0072\u0069es\u0029\u0020\u0069\u0073\u0020\u0034\u0030\u0039\u0035\u002e"));
_fgbe =true ;};for _bgdc ,_cfba :=range _eeegc {_gede (&_eeegc [_bgdc ]);_gede (_aaa .Get (_cfba ));};case *_dd .PdfObjectStream :_gede (_aaa .PdfObjectDictionary );case *_dd .PdfObjectStreams :for _ ,_ecde :=range _aaa .Elements (){_gede (_ecde );};case *_dd .PdfObjectReference :_gede (_aaa .Resolve ());
};};_ecdeb :=_adda .GetObjectNums ();if len (_ecdeb )> 8388607{_cgad =append (_cgad ,_cgc ("\u0036\u002e\u0031\u002e\u0031\u0032\u002d\u0037","\u004d\u0061\u0078\u0069\u006d\u0075\u006d\u0020\u006e\u0075\u006d\u0062\u0065\u0072\u0020\u006f\u0066\u0020in\u0064i\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0073 \u0069\u006e\u0020\u0061\u0020\u0050\u0044\u0046\u0020\u0066\u0069\u006c\u0065\u0020\u0069\u0073\u00208\u002c\u0033\u0038\u0038\u002c\u0036\u0030\u0037\u002e"));
};for _ ,_fcaec :=range _ecdeb {_cggb ,_gdgf :=_adda .GetIndirectObjectByNumber (_fcaec );if _gdgf !=nil {continue ;};_caca :=_dd .TraceToDirectObject (_cggb );_gede (_caca );};return _cgad ;};